; QSnap Basic extension, reverse engineered by Marcel Kilgus

	section qsnap2

	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_qlv'
	include 'dev8_keys_sys'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_chn'
	include 'dev8_keys_con'
	include 'dev8_keys_qlhw'
	include 'dev8_keys_thg'
	include 'dev8_mac_proc'
	include 'dev8_mac_config'

qsnap2_init
	move.w	sb.inipr,a0
	lea	qsnap2_procs,a1
	jsr	(a0)
	rts

qsnap2_procs
	proc_stt
	proc_end
	proc_stt
	proc_ref RMODE
	proc_ref THING
	proc_ref KEYW
	proc_ref INT%,int
	proc_ref FLOAT
	proc_ref CLIP%,clip
	proc_ref CLIP$
	proc_ref C_STRG$
	proc_ref C_CHAR$
	proc_ref C_CODE
	proc_ref C_BYTE
	proc_ref C_WORD
	proc_end

; c = CLIP%(#ch)
clip
	moveq	#-1,d7
	bra.s	clip_all

; c$ = CLIP$(#ch)
clip$
	moveq	#0,d7
clip_all
	movea.w sb.gtlin,a2
	jsr	(a2)
	bne.s	clip_ret
	subq.w	#1,d3		; One parameter
	bne.s	clip_ipar
	move.l	(a1,a6.l),d0
	addq.l	#2,a1
	move.l	a1,sb_arthp(a6) ; arithmetic stack pointer
	mulu.w	#ch.len,d0
	add.l	sb_chanb(a6),d0 ; channel table base
	cmp.l	sb_chanp(a6),d0 ; channel table pointer
	bge.s	clip_ichn
	move.l	(a6,d0.l),d0
	bmi.s	clip_ichn
	movea.l d0,a0
	lea	xtop_clip(pc),a2
	moveq	#0,d3
	lea	-10(sp),sp
	movea.l sp,a1
	moveq	#iow.xtop,d0	; eXTernal OPeration on screen
	trap	#3
	lea	10(sp),sp
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	tst.l	d0
	bpl.s	clip_check_mode
	move.l	d0,d1
	moveq	#0,d0

clip_check_mode
	tst.l	d7
	bmi.s	clip_ret_int
	tst.w	d1
	bmi.s	clip_ret_empty_str
	move.b	d1,(a1,a6.l)	; Return the char
	subq.l	#2,a1
	move.l	a1,sb_arthp(a6) ; arithmetic stack pointer
	move.w	#1,(a1,a6.l)	; One char string
	bra.s	clip_ret_str

clip_ret_empty_str
	clr.w	(a1,a6.l)

clip_ret_str
	moveq	#nt.st,d4
	rts

clip_ret_int
	move.w	d1,(a1,a6.l)
	moveq	#nt.in,d4
	rts

clip_ichn
	moveq	#err.ichn,d0	; Invalid CHaNnel id
clip_ret
	rts

clip_ipar
	moveq	#err.ipar,d0	; Invalid PARameter (c.f. err.orng)
	rts

clip_orng
	moveq	#err.orng,d0	; Out of range
	rts

; XTOP routine
xtop_clip
	moveq	#ch.len,d0
	cmp.l	chn_len(a0),d0
	beq.s	clip_ipar
	move.l	ch_width(a0),d0 ; width in characters
	bmi.s	clip_orng	; Out of range
	tst.w	d0
	bmi.s	clip_orng	; Out of range
	add.l	sd_xinc(a0),d0	; cursor pixel width
	cmp.w	sd_ysize(a0),d0 ; window height, exclusive of border
	bhi.s	clip_orng	; Out of range
	swap	d0
	cmp.w	sd_xsize(a0),d0 ; window width, exclusive of border
	bhi.s	clip_orng	; Out of range
	move.w	sd_xpos(a0),d1	; cursor position relative to left pixel above
	add.w	sd_xmin(a0),d1	; window left pixel, exclusive of border
	move.w	sd_ypos(a0),d2	; cursor position relative to top pixel above
	add.w	sd_ymin(a0),d2	; window top pixel, exclusive of border
	movea.l sd_scrb(a0),a2	; base address of screen
	lsl.w	#7,d2		; *128
	adda.w	d2,a2		; Line address
	move.w	#$8080,d7	; 4 colour mask
	btst	#mc..m8,sys_qlmr(a6) ; QL Master chip Register value
	beq.s	clip_mode4
	bclr	#0,d1		; Make sure even x ordinate
	btst	#2,sys_qlmr(a6) ; Test for Thor MODE 12
	beq.s	clip_mode8
	move.w	#$C0C0,d7	; 16 colour mask
clip_mode8
	move.b	#$C0,d7 	; 8 colour mask (exclude blink bit)
clip_mode4
	movea.w sd_linel(a0),a5 ; line length in bytes
	btst	#4,sd_cattr(a0) ; Double height characters?
	beq.s	clip_check_width
	adda.l	a5,a5		; Double height

clip_check_width
	moveq	#1,d5
	btst	#6,sd_cattr(a0) ; Double width characters?
	beq.s	clip_calc_addr
	moveq	#2,d5		; Double width

clip_calc_addr
	movea.l d1,a3		; Backup x ordinate
	moveq	#7,d2		; 8 pixels per word
	and.w	d1,d2		; Shift within word
	lsr.w	#3,d1		; Word index
	add.w	d1,d1		; Byte index
	move.w	(a2,d1.w),d4	; Colour word
	lsl.w	d2,d4		; Shift bits into place
	and.w	d7,d4		; Mask them
	movea.l d4,a4		; a4 = our background colour now
	moveq	#8,d2		; 9 lines

clip_read_lines_loop
	adda.l	a5,a2		; Next line
	move.w	a3,d1		; Restore x ordinate
	moveq	#0,d6
	moveq	#5,d3		; 6 pixels

clip_read_pixels_loop
	moveq	#7,d4		; 8 pixels per word
	and.w	d1,d4		; Shift within word
	move.w	d1,d0
	lsr.w	#3,d0		; Word index
	add.w	d0,d0		; Byte index
	move.w	(a2,d0.w),d0	; Colour word
	lsl.w	d4,d0		; Shift bits into place
	and.w	d7,d0		; Mask them
	cmp.w	a4,d0
	beq.s	clip_next_pixel ; Was just background
	addq.w	#2,d6		; Other than background -> add bit

clip_next_pixel
	add.w	d6,d6		; d6 <<= 1
	add.w	d5,d1		; x += pixel width
	dbf	d3,clip_read_pixels_loop
	move.b	d6,(a1)+	; Recognised bit pattern
	dbf	d2,clip_read_lines_loop
	lea	-9(a1),a1	; Reset to start
	moveq	#0,d1
	move.b	(a1)+,d4	; First line must look like this
	movea.l sd_font(a0),a2	; font addresses, primary first. default char in secondary
	bsr.s	check_font	; d4 = 1st pattern, a1 = pattern (2nd index), a2 = font address. Return char in d1 if found (Z flag set)
	beq.s	clip_ok
	movea.l sd_font+4(a0),a2 ; Secondary font
	bsr.s	check_font	; d4 = 1st pattern, a1 = pattern (2nd index), a2 = font address. Return char in d1 if found (Z flag set)
	beq.s	clip_ok
	moveq	#err.fdnf,d1	; File or Device Not Found
clip_ok
	moveq	#0,d0
	rts

; d4 = 1st pattern, a1 = pattern (2nd index), a2 = font address. Return char in d1 if found (Z flag set)
check_font
	move.b	(a2)+,d1	; Min font char
	moveq	#0,d0
	move.b	(a2)+,d0	; Max font char

check_loop
	cmp.b	(a2)+,d4	; Check first pixel line
	bne.s	check_next_char
	moveq	#5,d2		; Compare next 6 lines
	movea.l a1,a3
	movea.l a2,a4

check_char_loop
	cmpm.b	(a4)+,(a3)+
	dbne	d2,check_char_loop
	beq.s	check_last_lines

check_next_char
	addq.l	#8,a2		; Advance to next char
	addq.b	#1,d1		; Char index
	dbf	d0,check_loop
	moveq	#err.fdnf,d0	; File or Device Not Found
	rts

check_last_lines:			
	btst	#0,sd_cattr(a0) ; Underline?
	bne.s	check_skip_line ; Only compare 8 lines then
	move.b	(a4),d2
	cmp.b	(a3),d2
	bne.s	check_next_char

check_skip_line:			
	move.b	1(a4),d2
	cmp.b	1(a3),d2
	bne.s	check_next_char
	rts


float_int_ipar
	moveq	#err.ipar,d0	; Invalid PARameter (c.f. err.orng)
float_int_ret
	rts

; f = FLOAT(s$). Return 1E-615 on error
float
	moveq	#0,d5
	bra.s	float_int

; i = INT(s$). Return -32768 on error
int
	moveq	#1,d5
float_int
	movea.l sb_arthp(a6),a4 ; arithmetic stack pointer
	movea.w sb.gtstr,a0
	jsr	(a0)
	bne.s	float_int_ret
	subq.w	#1,d3		; Exactly one string
	bne.s	float_int_ipar
	movea.l a1,a0
	adda.w	(a1,a6.l),a0	; Add length of string
	addq.l	#2,a0		; Plus length word
	move.l	a0,d7		; Why???
	lea	2(a1),a0	; Skip length word
	tst.w	d5
	beq.s	do_float
	moveq	#2,d1		; Ensure 2 bytes on stack
	suba.l	d1,a4
	movea.w qa.resri,a2
	jsr	(a2)
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	movea.w cv.deciw,a2	; Str to int
	jsr	(a2)
	beq.s	int_ok
	move.w	#-32768,(a4,a6.l)
	bra.s	int_ret

int_ok
	move.w	(a1,a6.l),(a4,a6.l)
int_ret
	move.l	a4,sb_arthp(a6) ; arithmetic stack pointer
	moveq	#nt.in,d4
	moveq	#0,d0
	rts

do_float
	moveq	#6,d1
	suba.l	d1,a4
	movea.w qa.resri,a3
	jsr	(a3)
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	movea.w cv.decfp,a2
	jsr	(a2)
	beq.s	float_ok
	move.w	#6,(a4,a6.l)	; 1E-615
	move.l	#$40A24E92,2(a4,a6.l)
	bra.s	float_ret

float_ok
	move.l	2(a1,a6.l),2(a4,a6.l)
	move.l	(a1,a6.l),(a4,a6.l)

float_ret
	move.l	a4,sb_arthp(a6) ; arithmetic stack pointer
	moveq	#nt.fp,d4
	moveq	#0,d0
	rts


read_mode:				
	moveq	#-1,d1
	moveq	#-1,d2
	moveq	#sms.dmod,d0	; read the Display MODe
	trap	#1
	rts

; m = RMODE
rmode:					
	bsr.s	read_mode
	move.w	d1,d5
	bra.s	ret_d5

; Return long integer as floating point
int_to_fp
	moveq	#0,d2
	move.w	#$820,d0
i2fp_shift
	subq.w	#1,d0
	asl.l	#1,d1
	bvs.s	i2fp_end
	beq.s	i2fc_ret
	bra.s	i2fp_shift

i2fp_end
	roxr.l	#1,d1
	move.w	d0,d2
i2fc_ret
	rts

; Return long int D5
ret_d5
	move.l	d5,d1
	bsr.s	int_to_fp
	move.l	d1,d3
	moveq	#6,d1
	bsr.s	qa_resri_d1	; Allocate D1 bytes on arithmetic stack
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	move.w	d2,(a6,a1.l)
	move.l	d3,2(a6,a1.l)
	moveq	#0,d0
	moveq	#nt.fp,d4
	rts

; Reserve D1 bytes on arithmetic stack
qa_resri
	movem.l d1-d3/a0/a2,-(sp)
	movea.w qa.resri,a2
	jsr	(a2)
	movem.l (sp)+,d1-d3/a0/a2
	rts

; Allocate D1 bytes on arithmetic stack
qa_resri_d1
	bsr.s	qa_resri	; Reserve D1 bytes on arithmetic stack
	sub.l	d1,sb_arthp(a6)
	rts


keyw_get_str
	moveq	#8,d0
	add.l	a3,d0
	sub.l	a5,d0
	bne.s	keyw_ipar
	bsr	get_str1
	bne.s	keyw_get_str_ret
	move.w	(a6,a1.l),d1
	addq.l	#2,a1
	bsr.s	lookup_name_table
	rts

keyw_ipar
	moveq	#err.ipar,d0	; Invalid PARameter (c.f. err.orng)
keyw_get_str_ret
	addq.l	#4,sp
	rts

; 0/-7 = KEYW(keyword$)
keyw:					
	moveq	#0,d5
	bsr.s	keyw_get_str
	move.l	d0,d5
	bra.s	ret_d5

lookup_name_table
	movem.l d2/d4/a0-a2,-(sp)
	trap	#0
	adda.l	a6,a1
	move.l	a6,-(sp)
	move.l	d1,d4
	moveq	#sms.info,d0	; get INFOrmation on SMS
	trap	#1
	move.l	d4,d1
	movea.l sys_jbtb(a0),a0 ; JoB Table Base
	movea.l (a0),a0
	adda.w	#sb_offs,a0	; offset from JCB to SuperBASIC vars
	movea.l a0,a6
	suba.l	a6,a1
	movea.l sb_nmtbb(a6),a3 ; name table base

ln_loop
	cmpa.l	sb_nmtbp(a6),a3 ; name table pointer
	bcc.s	ln_not_found
	move.w	2(a6,a3.l),d2
	bmi.s	ln_next_name
	movea.w d2,a2
	adda.l	sb_nmlsb(a6),a2 ; name list base
	moveq	#0,d2
	move.b	(a6,a2.l),d2
	cmp.w	d1,d2
	beq.s	lookup_name_size_match

ln_next_name
	addq.l	#nt.len,a3
	bra.s	ln_loop

ln_not_found
	moveq	#err.itnf,d0	; ITem Not Found
	bra.s	ln_ret

lookup_name_size_match
	movea.l a1,a0
	bra.s	ln_compare_name

ln_compare_loop
	move.b	(a6,a0.l),d4
	cmp.b	1(a6,a2.l),d4
	beq.s	ln_compare_next
	bchg	#5,d4
	cmp.b	1(a6,a2.l),d4
	bne.s	ln_next_name

ln_compare_next
	addq.l	#1,a0
	addq.l	#1,a2
ln_compare_name:			
	dbf	d2,ln_compare_loop
	cmpi.w	#nt.mcprc<<8,(a6,a3.l)
	beq.s	ln_found
	cmpi.w	#nt.mcfun<<8,(a6,a3.l)
	bne.s	ln_not_found

ln_found
	moveq	#0,d0
ln_ret
	movea.l (sp)+,a6
	andi.w	#$D8FF,sr
	movem.l (sp)+,d2/d4/a0-a2
	rts

; Get next parameter string
get_str1
	movem.l d1-d4/d6/a0/a2/a5,-(sp)
	lea	8(a3),a5
	movea.w sb.gtstr,a2
	jsr	(a2)
	bne.s	get_str1_ret
	moveq	#0,d1
	move.w	(a6,a1.l),d1
	addq.l	#3,d1
	bclr	#0,d1
	add.l	a1,d1
	move.l	d1,sb_arthp(a6) ; arithmetic stack pointer
get_str1_ret
	movea.l a5,a3
	movem.l (sp)+,d1-d4/d6/a0/a2/a5
	tst.l	d0
	rts


thing_check_par_count
	lsl.l	#3,d1
	move.l	a5,d0
	sub.l	a3,d0
	sub.l	d1,d0
	beq.s	thing_rts
	moveq	#err.ipar,d0	; Invalid PARameter (c.f. err.orng)
thing_rts
	rts

thing_get_str
	move.l	sb_arthp(a6),d5 ; arithmetic stack pointer
	movea.w sb.gtstr,a2
	jsr	(a2)
	bne.s	thing_get_str_nc
	moveq	#0,d0
	bra.s	thing_get_str_ret

thing_get_str_nc
	moveq	#err.nc,d0	; operation Not Complete
thing_get_str_ret
	move.l	d5,sb_arthp(a6) ; arithmetic stack pointer
	tst.l	d0
	rts

; err = THING(name)
thing
	moveq	#1,d1
	bsr.s	thing_check_par_count
	bne.s	thing_rts
	bsr.s	thing_get_str
	bne.s	thing_rts
	lea	(a6,a1.l),a0	; Thing name
	move.l	a0,d6
	bsr.s	get_thg 	; Get Thing system thing in a3
	tst.l	d0
	bne.s	thing_ret
	movea.l thh_entr(a3),a4
	movea.l d6,a0		; Thing name
	bsr.s	thg_use
	tst.l	d0
	bne.s	thing_ret
	movea.l a1,a3
	movea.l d6,a0		; Thing name
	bsr.s	thg_free
	tst.l	d0
	bne.s	thing_ret
	moveq	#0,d5
	bra	ret_d5

thing_ret
	move.l	d0,d5
	bra	ret_d5

; Get Thing system thing in a3
get_thg
	moveq	#sms.info,d0	; get INFOrmation on SMS
	trap	#1
	moveq	#err.fdnf,d0	; File or Device Not Found
	move.l	sys_thgl(a0),d5 ; pointer to THinG List
	beq.s	get_thg_ret

get_thg_loop
	movea.l d5,a0
	move.l	(a0),d5
	bne.s	get_thg_loop
	movea.l th_thing(a0),a3 ; pointer to THING itself
	cmpi.l	#'THG%',thh_flag(a3)
	bne.s	get_thg_ret
	cmpi.l	#-1,thh_type(a3) ; type of thing
	bne.s	get_thg_ret
	moveq	#0,d0
get_thg_ret
	rts

; Use thing
thg_use
	moveq	#sms.uthg,d0	; Use THinG
	moveq	#-1,d1
	moveq	#0,d2
	moveq	#-1,d3
	jsr	(a4)
	rts

; Free thing
thg_free:				
	moveq	#sms.fthg,d0	; Free THinG
	moveq	#-1,d1
	jsr	(a4)
	rts


; s$ = C_STRG$(index)
c_strg$
	bsr	c_getint_d1	; Get exactly one integer parameter in D1
	bne.s	c_ret
	moveq	#0,d4		; Item type
	bsr	c_get_item
	bne.s	c_strg$_empty
	addq.w	#2,a0
	adda.w	(a0),a0
	addq.w	#2,a0
	movea.l a0,a4
	move.w	(a0),d1
	addq.w	#2,d1
	ext.l	d1
	move.l	a1,sb_arthp(a6) ; arithmetic stack pointer
	movea.w qa.resri,a0
	jsr	(a0)
	movea.l sb_arthp(a6),a1 ; arithmetic stack pointer
	move.w	(a4)+,d0
	moveq	#3,d1
	add.w	d0,d1
	bclr	#0,d1
	sub.w	d1,a1
	move.l	a1,sb_arthp(a6)
	movea.l a1,a2
	move.w	d0,(a2,a6.l)
	addq.l	#2,a2
	bra.s	c_strg$_copy

c_strg$_loop
	move.b	(a4)+,(a2,a6.l)
	addq.l	#1,a2
c_strg$_copy
	dbf	d0,c_strg$_loop
	moveq	#nt.st,d4
c_ok
	moveq	#0,d0
c_ret
	rts

c_strg$_empty
	clr.w	(a1,a6.l)
	moveq	#nt.st,d4
	bra.s	c_ok

; s$ = C_CHAR$(index)
c_char$
	bsr.s	c_getint_d1	; Get exactly one integer parameter in D1
	bne.s	c_ret
	moveq	#cf.char,d4	; Item type
	bsr.s	c_get_item
	bne.s	c_strg$_empty
	addq.w	#2,a0
	adda.w	(a0),a0
	move.w	#1,(a1,a6.l)	; Return as single char string
	move.b	(a0),2(a1,a6.l)
	moveq	#nt.st,d4
	bra.s	c_ok

; c = C_CODE(index)
c_code
	bsr.s	c_getint_d1	; Get exactly one integer parameter in D1
	bne.s	c_ret
	moveq	#cf.code,d4	; Item type
	bsr.s	c_get_item
	addq.w	#2,a0
	adda.w	(a0),a0
	move.b	(a0),d0
	ext.w	d0
	move.w	d0,(a1,a6.l)
	moveq	#nt.in,d4
	bra.s	c_ok

; b = C_BYTE(index)
c_byte
	bsr.s	c_getint_d1	; Get exactly one integer parameter in D1
	bne.s	c_ret
	moveq	#cf.byte,d4	; Item type
	bsr.s	c_get_item
	addq.w	#2,a0
	adda.w	(a0),a0
	move.b	(a0),d0
	ext.w	d0
	move.w	d0,(a1,a6.l)
	moveq	#nt.in,d4
	bra.s	c_ok

; w = C_WORD(index)
c_word
	bsr.s	c_getint_d1	; Get exactly one integer parameter in D1
	bne.s	c_ret
	moveq	#cf.word,d4	; Item type
	bsr.s	c_get_item
	addq.w	#2,a0
	adda.w	(a0),a0
	move.w	(a0),(a1,a6.l)
	moveq	#nt.in,d4
	bra.s	c_ok

; Get exactly one integer parameter in D1
c_getint_d1
	movea.w sb.gtint,a0
	jsr	(a0)
	bne.s	c_getint_ipar
	subq.w	#1,d3
	bne.s	c_getint_ipar
	move.w	(a1,a6.l),d1
	moveq	#0,d0
	rts

c_getint_ipar
	moveq	#err.ipar,d0	; Invalid PARameter (c.f. err.orng)
	rts

c_get_item
	move.w	d1,d0
	lea	nm_config(pc),a0
	bsr.s	c_skip_string
	bsr.s	c_skip_string

c_get_item_loop
	move.b	(a0),d3
	cmp.b	d4,d3
	beq.s	c_get_item_check_index

c_get_item_next
	adda.w	#$C,a0
	move.w	(a0),d1
	addq.w	#1,d1
	beq.s	c_get_item_nf
	bra.s	c_get_item_loop

c_get_item_check_index
	subq.w	#1,d0
	bne.s	c_get_item_next
	moveq	#0,d0
	rts

c_get_item_nf
	moveq	#err.fdnf,d0	; File or Device Not Found
	rts

c_skip_string
	move.w	(a0)+,d1
	btst	#0,d1
	beq.s	c_skip_string_ret
	addq.w	#1,d1
c_skip_string_ret
	adda.w	d1,a0
	rts

config	mkcfhead {QSnap},{2.04}
	mkcfitem byte,0,cfg_type,,,\
       {Enter your printer typ (by Trump Card manual) : },1,23

	mkcfitem byte,0,cfg_scale,,,\
       {Enter the scale factor for your printer :},1,3

	mkcfitem code,0,cfg_invert,,,\
       {Invert :},0,0,{off},1,0,{on}

	mkcfitem code,0,cfg_random,,,\
       {Random :},0,0,{off},1,0,{on}

	mkcfitem code,0,cfg_default,,,\
       {Select default for save / dump :}\
	0,0,{full screen},1,0,{part of screen}

	mkcfitem code,0,cfg_area,,,\
       {Select default option :}\
	0,0,{save area},1,0,{dump area},2,0,{text from area}

	mkcfitem string,0,cfg_save_name,,,\
       {Enter default device and filename to save :},0

	mkcfitem string,0,cfg_dump_name,,,\
       {Enter default device (file) to dump :},0

       mkcfend

cfg_type
	dc.b	6
cfg_scale
	dc.b	1
cfg_invert
	dc.b	1
cfg_random
	dc.b	0
cfg_default
	dc.b	1
cfg_area
	dc.b	1

cfg_save_name
	dc.w	30
	dc.w	15
	dc.b	'flp1_Screen_Cut'
	ds.b	15
cfg_dump_name
	dc.w	30
	dc.w	3
	dc.b	'PRT'
	ds.b	27

	end
