; QDesign Basic extension, reverse engineered by Marcel Kilgus

	section code
	
	include 'dev8_keys_sbasic'
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qdos_ioa'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_con'
	include 'dev8_keys_sys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_thg'
	include 'dev8_keys_hdr'
	include 'dev8_keys_qlhw'
		

; QDesign thing
qthg_x_min		equ 0
qthg_x_max		equ 2                       
qthg_y_min		equ 4                       
qthg_y_max		equ 6                       
qthg_scr_base		equ 8                    
qthg_scr_llen		equ $C   	; Scr line length (bytes)
qthg_scr_yres		equ $E                   
qthg_curr_ink_col	equ $10		; Current ink colour (actual ink or shadow)
qthg_font_size_x	equ $12               
qthg_font_size_y	equ $14               
qthg_font_angle		equ $16                
qthg_font_ql2ibm	equ $18               
qthg_font_italic_angle	equ $1A         
qthg_font_italic_slant	equ $1C         
qthg_font_flags		equ $1E         ; Bold 0..15, right 16, down 32, left 64, top 128, shadow 256, pixel 512
qthg_font_mirror_x	equ $20             
qthg_font_mirror_y	equ $22             
qthg_font_outline	equ $24              
qthg_move_scr_base	equ $26         ; Screen address
qthg_move_scr_width	equ $2A         ; Width in words
qthg_move_scr_height	equ $2E         ; Height in lines
qthg_move_scr_x		equ $32         ; X address in words
qthg_move_scr_y		equ $36         ; y position in lines
qthg_img_base		equ $3A                  
qthg_img_llen_w		equ $3E                
qthg_prev_height	equ $42               
qthg_ink_col		equ $44         ; Ink colour set though VG_INK
qthg_shadow_col		equ $46         ; Shadow colour set though VG_SHAD
qthg_over_mode		equ $48                 
qthg_ver_cnt		equ $4A                   
qthg_over_mode_copy	equ $52            
qthg_buffer_ptr		equ $54                
qthg_buffer_size	equ $58               
qthg_prt_loops		equ $58                 
qthg_pixel_accu		equ $5A                
qthd_tmp_mode		equ $5C                  
qthg_file_type		equ $5F                 
qthg_mono_mode		equ $60                 
qthg_prt_chan		equ $64                  
qthg_fonts		equ $7E                     
qthg_workspace		equ $C8                 
qthg_work_img_x		equ $C8                
qthg_work_par2		equ $CC                 
qthg_work_img_y		equ $CC                
qthg_work_img_width	equ $D0            
qthg_work_img_base	equ $D4             
qthg_dst_x		equ $D8                     
qthg_dst_y		equ $DC                     
qthg_work_scr_xres	equ $E0             
qthg_work_scr_base	equ $E4             
qthg_sx1		equ $FA                       
qthg_src_x		equ $FE                     
qthg_x_ratio		equ $102                  
qthg_sy1		equ $106                      
qthg_src_y		equ $10A                    
qthg_y_ratio		equ $10E                  
qthg_io_dx1		equ $112                   
qthg_prt_can		equ $12C                  
qthg_ptr_start		equ $136                
qthg_prt_space1		equ $140               
qthg_ptr_space24	equ $14A              
qthg_prt_space30	equ $154              
qthg_ptr_dev		equ $15E                  
qthg_prt_device		equ $160               
qthg_prt_dpi_hor	equ $186              
qthg_prt_dpi_ver	equ $18A              
qthg_prt_type		equ $18E        ; 1 = 9-pin, 3 = 24-pin, 4 = laser
qthg_prt_colour		equ $192               
qthg_rotate		equ $196        ; Exchange X/Y during INOUT or PRINT
qthg_chid		equ $19A                     
qthg_paint_with_pattern	equ $19E       	; True to paint with pattern, false to paint with colour
qthg_patt_addr		equ $1A2        ; Paint pattern address
qthg_patt_llen_l	equ $1A6        ; Long version of qthg_paint_llen (used to set)
qthg_patt_llen		equ $1A8        ; Paint area line length
qthg_patt_width_l	equ $1AA        ; Long version of qthg_paint_width (used to set)
qthg_patt_width		equ $1AC        ; Paint pattern width (to wrap around)
qthg_patt_height_l	equ $1AE        ; Long version of qthg_paint_height (used to set)
qthg_patt_height	equ $1B0        ; Paint pattern height (to wrap around)
qthg_hc_good		equ $1BA        ; Use "good" quality during INOUT/PRINT
qthg_prt_patt1		equ $1BE                
qthg_prt_patt2		equ $1C2                
qthg_fill_buffer	equ $1F4              
qthg_buffer		equ $800                   

; Vector font thing
vthg_fonts       	equ $7E                
vthg_workspace   	equ $C8                

; BGI font data
font_base        	equ $80                
font_char_count  	equ $81                
font_first_char  	equ $84                
font_ascender    	equ $88               
font_descender   	equ $8A              
font_width_table 	equ $90               

; Bezier data
pd.points        	equ $14                
bd_floats        	equ $100               
bd_p0_x          	equ $200               
bd_p0_y          	equ $202               
bd_p1_x          	equ $204               
bd_p1_y          	equ $206               
bd_p2_x          	equ $208               
bd_p2_y          	equ $20A               
bd_p3_x          	equ $20C               
bd_p3_y          	equ $20E               
bd_points        	equ $300               
bd.size          	equ $400               

; PIC data
pic_id           	equ 0           ; $4AFC
pic_xs           	equ 2           ; Width in pixels
pic_ys           	equ 4           ; Height in pixels
pic_incr         	equ 6           ; Line increment
pic_mode         	equ 8           ; Mode of image
pic_spare        	equ 9           ; Unused
pic_image        	equ $A          ; Image data

; QLiberator keys
sbq_qerr_wrappers  	equ $DC

; QL screen definitions
scr_incr  		equ $80               
scr_size  		equ $8000          
scr_base  		equ $20000             

; Additional thing keys
thh_qdata    		equ $0A
th_start     		equ $40
th_data_base 		equ $4A

qdesign_start
        movea.w sb.inipr,a0    
        lea     qdesign_procs(pc),a1
        jsr     (a0)
        rts
; ---------------------------------------------------------------------------
qdesign_procs:dc.w 49                   
        dc.w bezier-*                   ; BEZIER p0x,p0y,p3x,p3y,p1x,p1y,p2x,p2y
        dc.b 6,'BEZIER',0
        dc.w a_mono-*                   ; A_MONO addr - OR red and green colour bits to white
        dc.b 6,'A_MONO',0
        dc.w swap-*                     ; SWAP addr - Mirror QL screen in y direction
        dc.b 4,'SWAP',0
        dc.w mix-*                      ; MIX src,dest,bytes,mode (0 = or, 1 = eor) - OR or XOR a block of memory
        dc.b 3,'MIX'
        dc.w monoise-*                  ; MONOISE addr,bytes per line,lines/2 - Convert colours to B/W
        dc.b 7,'MONOISE'
        dc.w convert-*                  ; CONVERT addr,bytes,lines
        dc.b 7,'CONVERT'
        dc.w enhance-*                  ; ENHANCE addr - Blur picture?
        dc.b 7,'ENHANCE'
        dc.w outline-*                  ; OUTLINE addr - Outline screen
        dc.b 7,'OUTLINE'
        dc.w vgpat-*                    ; VGPAT patt_addr,pic_addr - Make sprite out of PIC
        dc.b 5,'VGPAT'
        dc.w q_err_on-*                 ; Q_ERR_ON keyword$
        dc.b 8,'Q_ERR_ON',0
        dc.w q_err_off-*                ; Q_ERR_OFF keyword$
        dc.b 9,'Q_ERR_OFF'
        dc.w q_err_list-*               ; Q_ERR_LIST - List Q_ERR_ON enabled keywords
        dc.b $A
        dc.b 'Q_ERR_LIST',0
        dc.w box-*                      ; BOX {#ch,}x1,y1,x2,y2,{filled}
        dc.b 3,'BOX'
        dc.w poke$-*                    ; POKE$ addr,str1 - Poke string into memory
        dc.b 5,'POKE$'
        dc.w initdest-*                 ; INITDEST - Init DEST$ to SER1
        dc.b 8,'INITDEST',0
        dc.w m_conv-*                   ; M_CONV mode (2,4,8),addr,words
        dc.b 6,'M_CONV',0
        dc.w move_id-*                  ; MOVE_ID chan - Set channel as main channel for toolkit
        dc.b 7,'MOVE_ID'
        dc.w movepara-*                 ; MOVEPARA scr_addr, scr_width, scr_height, scr_x, scr_y, mem_base, mem_llen_words
                                        ;
                                        ; Initialise parameters for TOSCR/TOMEM
        dc.b 8,'MOVEPARA',0
        dc.w toscr-*                    ; TOSCR x_pos, y_pos
        dc.b 5,'TOSCR'
        dc.w tomem-*                    ; TOMEM x,y
        dc.b 5,'TOMEM'
        dc.w zoom-*                     ; ZOOM level, x_pos, y_pos
        dc.b 4,'ZOOM',0
        dc.w prev-*                     ; PREV mem_height, sample_x, sample_y - Make preview of image
        dc.b 4,'PREV',0
        dc.w inout-*                    ; INOUT dx1,dy1,dx2,dy2,sx1,sy1,sx2,sy2 - Copy/stretch source area into destination area
        dc.b 5,'INOUT'
        dc.w rotate-*                   ; ROTATE r - Set rotation
        dc.b 6,'ROTATE',0
        dc.w punkt-*                    ; PUNKT x,y,{colour} - Draw point
        dc.b 5,'PUNKT'
        dc.w linie-*                    ; LINIE x1,y1,x2,y2,{colour} - Draw line
        dc.b 5,'LINIE'
        dc.w p_para-*                   ; P_PARA mode,addr,llen,x_size,y_size
        dc.b 6,'P_PARA',0
        dc.w paint-*                    ; PAINT x,y,colour
        dc.b 5,'PAINT'
        dc.w s_save-*                   ; S_SAVE filename,addr,size,mode
        dc.b 6,'S_SAVE',0
        dc.w s_load-*                   ; S_LOAD filename,addr
        dc.b 6,'S_LOAD',0
        dc.w hc_patt-*                  ; HC_PATT p1,p2
        dc.b 7,'HC_PATT'
        dc.w hc_good-*                  ; HC_GOOD val
        dc.b 7,'HC_GOOD'
        dc.w hc_para-*                  ; HC_PARA cancel$,start$,space1$,space24$,space30$
        dc.b 7,'HC_PARA'
        dc.w hc_reso-*                  ; HC_RESO hor,ver,type,colour
        dc.b 7,'HC_RESO'
        dc.w hc_dev-*                   ; HC_DEV dev$
        dc.b 6,'HC_DEV',0
        dc.w hc_do-*                    ; HC_DO x1,y1,x2,y2,loops
        dc.b 5,'HC_DO'
        dc.w hc_multi-*                 ; HC_MULTI x1,y1,x2,y2,loops - Same as HC_DO, but leave multitasking enabled
        dc.b 8,'HC_MULTI',0
        dc.w vg_mode-*                  ; VG_MODE mode (1 = mode 4,2 = mono)
        dc.b 7,'VG_MODE'
        dc.w vg_reso-*                  ; VG_RESO scr_base,words_per_line,lines - Define screen resolution
        dc.b 7,'VG_RESO'
        dc.w vg_wind-*                  ; VG_WIND x_min,x_max,y_min,y_max - Define window
        dc.b 7,'VG_WIND'
        dc.w vg_para-*                  ; VG_PARA size_x,size_y,angle,ibm,it_angle,it_slant,flags,mirror_x,mirror_y,outline
        dc.b 7,'VG_PARA'
        dc.w vg_load-*                  ; VG_LOAD filename,font_index - Load BGI font
        dc.b 7,'VG_LOAD'
        dc.w vg_print-*                 ; VG_PRINT x,y,font,str$
        dc.b 8,'VG_PRINT',0
        dc.w vg_weg-*                   ; VG_WEG font-index - Remove font
        dc.b 6,'VG_WEG',0
        dc.w vg_ink-*                   ; VG_INK colour
        dc.b 6,'VG_INK',0
        dc.w vg_shad-*                  ; VG_SHAD colour
        dc.b 7,'VG_SHAD'
        dc.w vg_over-*                  ; VG_OVER over
        dc.b 7,'VG_OVER'
        dc.w vg_clr-*                   ; VG_CLR addr,words,colour - Quickly clear memory
        dc.b 6,'VG_CLR',0
        dc.w vg_inv-*                   ; VG_INV addr,words - Quickly invert memory
        dc.b 6,'VG_INV',0
        dc.w 0
        dc.w 26
        dc.w level2-*                   ; l2 = LEVEL2(#ch) - Get if driver is level 2 capable
        dc.b 6,'LEVEL2',0
        dc.w vg_init-*                  ; addr = VG_INIT - Initialise QDesign thing
        dc.b 7,'VG_INIT'
        dc.w vec_thg-*                  ; thg = VEC_THG - Get vector fonts thing pointer
        dc.b 7,'VEC_THG'
        dc.w vg_breit-*                 ; width% = VG_BREIT font_index,character - Return width of font
        dc.b 8,'VG_BREIT',0
        dc.w vg_hoch-*                  ; height% = VG_HOCH(font_index) - Return height of font
        dc.b 7,'VG_HOCH'
        dc.w vg_name-*                  ; name$ = VG_NAME(font_index) - Return name of font
        dc.b 7,'VG_NAME'
        dc.w vg_lang-*                  ; length% = VG_LANG(font_index) - Return size of font data
        dc.b 7,'VG_LANG'
        dc.w atari-*                    ; atari = ATARI - Hacky check for ATARI hw
        dc.b 5,'ATARI'
        dc.w q_err-*                    ; err = Q_ERR - Returned trapped error or 0
        dc.b 5,'Q_ERR'
        dc.w win_base-*                 ; cdb = WIN_BASE({#chan}) - Return CDB address
        dc.b 8,'WIN_BASE',0
        dc.w sys_base-*                 ; base = SYS_BASE - Return system variable base
        dc.b 8,'SYS_BASE',0
        dc.w vgrsp-*                    ; VGRSP x,y - Get memory needed for sprite
        dc.b 5,'VGRSP'
        dc.w peek$-*                    ; string$ = PEEK$(addr, len) - Get string from memory
        dc.b 5,'PEEK$'
        dc.w brush-*                    ; addr = BRUSH(0..12) - Return one of the inbuilt brushes
        dc.b 5,'BRUSH'
        dc.w muster-*                   ; addr = MUSTER(0..18) - Return one of the inbuilt patterns
        dc.b 6,'MUSTER',0
        dc.w check_int-*                ; val = CHECK%(string). -32768 on error
        dc.b 6,'CHECK%',0
        dc.w checkf-*                   ; val = CHECKF(string). -1E600 on error
        dc.b 6,'CHECKF',0
        dc.w thing-*                    ; err = THING(name) - Return if a thing exists
        dc.b 5,'THING'
        dc.w keyw-*                     ; exists = KEYW(keyword$)
        dc.b 4,'KEYW',0
        dc.w rmode-*                    ; mode = RMODE - Read screen mode
        dc.b 5,'RMODE'
        dc.w qver$-*                    ; v$ = QVER$ - Get QDOS version (language independant)
        dc.b 5,'QVER$'
        dc.w c_strg$-*                  ; s$ = C_STRG$(index)
        dc.b 7,'C_STRG$'
        dc.w c_char$-*                  ; s$ = C_CHAR$(index)
        dc.b 7,'C_CHAR$'
        dc.w c_code-*                   ; c = C_CODE(index)
        dc.b 6,'C_CODE',0
        dc.w c_byte-*                   ; b = C_BYTE(index)
        dc.b 6,'C_BYTE',0
        dc.w c_word-*                   ; w = C_WORD(index)
        dc.b 6,'C_WORD',0
        dc.w 0

; =============== S U B R O U T I N E =======================================
; BEZIER p0x,p0y,p3x,p3y,p1x,p1y,p2x,p2y

bezier:                                 
        jsr     get_channel_default_1
        bne.s   bezier_ret
        movea.l a0,a4                   ; Channel ID
        movem.l a3/a5,-(sp)
        move.l  #bd.size,d1
        moveq   #-1,d2
        moveq   #sms.achp,d0            ; Allocate space in Common HeaP
        trap    #1
        movem.l (sp)+,a3/a5
        tst.w   d0
        bne.s   bezier_ret
        move.l  a0,-(sp)
        movea.w sb.gtint,a2    
        jsr     (a2)
        movea.l (sp)+,a0
        cmpi.w  #8,d3                   ; 8 parameters
        bne.s   bezier_ipar
        move.w  (a6,a1.l),bd_p0_x(a0)
        move.w  2(a6,a1.l),bd_p0_y(a0)
        move.w  4(a6,a1.l),bd_p3_x(a0)
        move.w  6(a6,a1.l),bd_p3_y(a0)
        move.w  8(a6,a1.l),bd_p1_x(a0)
        move.w  $A(a6,a1.l),bd_p1_y(a0)
        move.w  $C(a6,a1.l),bd_p2_x(a0)
        move.w  $E(a6,a1.l),bd_p2_y(a0)
        movea.l a0,a5                   ; Working block
        bsr.s   bezier_calc_lines
        bsr     bezier_draw_20_lines
        movea.l a5,a0
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        trap    #1
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

bezier_ipar:                            
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        trap    #1
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

bezier_ret:                             
        rts

; =============== S U B R O U T I N E =======================================

bezier_calc_lines:                      
        lea     bd_p0_x(a5),a0
        lea     bd_points(a5),a1
        move.w  (a0),(a1)+              ; Starting point
        move.w  bd_p0_y-bd_p0_x(a0),(a1)+
        moveq   #1,d7

bezier_calc_loop:                       
        move.w  bd_p1_x-bd_p0_x(a0),d0
        sub.w   (a0),d0                 ; Diff to next point
        muls.w  d7,d0
        divs.w  #pd.points,d0           ; d7/20th
        add.w   (a0),d0                 ; d0 = p01_x = p0.x + (p1.x - p0.x) * d7 / 20
        move.w  bd_p1_y-bd_p0_x(a0),d1
        sub.w   bd_p0_y-bd_p0_x(a0),d1
        muls.w  d7,d1
        divs.w  #pd.points,d1           ; d7/20th
        add.w   bd_p0_y-bd_p0_x(a0),d1  ; d1 = p01_y = p0.y + (p1.y - p0.y) * d7 / 20
        move.w  bd_p2_x-bd_p0_x(a0),d2
        sub.w   bd_p1_x-bd_p0_x(a0),d2
        muls.w  d7,d2
        divs.w  #pd.points,d2
        add.w   bd_p1_x-bd_p0_x(a0),d2  ; d2 = p12_x = p1.x + (p2.x - p1.x) * d7 / 20
        move.w  bd_p2_y-bd_p0_x(a0),d3
        sub.w   bd_p1_y-bd_p0_x(a0),d3
        muls.w  d7,d3
        divs.w  #pd.points,d3
        add.w   bd_p1_y-bd_p0_x(a0),d3  ; d3 = p12_y = p1.y + (p2.y - p1.y) * d7 / 20
        move.w  bd_p3_x-bd_p0_x(a0),d4
        sub.w   bd_p2_x-bd_p0_x(a0),d4
        muls.w  d7,d4
        divs.w  #pd.points,d4
        add.w   bd_p2_x-bd_p0_x(a0),d4  ; d4 = p23_x = p2.x + (p3.x - p2.x) * d7 / 20
        move.w  bd_p3_y-bd_p0_x(a0),d5
        sub.w   bd_p2_y-bd_p0_x(a0),d5
        muls.w  d7,d5
        divs.w  #pd.points,d5
        add.w   bd_p2_y-bd_p0_x(a0),d5  ; d5 = p23_y = p2.y + (p3.y - p2.y) * d7 / 20
        move.w  d2,d6                   ; p12_x
        sub.w   d0,d6                   ; p12_x - p01_x
        muls.w  d7,d6
        divs.w  #pd.points,d6
        add.w   d6,d0                   ; d0 = p02_x = p12_x + (p12_x - p01_x) * d7 / 20
        move.w  d3,d6
        sub.w   d1,d6
        muls.w  d7,d6
        divs.w  #pd.points,d6
        add.w   d6,d1                   ; d1 = p02_y = p12_y + (p12_y - p01_y) * d7 / 20
        sub.w   d2,d4
        muls.w  d7,d4
        divs.w  #pd.points,d4
        add.w   d4,d2                   ; d2 = p13_x = p23_x + (p23_x - p12_x) * d7 / 20
        sub.w   d3,d5
        muls.w  d7,d5
        divs.w  #pd.points,d5
        add.w   d5,d3                   ; d3 = p13_y = p23_y + (p23_y - p12_y) * d7 / 20
        sub.w   d0,d2
        muls.w  d7,d2
        divs.w  #pd.points,d2
        add.w   d2,d0                   ; d0 = p03_x = p13_x + (p13_x - p02_x) * d7 / 20
        move.w  d0,(a1)+                ; p03_x
        sub.w   d1,d3
        muls.w  d7,d3
        divs.w  #pd.points,d3
        add.w   d3,d1                   ; d1 = p03_y = p13_y + (p13_y - p02_y) * d7 / 20
        move.w  d1,(a1)+                ; p03_y
        addq.w  #1,d7
        cmpi.w  #pd.points,d7
        bcs     bezier_calc_loop
        move.w  bd_p3_x-bd_p0_x(a0),(a1)+
        move.w  bd_p3_y-bd_p0_x(a0),(a1)+
        rts

; =============== S U B R O U T I N E =======================================

bezier_draw_20_lines:                   
        move.w  #pd.points,d7
        subq.w  #1,d7
        lea     bd_points(a5),a0

bezier_line_loop:                       
        movem.w (a0)+,d0-d1             ; x/y start
        movem.w (a0),d2-d3              ; x/y end
        movem.l d7/a0,-(sp)
        bsr.s   bezier_line             ; d0 = x-start, d1 = y-start, d2 = x-end, d3 = y-end
        movem.l (sp)+,d7/a0
        dbf     d7,bezier_line_loop
        rts

; =============== S U B R O U T I N E =======================================
; d0 = x-start, d1 = y-start, d2 = x-end, d3 = y-end

bezier_line:                            
        lea     bd_floats(a5),a1
        bsr.s   d0_to_float             ; x-start
        move.w  d1,d0                   ; y-start
        bsr.s   d0_to_float
        move.w  d2,d0                   ; x-end
        bsr.s   d0_to_float
        move.w  d3,d0                   ; y-end
        bsr.s   d0_to_float
        moveq   #-1,d3
        movea.l a4,a0
        moveq   #iog.line,d0            ; draw (list of) LINEs
        trap    #3
        rts

; =============== S U B R O U T I N E =======================================

d0_to_float:                            
        move    sr,d7
        trap    #0
        move.w  d7,-(sp)
        move.w  d0,-(a1)
        suba.l  a6,a1
        moveq   #0,d7
        moveq   #qa.float,d0            ; FLOAT integer
        movea.w qa.op,a2    
        jsr     (a2)
        adda.l  a6,a1
        move    (sp)+,sr
        rts

; =============== S U B R O U T I N E =======================================
; l2 = LEVEL2(#ch) - Get if driver is level 2 capable

level2:                                 
        bsr.s   get_channel             ; Get channel (pass default in D6)
        bne.s   level2_ipar
        move.l  a0,-(sp)
        moveq   #100,d0
        bsr     achp                    ; Allocate d0 bytes
        movea.l a0,a1
        movea.l (sp)+,a0
        moveq   #iof.xinf,d0            ; get eXtended INFormation
        moveq   #0,d1
        moveq   #0,d2
        moveq   #-1,d3
        trap    #3
        tst.l   d0
        beq.s   level2_ok
        movea.l a1,a2
        bsr     rchp                    ; Release memory in a2

level2_ipar:                            
        moveq   #err.ichn,d5            ; Invalid CHaNnel id
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------

level2_ok:                              
        movea.l a1,a2
        bsr     rchp                    ; Release memory in a2
        moveq   #0,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================

get_channel_default_1:                  
        moveq   #1,d6

; =============== S U B R O U T I N E =======================================
; Get channel (pass default in D6)

get_channel:                            
        cmpa.l  a3,a5
        beq.s   get_chan_loop
        btst    #nt..hash,1(a6,a3.l)    ; preceded by hash
        beq.s   get_chan_loop
        move.l  a5,-(sp)
        movea.l a3,a5
        addq.l  #8,a5                   ; Get first parameter
        move.l  a5,-(sp)
        movea.w sb.gtint,a2    
        jsr     (a2)
        movea.l (sp)+,a3
        movea.l (sp)+,a5
        subq.w  #1,d3
        bne.s   get_chan_next
        move.w  (a6,a1.l),d6
        addq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer

get_chan_loop:                          
        mulu.w  #ch.len,d6
        moveq   #err.ichn,d0            ; Invalid CHaNnel id
        add.l   sb_chanb(a6),d6         ; channel table base
        cmp.l   sb_chanp(a6),d6         ; channel table pointer
        bcc.s   get_chan_next
        move.l  (a6,d6.l),d1
        btst    #$1F,d1
        bne.s   get_chan_next
        movea.l d1,a0
        moveq   #0,d0

get_chan_next:                          
        tst.l   d0
        rts

; =============== S U B R O U T I N E =======================================
; v$ = QVER$ - Get QDOS version (language independant)

qver$:                                  
        cmpa.l  a3,a5
        bne.s   qver_ipar
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        swap    d2
        move.b  #'.',d2                 ; Replace language character
        swap    d2
        moveq   #6,d6                   ; Useless
        move.l  d2,d7
        bra     ret_4char_str_d7        ; Reserve 6 bytes
; ---------------------------------------------------------------------------

qver_ipar:                              
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts

; =============== S U B R O U T I N E =======================================

read_mode:                              
        moveq   #-1,d1
        moveq   #-1,d2
        moveq   #sms.dmod,d0            ; set the Display MODe
        trap    #1
        rts

; =============== S U B R O U T I N E =======================================
; mode = RMODE - Read screen mode

rmode:                                  
        bsr.s   read_mode
        move.w  d1,d5
        bra.s   ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------

int_to_fp:                              
        moveq   #0,d2
        move.w  #$820,d0

i2fp_shift:                             
        subq.w  #1,d0
        asl.l   #1,d1
        bvs.s   i2fp_end
        beq.s   i2fc_ret
        bra.s   i2fp_shift
; ---------------------------------------------------------------------------

i2fp_end:                               
        roxr.l  #1,d1
        move.w  d0,d2

i2fc_ret:                               
        rts
; ---------------------------------------------------------------------------

ret_d5:                                 
        move.l  d5,d1                   ; Return integer in d5
        bsr.s   int_to_fp
        move.l  d1,d3
        moveq   #6,d1
        bsr.s   qa_resri_d1             ; Allocate D1 bytes on arithmetic stack
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.w  d2,(a6,a1.l)
        move.l  d3,2(a6,a1.l)
        moveq   #0,d0
        moveq   #nt.fp,d4
        rts

; =============== S U B R O U T I N E =======================================
; Reserve D1 bytes on arithmetic stack

qa_resri:                               
        movem.l d1-d3/a0/a2,-(sp)
        movea.w qa.resri,a2    
        jsr     (a2)
        movem.l (sp)+,d1-d3/a0/a2
        rts

; =============== S U B R O U T I N E =======================================
; Allocate D1 bytes on arithmetic stack

qa_resri_d1:                            
        bsr.s   qa_resri                ; Reserve D1 bytes on arithmetic stack
        sub.l   d1,sb_arthp(a6)         ; arithmetic stack pointer
        rts

; =============== S U B R O U T I N E =======================================
; Get string and look it up in name table. Ret d0 = 0 or err.itnf

keyw_get_str:                           
        moveq   #8,d0
        add.l   a3,d0
        sub.l   a5,d0
        bne.s   keyw_ipar
        bsr     get_str1                ; Get next basic parameter string
        bne.s   keyw_get_str_ret
        move.w  (a6,a1.l),d1
        addq.l  #2,a1
        bsr.s   lookup_name_table       ; Lookup string in (a6,a1.l) in name list. Ret d0 = 0 or err.itnf
        rts
; ---------------------------------------------------------------------------

keyw_ipar:                              
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

keyw_get_str_ret:                       
        addq.l  #4,sp
        rts

; =============== S U B R O U T I N E =======================================
; exists = KEYW(keyword$)

keyw:                                   
        moveq   #0,d5
        bsr.s   keyw_get_str            ; Get string and look it up in name table. Ret d0 = 0 or err.itnf
        move.l  d0,d5
        bra.s   ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================
; Lookup string in (a6,a1.l) in name list. Ret d0 = 0 or err.itnf

lookup_name_table:                      
        movem.l d2/d4/a0-a2,-(sp)
        trap    #0
        adda.l  a6,a1
        move.l  a6,-(sp)
        move.l  d1,d4
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        move.l  d4,d1
        movea.l sys_jbtb(a0),a0         ; JoB Table Base
        movea.l (a0),a0
        adda.w  #sb_offs,a0             ; offset from JCB to SuperBASIC vars
        movea.l a0,a6
        suba.l  a6,a1
        movea.l sb_nmtbb(a6),a3         ; name table base

ln_loop:                                
        cmpa.l  sb_nmtbp(a6),a3         ; name table pointer
        bcc.s   ln_not_found
        move.w  2(a6,a3.l),d2
        bmi.s   ln_next_name
        movea.w d2,a2
        adda.l  sb_nmlsb(a6),a2         ; name list base
        moveq   #0,d2
        move.b  (a6,a2.l),d2
        cmp.w   d1,d2
        beq.s   lookup_name_size_match

ln_next_name:                           
        addq.l  #nt.len,a3
        bra.s   ln_loop
; ---------------------------------------------------------------------------

ln_not_found:                           
        moveq   #err.itnf,d0            ; ITem Not Found
        bra.s   ln_ret
; ---------------------------------------------------------------------------

lookup_name_size_match:                 
        movea.l a1,a0
        bra.s   ln_compare_name
; ---------------------------------------------------------------------------

ln_compare_loop:                        
        move.b  (a6,a0.l),d4
        cmp.b   1(a6,a2.l),d4
        beq.s   ln_compare_next
        bchg    #5,d4
        cmp.b   1(a6,a2.l),d4
        bne.s   ln_next_name

ln_compare_next:                        
        addq.l  #1,a0
        addq.l  #1,a2

ln_compare_name:                        
        dbf     d2,ln_compare_loop
        cmpi.w  #nt.mcprc<<8,(a6,a3.l)
        beq.s   ln_found
        cmpi.w  #nt.mcfun<<8,(a6,a3.l)
        bne.s   ln_not_found

ln_found:                               
        moveq   #0,d0

ln_ret:                                 
        movea.l (sp)+,a6
        andi.w  #$D8FF,sr
        movem.l (sp)+,d2/d4/a0-a2
        rts

; =============== S U B R O U T I N E =======================================
; Get next basic parameter string

get_str1:                               
        movem.l d1-d4/d6/a0/a2/a5,-(sp)
        lea     8(a3),a5
        movea.w sb.gtstr,a2    
        jsr     (a2)
        bne.s   get_str1_ret
        moveq   #0,d1
        move.w  (a6,a1.l),d1
        addq.l  #3,d1
        bclr    #0,d1
        add.l   a1,d1
        move.l  d1,sb_arthp(a6)         ; arithmetic stack pointer

get_str1_ret:                           
        movea.l a5,a3
        movem.l (sp)+,d1-d4/d6/a0/a2/a5
        tst.l   d0
        rts

; =============== S U B R O U T I N E =======================================

thing_check_par_count:                  
        lsl.l   #3,d1
        move.l  a5,d0
        sub.l   a3,d0
        sub.l   d1,d0
        beq.s   thing_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

thing_ret:                              
        rts

; =============== S U B R O U T I N E =======================================

thing_get_str:                          
        move.l  sb_arthp(a6),d5         ; arithmetic stack pointer
        movea.w sb.gtstr,a2    
        jsr     (a2)
        bne.s   thing_get_str_nc
        moveq   #0,d0
        bra.s   thing_get_str_ret
; ---------------------------------------------------------------------------

thing_get_str_nc:                       
        moveq   #err.nc,d0              ; operation Not Complete

thing_get_str_ret:                      
        move.l  d5,sb_arthp(a6)         ; arithmetic stack pointer
        tst.l   d0
        rts

; =============== S U B R O U T I N E =======================================
; err = THING(name) - Return if a thing exists

thing:                                  
        moveq   #1,d1
        bsr.s   thing_check_par_count
        bne.s   thing_ret
        bsr.s   thing_get_str
        bne.s   thing_ret
        lea     (a6,a1.l),a0            ; Thing name
        move.l  a0,d6
        bsr     get_thg                 ; Get Thing system thing in a3
        tst.l   d0
        bne.s   thing_ret_d0
        movea.l thh_entr(a3),a5
        movea.l d6,a0                   ; Thing name
        bsr     thg_use                 ; Use thing
        tst.l   d0
        bne.s   thing_ret_d0
        movea.l a1,a3
        movea.l d6,a0                   ; Thing name
        bsr     thg_free                ; Free thing
        tst.l   d0
        bne.s   thing_ret_d0
        moveq   #0,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------

thing_ret_d0:                           
        move.l  d0,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================
; base = SYS_BASE - Return system variable base

sys_base:                               
        moveq   #0,d0
        trap    #1
        move.l  a0,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================
; Get basic channel parameter (default 1) and return channel ID in a0

get_basic_chan:                         
        moveq   #1,d6                   ; Default channel
        cmpa.l  a3,a5
        beq.s   get_chan
        btst    #nt..hash,1(a6,a3.l)    ; preceded by hash
        beq.s   get_chan
        move.l  a5,-(sp)
        movea.l a3,a5
        addq.l  #8,a5
        move.l  a5,-(sp)
        movea.w sb.gtint,a2    
        jsr     (a2)
        movea.l (sp)+,a3
        movea.l (sp)+,a5
        subq.w  #1,d3
        bne.s   get_chan_ret
        move.w  (a6,a1.l),d6            ; Channel
        addq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer

get_chan:                               
        mulu.w  #ch.len,d6
        moveq   #err.ichn,d0            ; Invalid CHaNnel id
        add.l   sb_chanb(a6),d6         ; channel table base
        cmp.l   sb_chanp(a6),d6         ; channel table pointer
        bcc.s   get_chan_ret
        move.l  (a6,d6.l),d1
        btst    #$1F,d1
        bne.s   get_chan_ret
        movea.l d1,a0
        moveq   #0,d0

get_chan_ret:                           
        tst.l   d0
        rts
; ---------------------------------------------------------------------------
ret_d1:                                 
        move.l  d1,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================
; cdb = WIN_BASE({#chan}) - Return CDB address

win_base:                               
        moveq   #0,d4
        bsr.s   get_basic_chan          ; Get basic channel parameter (default 1) and return channel ID in a0
        move.l  d0,d1
        bne.s   ret_d1
        lea     xtop_get_cdb(pc),a2
        moveq   #-1,d3
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        trap    #3
        tst.l   d0
        bne.s   win_base_err
        bra.s   ret_d1
; ---------------------------------------------------------------------------

win_base_err:                           
        move.l  d0,d1
        bra.s   ret_d1

; =============== S U B R O U T I N E =======================================

xtop_get_cdb:                           
        move.l  a0,d1
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; atari = ATARI - Hacky check for ATARI hw

atari:                                  
        bsr.s   check_no_params
        moveq   #0,d5
        bsr.s   check_atari
        bne     ret_d5                  ; Return integer in d5
        moveq   #1,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================

check_no_params:                        
        cmpa.l  a3,a5
        beq.s   check_no_params_ret
        addq.l  #4,sp
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

check_no_params_ret:                    
        rts

; =============== S U B R O U T I N E =======================================

check_atari:                            
        movem.l a0-a1,-(sp)
        suba.l  a0,a0
        move    sr,d0
        trap    #0
        move.w  d0,-(sp)
        lea     $FC0000,a1              ; ROM copy at $FC0000?
        cmpm.l  (a0)+,(a1)+
        bne.s   no_rom_mirror
        cmpm.l  (a0)+,(a1)+
        bne.s   no_rom_mirror
        moveq   #0,d0
        bra.s   check_atari_ret
; ---------------------------------------------------------------------------

no_rom_mirror:                          
        moveq   #err.nc,d0              ; operation Not Complete

check_atari_ret:                        
        move    (sp)+,sr
        movem.l (sp)+,a0-a1
        tst.l   d0
        rts
; ---------------------------------------------------------------------------
check_ipar:                             
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

check_par_ret:                          
        rts

; =============== S U B R O U T I N E =======================================
; val = CHECKF(string). -1E600 on error

checkf:                                 
        moveq   #0,d5
        bra.s   check_all

; =============== S U B R O U T I N E =======================================
; val = CHECK%(string). -32768 on error

check_int:                              
        moveq   #1,d5

check_all:                              
        movea.l sb_arthp(a6),a4         ; arithmetic stack pointer
        movea.w sb.gtstr,a0    
        jsr     (a0)
        bne.s   check_par_ret
        subq.w  #1,d3                   ; Only one string please
        bne.s   check_ipar
        movea.l a1,a0
        adda.w  (a1,a6.l),a0
        addq.l  #2,a0                   ; End of string
        move.l  a0,d7
        lea     2(a1),a0                ; Start of string
        tst.w   d5
        beq.s   check_float             ; val = CHECK_FLOAT(string). -1E600 on error
        moveq   #2,d1
        suba.l  d1,a4
        movea.w qa.resri,a2    
        jsr     (a2)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        movea.w cv.deciw,a2    
        jsr     (a2)
        beq.s   check_int_ok
        move.w  #$8000,(a4,a6.l)
        bra.s   check_int_ret
; ---------------------------------------------------------------------------

check_int_ok:                           
        move.w  (a1,a6.l),(a4,a6.l)

check_int_ret:                          
        move.l  a4,sb_arthp(a6)         ; arithmetic stack pointer
        moveq   #nt.in,d4
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

check_float:                            
        moveq   #6,d1                   ; val = CHECK_FLOAT(string). -1E600 on error
        suba.l  d1,a4
        movea.w qa.resri,a3    
        jsr     (a3)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        movea.w cv.decfp,a2    
        jsr     (a2)
        beq.s   check_float_ok
        move.w  #$FCA,(a4,a6.l)         ; -1E600
        move.w  #$B8A6,2(a4,a6.l)
        move.w  #$3468,4(a4,a6.l)
        bra.s   check_float_ret
; ---------------------------------------------------------------------------

check_float_ok:                         
        move.l  2(a1,a6.l),2(a4,a6.l)
        move.l  (a1,a6.l),(a4,a6.l)

check_float_ret:                        
        move.l  a4,sb_arthp(a6)         ; arithmetic stack pointer
        moveq   #nt.fp,d4
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; POKE$ addr,str1 - Poke string into memory

poke$:                                  
        move.l  a5,d1
        sub.l   a3,d1
        divu.w  #8,d1                   ; Parameter count
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        subq.w  #2,d1                   ; Exactly two please
        bne.s   poke$_ret
        movea.l a3,a4
        lea     8(a3),a5
        movea.w sb.gtlin,a2             ; Get address
        jsr     (a2)
        bne.s   poke$_ret
        move.l  (a6,a1.l),d7
        lea     8(a4),a3
        lea     8(a3),a5
        movea.w sb.gtstr,a2    
        jsr     (a2)
        bne.s   poke$_ret
        trap    #0
        adda.l  a6,a1
        movea.l d7,a2
        move.w  (a1)+,d1

poke$_copy:                             
        beq.s   poke$_end
        move.b  (a1)+,(a2)+
        subq.w  #1,d1
        bra.s   poke$_copy
; ---------------------------------------------------------------------------

poke$_end:                              
        move    #0,sr
        moveq   #0,d0

poke$_ret:                              
        rts

; =============== S U B R O U T I N E =======================================
; string$ = PEEK$(addr, len) - Get string from memory

peek$:                                  
        movea.w sb.gtlin,a2    
        jsr     (a2)
        bne.s   poke$_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #2,d3                   ; Exactly two please
        bne.s   poke$_ret
        movea.l (a6,a1.l),a5            ; Addr
        move.l  4(a6,a1.l),d5           ; Len
        andi.l  #$FFFF,d5
        beq.s   poke$_ret
        move.l  d5,d1
        addq.w  #1,d1
        bclr    #0,d1
        move.l  a1,sb_arthp(a6)         ; arithmetic stack pointer
        movea.w qa.resri,a2    
        jsr     (a2)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.l  d5,d4
        addq.w  #1,d4
        bclr    #0,d4
        suba.l  d4,a1
        move.l  a1,sb_arthp(a6)         ; arithmetic stack pointer
        adda.l  a6,a1
        move.w  d5,(a1)+

peek$_loop:                             
        move.b  (a5)+,(a1)+
        subq.w  #1,d5
        bne.s   peek$_loop
        moveq   #0,d0
        moveq   #nt.st,d4
        rts

; =============== S U B R O U T I N E =======================================
; BOX {#ch,}x1,y1,x2,y2,{filled}

box:                                    
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        andi.l  #$FF00FFFF,d2
        cmpi.l  #$31003130,d2           ; "1.10"
        bcs     box_old_qdos            ; These don't have sd_linel!
        sf      d7
        bsr     get_channel_default_1
        bne.s   box_ret
        movea.l a0,a4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        subq.w  #4,d1                   ; 4 parameters?
        bne.s   box_do
        movea.w qa.resri,a2             ; Default outline parameter to 0
        moveq   #2,d1
        jsr     (a2)
        subq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        clr.w   (a6,a1.l)

box_do:                                 
        movea.w sb.gtint,a2    
        jsr     (a2)
        bne.s   box_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        subq.w  #4,d3                   ; Need at least 4 parameters
        bcs.s   box_ret
        subq.w  #1,d3                   ; And at most 5
        bhi.s   box_ret
        move.l  2(a6,a1.l),d1           ; x1,y1,x2,y2
        swap    d1
        move.l  d1,2(a6,a1.l)           ; x1,x2,y1,y2
        moveq   #10,d1                  ; Remove 5 integers from stack
        add.l   d1,sb_arthp(a6)         ; arithmetic stack pointer
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l a4,a0                   ; Channel ID
        lea     xtop_box(pc),a2
        tst.b   d7
        beq.s   box_xtop_do
        lea     xtop_box_rotated(pc),a2 ; I think this code is never reached?

box_xtop_do:                            
        trap    #4
        trap    #3
        move.l  d0,sb_erno(a6)          ; long    last error number
        moveq   #0,d0

box_ret:                                
        rts
; ---------------------------------------------------------------------------

xtop_box_rotated:                       
        movem.l (a1)+,d1-d2
        bsr     rotate_coords
        bra.s   xtop_both
; ---------------------------------------------------------------------------

xtop_box:                               
        movem.l (a1)+,d1-d2             ; d1 = x1/x2, d2 = y1/y2

xtop_both:                              
        bsr     box_coords_abs          ; Make coordinates absolute, return pixel mask in d7
        move.l  d1,d4                   ; x1/x2
        swap    d4                      ; x2/x1
        move.l  d2,d5                   ; y1/y2
        swap    d5                      ; y2/y1
        cmp.w   d4,d1
        bge.s   box_order_x
        exg     d4,d1                   ; Make sure x1<x2

box_order_x:                            
        cmp.w   d5,d2
        bge.s   box_order_y
        exg     d5,d2                   ; Make sure y1<y2

box_order_y:                            
        move.w  d1,d0                   ; x2
        sub.w   d4,d0                   ; -x1 = width
        subq.w  #1,d0
        btst    #mc..m8,sys_qlmr(a6)    ; QL Master chip Register value
        beq.s   box_mode4_width
        subq.w  #1,d0

box_mode4_width:                        
        bcs     box_filled
        move.w  d2,d0                   ; y2
        sub.w   d5,d0                   ; -y1 = height
        subq.w  #1,d0
        bcs     box_filled
        tst.w   (a1)                    ; Filled?
        bne     box_filled              ; yes... otherwise it's outline only!
        move.l  d2,d5                   ; y1/y2
        swap    d2
        sub.w   d2,d5                   ; d5 = y2 - y1 = height
        movem.l d1/d5,-(sp)             ; d1 = x2/x1, d5 = height
        move.l  sd_imask(a0),d3         ; ink colour mask
        btst    #0,d2                   ; y1 odd?
        beq.s   boutl_imask_ok
        swap    d3                      ; Then invert stipple

boutl_imask_ok:                         
        bsr     box_prepare_ptrs        ; I: d1 = x1/x2, d2 = y. O: a1 = line addr, d1 = x2/line off, d2 = pix shifts (x1/x2)
        lea     (a1,d1.w),a2            ; Pixel word x1 address
        swap    d1                      ; x1 line offset/x2
        swap    d2                      ; x2 shift/x1 shift
        lsr.w   #3,d1                   ; 8 pixels per word
        add.w   d1,d1                   ; x1 line offset/x2 line offset
        lea     (a1,d1.w),a3            ; Pixel word x2 address
        move.w  d7,d1                   ; Pixel mask
        ror.w   d2,d1                   ; Rotate for x1 pixel
        move.w  d1,d0                   ; x1 pixel mask
        and.w   d3,d0                   ; d0 = x1 colour bits
        move.w  d1,d4                   ; x1 pixel mask
        swap    d1                      ; Save it
        swap    d2                      ; x1 shift/x2 shift
        move.w  d7,d1                   ; Pixel mask
        ror.w   d2,d1                   ; Rotate for x2 pixel
        swap    d0                      ; Save x1 colour bits
        move.w  d1,d0                   ; x2 pixel mask
        and.w   d3,d0                   ; d0 = x2 colour bits
        swap    d4
        move.w  d1,d4                   ; x1 pixel mask/x2 pixel mask
        swap    d3                      ; Other stipple colour
        and.w   d3,d4                   ; x2 colour stipple2
        swap    d4
        and.w   d3,d4                   ; x2 colour stipple2/x1 colour stipple2
        swap    d4                      ; x1 colour stipple2/x2 colour stipple2
        swap    d3                      ; Restore imask
        subq.w  #1,d5                   ; Prepare for DBF
        beq.s   boutl_h                 ; No height, just draw horizontal lines
        move.l  a2,-(sp)
        btst    #3,sd_cattr(a0)         ; XOR?
        bne.s   boutl_v_xor
        not.l   d1
        bra.s   boutl_v_loop_start
; ---------------------------------------------------------------------------

boutl_v_loop:                           
        exg     d4,d0
        adda.w  sd_linel(a0),a2         ; line length in bytes
        adda.w  sd_linel(a0),a3         ; line length in bytes
        and.w   d1,(a3)                 ; Mask x2 pixel
        or.w    d0,(a3)                 ; Set x2 pixel
        swap    d1                      ; x1 pixel mask
        swap    d0                      ; x1 pixel colours
        and.w   d1,(a2)                 ; Mask x1 pixel
        or.w    d0,(a2)                 ; Set x1 pixel
        swap    d1
        swap    d0

boutl_v_loop_start:                     
        dbf     d5,boutl_v_loop
        bra.s   boutl_h_2
; ---------------------------------------------------------------------------

boutl_v_xor:                            
        bra.s   boutl_v_xor_loop_start
; ---------------------------------------------------------------------------

boult_v_xor_loop:                       
        exg     d4,d0
        adda.w  sd_linel(a0),a2         ; line length in bytes
        adda.w  sd_linel(a0),a3         ; line length in bytes
        eor.w   d0,(a3)                 ; XOR x2 colour
        swap    d0
        eor.w   d0,(a2)                 ; XOR x1 colour
        swap    d0

boutl_v_xor_loop_start:                 
        dbf     d5,boult_v_xor_loop

boutl_h_2:                              
        movea.l (sp)+,a2

boutl_h:                                
        movem.l (sp)+,d1/d5             ; d1 = x2/x1, d5 = height
        move.w  d3,d7                   ; imask
        swap    d3
        btst    #0,d5                   ; Uneven line?
        beq.s   boutl_h_prepare
        move.w  d7,d3                   ; Other stipple colour

boutl_h_prepare:                        
        swap    d3
        move.w  d5,d0                   ; Height
        mulu.w  sd_linel(a0),d0         ; line length in bytes
        lea     (a2,d0.l),a3            ; y2 line offset
        move.l  d1,d4                   ; x2/x1
        swap    d1                      ; x1/x2
        lsr.w   #3,d1                   ; 8 pixels per word
        lsr.w   #3,d4                   ; 8 pixels per word
        sub.w   d1,d4                   ; Words
        subq.w  #1,d4
        moveq   #-1,d0
        swap    d2                      ; x1 shift
        lsr.b   d2,d0                   ; x1 mask
        tst.w   d4
        blt     boutl_h_single_word
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0                   ; Double the mask
        swap    d2                      ; x2 shift
        swap    d0                      ; -1
        neg.b   d2
        addq.b  #7,d2
        lsl.b   d2,d0                   ; x2 mask
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0                   ; Double the mask
        move.w  d3,d6                   ; imask
        and.w   d0,d6                   ; d6 = masked colour
        swap    d0
        swap    d6
        move.w  d3,d6
        and.w   d0,d6                   ; masked x1 colour/masked x2 colour
        swap    d3
        move.w  d3,d7
        and.w   d0,d7
        swap    d0
        swap    d7
        move.w  d3,d7
        and.w   d0,d7                   ; masked x1 colour2/masked x2 colour2
        swap    d0
        swap    d7
        swap    d3
        btst    #3,sd_cattr(a0)         ; XOR?
        bne.s   boutl_h_xor
        not.l   d0                      ; Process the start words
        and.w   d0,(a2)
        or.w    d6,(a2)+
        and.w   d0,(a3)
        or.w    d7,(a3)+
        bra.s   boutl_h_loop_start
; ---------------------------------------------------------------------------

boutl_h_loop:                           
        move.w  d3,(a2)+                ; Set pixels in both lines
        swap    d3
        move.w  d3,(a3)+
        swap    d3

boutl_h_loop_start:                     
        dbf     d4,boutl_h_loop
        swap    d0
        swap    d6
        swap    d7
        and.w   d0,(a2)                 ; Process the end word
        or.w    d6,(a2)
        and.w   d0,(a3)
        or.w    d7,(a3)
        bra.s   boutl_ok
; ---------------------------------------------------------------------------

boutl_h_xor:                            
        eor.w   d6,(a2)+                ; Process the start word
        eor.w   d7,(a3)+
        bra.s   boutl_h_xor_loop_start
; ---------------------------------------------------------------------------

boutl_h_xor_loop:                       
        eor.w   d3,(a2)+                ; XOR pixels in both lines
        swap    d3
        eor.w   d3,(a3)+
        swap    d3

boutl_h_xor_loop_start:                 
        dbf     d4,boutl_h_xor_loop
        swap    d6
        swap    d7
        eor.w   d6,(a2)
        eor.w   d7,(a3)
        bra.s   boutl_ok
; ---------------------------------------------------------------------------

boutl_h_single_word:                    
        swap    d2
        neg.b   d2
        addq.b  #7,d2
        lsr.b   d2,d0
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        move.w  d3,d6
        and.w   d0,d6
        swap    d6
        swap    d3
        move.w  d3,d6
        and.w   d0,d6
        btst    #3,sd_cattr(a0)         ; XOR?
        bne.s   boutl_h_single_word_xor
        not.w   d0                      ; Put colour within single word
        and.w   d0,(a3)
        or.w    d6,(a3)
        swap    d6
        and.w   d0,(a2)
        or.w    d6,(a2)
        bra.s   boutl_ok
; ---------------------------------------------------------------------------

boutl_h_single_word_xor:                
        eor.w   d6,(a3)                 ; XOR single word
        swap    d6
        eor.w   d6,(a2)

boutl_ok:                               
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

box_prepare_ptrs:                       
        move.w  d2,d0                   ; I: d1 = x1/x2, d2 = y. O: a1 = line addr, d1 = x2/line off, d2 = pix shifts (x1/x2)
        mulu.w  sd_linel(a0),d0         ; line length in bytes
        movea.l sd_scrb(a0),a1          ; base address of screen
        adda.l  d0,a1
        move.l  #$70007,d2
        and.l   d1,d2
        swap    d1
        lsr.w   #3,d1                   ; 8 pixels per word
        add.w   d1,d1                   ; Byte offset
        rts
; ---------------------------------------------------------------------------

box_filled:                             
        move.w  d2,d5                   ; y2
        swap    d2                      ; y2/y1
        move.l  sd_imask(a0),d3         ; ink colour mask
        btst    #0,d2                   ; y1 even?
        beq.s   bfill_prepare
        swap    d3                      ; Adjust imask

bfill_prepare:                          
        sub.w   d2,d5                   ; y2-y1
        addq.w  #1,d5
        bsr.s   box_prepare_ptrs        ; I: d1 = x1/x2, d2 = y. O: a1 = line addr, d1 = x2/line off, d2 = pix shifts (x1/x2)
        adda.w  d1,a1                   ; Pixel word address
        lsr.w   #1,d1                   ; Word offset
        move.l  d1,d4
        swap    d4                      ; x2
        lsr.w   #3,d4                   ; 8 pixels per word
        sub.w   d1,d4                   ; d4 = occupied pixel words
        subq.w  #1,d4
        swap    d2                      ; x2/x1 pixel shifts
        moveq   #-1,d0
        lsr.b   d2,d0                   ; x1 mask
        swap    d2                      ; x1/x2 pixel shifts
        tst.w   d4
        blt.s   bfill_single_word       ; Contained within a single word
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0                   ; x1 mask for both colours
        swap    d0
        neg.b   d2
        addq.b  #7,d2
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0                   ; x2 mask for both colours
        swap    d0                      ; d0 = x2/x1 bit mask
        swap    d2                      ; 7-x2/x1 pixel shifts
        bra.s   bfill_prepare_imask
; ---------------------------------------------------------------------------

bfill_single_word:                      
        neg.b   d2
        addq.b  #7,d2                   ; 7-x2 pixel shifts
        lsr.b   d2,d0
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0                   ; x2 mask for both colours
        move.l  d3,d6                   ; imask
        and.w   d0,d6
        swap    d6
        and.w   d0,d6
        swap    d6                      ; d6 = masked ink colour
        btst    #3,sd_cattr(a0)         ; XOR?
        bne.s   bfill_swx_loop_start
        not.w   d0
        bra.s   bfill_sw_loop_start
; ---------------------------------------------------------------------------

bfill_sw_loop:                          
        and.w   d0,(a1)
        or.w    d6,(a1)
        swap    d6
        adda.w  sd_linel(a0),a1         ; line length in bytes

bfill_sw_loop_start:                    
        dbf     d5,bfill_sw_loop
        bra     box_ok
; ---------------------------------------------------------------------------

bfill_swx_loop:                         
        eor.w   d6,(a1)
        adda.w  sd_linel(a0),a1         ; line length in bytes

bfill_swx_loop_start:                   
        dbf     d5,bfill_swx_loop
        bra.s   box_ok
; ---------------------------------------------------------------------------

bfill_prepare_imask:                    
        movea.l a1,a2                   ; Pixel word address
        move.l  d4,d2                   ; Occupied words
        move.w  d3,d6                   ; imask
        and.w   d0,d6                   ; d0 = x2/x1 bit mask
        swap    d0
        swap    d6
        move.w  d3,d6
        and.w   d0,d6                   ; d6 = masked ink
        swap    d6
        swap    d3
        move.w  d3,d7
        and.w   d0,d7
        swap    d0
        swap    d7
        move.w  d3,d7
        and.w   d0,d7                   ; d7 = masked ink (stipple2)
        swap    d3
        btst    #3,sd_cattr(a0)         ; XOR?
        bne.s   bfillx_loop_start
        not.l   d0
        bra.s   bfill_loop_start
; ---------------------------------------------------------------------------

bfill_line_loop:                        
        and.w   d0,(a1)                 ; Start word
        or.w    d6,(a1)+
        bra.s   bfill_word_loop_start
; ---------------------------------------------------------------------------

bfill_word_loop:                        
        move.w  d3,(a1)+

bfill_word_loop_start:                  
        dbf     d2,bfill_word_loop
        swap    d0
        swap    d6
        and.w   d0,(a1)                 ; End word
        or.w    d6,(a1)
        swap    d0
        swap    d6
        move.w  d4,d2
        movea.l a2,a1
        adda.w  sd_linel(a0),a1         ; Next line
        movea.l a1,a2
        swap    d3
        exg     d6,d7

bfill_loop_start:                       
        dbf     d5,bfill_line_loop
        bra.s   box_ok
; ---------------------------------------------------------------------------

bfillx_line_loop:                       
        eor.w   d6,(a1)+
        bra.s   bfillx_word_loop_start
; ---------------------------------------------------------------------------

bfillx_word_loop:                       
        eor.w   d3,(a1)+

bfillx_word_loop_start:                 
        dbf     d2,bfillx_word_loop
        swap    d6
        eor.w   d6,(a1)+
        swap    d6
        move.w  d4,d2
        movea.l a2,a1
        adda.w  sd_linel(a0),a1         ; line length in bytes
        movea.l a1,a2
        swap    d3
        exg     d6,d7

bfillx_loop_start:                      
        dbf     d5,bfillx_line_loop

box_ok:                                 
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

rotate_coords:                          
        swap    d2
        move.w  sd_ysize(a0),d5         ; window height, exclusive of border
        subq.w  #1,d5
        sub.w   d2,d5
        move.w  d5,d2
        rts
; ---------------------------------------------------------------------------

box_coords_abs:                         
        tst.b   sys_dfrz(a6)            ; Make coordinates absolute, return pixel mask in d7
        bne.s   box_frozen
        cmp.w   sd_ysize(a0),d2         ; Check y1 against height
        bcc.s   box_oor
        add.w   sd_ymin(a0),d2          ; Make absolute
        swap    d2
        cmp.w   sd_ysize(a0),d2         ; Check y2 against height
        bcc.s   box_oor
        add.w   sd_ymin(a0),d2          ; Make absolute
        cmp.w   sd_xsize(a0),d1         ; Check x1 against width
        bcc.s   box_oor
        add.w   sd_xmin(a0),d1          ; Make absolute
        swap    d1
        cmp.w   sd_xsize(a0),d1         ; Check x2 against width
        bcc.s   box_oor
        add.w   sd_xmin(a0),d1          ; Make absolute
        move.w  #$8080,d7               ; Mode 4 pixel mask
        btst    #mc..m8,sys_qlmr(a6)    ; QL Master chip Register value
        beq.s   box_coords_ret
        andi.l  #$FFFEFFFE,d1
        move.b  #$C0,d7                 ; Now mode 8 pixel mask

box_coords_ret:                         
        swap    d1
        swap    d2
        rts
; ---------------------------------------------------------------------------

box_frozen:                             
        moveq   #err.nc,d0              ; operation Not Complete
        bra.s   box_ret4
; ---------------------------------------------------------------------------

box_oor:                                
        moveq   #0,d0

box_ret4:                               
        addq.l  #4,sp
        rts
; ---------------------------------------------------------------------------

box_old_qdos:                           
        sf      d7
        bsr     get_channel_default_1
        bne.s   boq_ret
        movea.l a0,a4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        subq.w  #4,d1
        bne.s   boq_get_params
        movea.w qa.resri,a2             ; Fake 5th parameter to 0
        moveq   #2,d1
        jsr     (a2)
        subq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        clr.w   (a6,a1.l)

boq_get_params:                         
        movea.w sb.gtint,a2    
        jsr     (a2)
        bne.s   boq_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        subq.w  #4,d3
        bcs.s   boq_ret
        subq.w  #1,d3
        bhi.s   boq_ret
        move.l  2(a6,a1.l),d1
        swap    d1
        move.l  d1,2(a6,a1.l)
        moveq   #10,d1
        add.l   d1,sb_arthp(a6)         ; arithmetic stack pointer
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l a4,a0
        lea     xtop_boq(pc),a2         ; Version that does not rely on sd_linel
        tst.b   d7
        beq.s   boq_xtop_do
        lea     xtop_boq_rotated(pc),a2

boq_xtop_do:                            
        trap    #4
        trap    #3
        move.l  d0,sb_erno(a6)          ; long    last error number
        moveq   #0,d0

boq_ret:                                
        rts

; =============== S U B R O U T I N E =======================================

xtop_boq_rotated:                       
        movem.l (a1)+,d1-d2
        bsr     boq_rotate_coords
        bra.s   boq_both
; ---------------------------------------------------------------------------

xtop_boq:                               
        movem.l (a1)+,d1-d2             ; Version that does not rely on sd_linel

boq_both:                               
        bsr     boq_coords_abs
        move.l  d1,d4
        swap    d4
        move.l  d2,d5
        swap    d5
        cmp.w   d4,d1
        bge.s   boq_order_x
        exg     d4,d1

boq_order_x:                            
        cmp.w   d5,d2
        bge.s   boq_order_y
        exg     d5,d2

boq_order_y:                            
        move.w  d1,d0
        sub.w   d4,d0
        subq.w  #1,d0
        btst    #3,sys_qlmr(a6)         ; QL Master chip Register value
        beq.s   boq_mode4_width
        subq.w  #1,d0

boq_mode4_width:                        
        bcs     boq_filled
        move.w  d2,d0
        sub.w   d5,d0
        subq.w  #1,d0
        bcs     boq_filled
        tst.w   (a1)
        bne     boq_filled
        move.l  d2,d5
        swap    d2
        sub.w   d2,d5
        movem.l d1/d5,-(sp)
        move.l  sd_imask(a0),d3         ; ink colour mask
        btst    #0,d2
        beq.s   boq_outl_imask_ok
        swap    d3

boq_outl_imask_ok:                      
        bsr     boq_prepare_ptrs
        lea     (a1,d1.w),a2
        swap    d1
        swap    d2
        lsr.w   #3,d1
        add.w   d1,d1
        lea     (a1,d1.w),a3
        move.w  d7,d1
        ror.w   d2,d1
        move.w  d1,d0
        and.w   d3,d0
        move.w  d1,d4
        swap    d1
        swap    d2
        move.w  d7,d1
        ror.w   d2,d1
        swap    d0
        move.w  d1,d0
        and.w   d3,d0
        swap    d4
        move.w  d1,d4
        swap    d3
        and.w   d3,d4
        swap    d4
        and.w   d3,d4
        swap    d4
        swap    d3
        subq.w  #1,d5
        beq.s   boq_outl_h
        move.l  a2,-(sp)
        btst    #3,sd_cattr(a0)         ; character attributes
        bne.s   boq_outl_v_xor
        not.l   d1
        bra.s   boq_outl_v_loop_start
; ---------------------------------------------------------------------------

boq_outl_v_loop:                        
        exg     d4,d0
        adda.w  #scr_incr,a2
        adda.w  #scr_incr,a3
        and.w   d1,(a3)
        or.w    d0,(a3)
        swap    d1
        swap    d0
        and.w   d1,(a2)
        or.w    d0,(a2)
        swap    d1
        swap    d0

boq_outl_v_loop_start:                  
        dbf     d5,boq_outl_v_loop
        bra.s   boq_outl_h_2
; ---------------------------------------------------------------------------

boq_outl_v_xor:                         
        bra.s   boq_outl_v_xor_loop_start
; ---------------------------------------------------------------------------

boq_outl_v_xor_loop:                    
        exg     d4,d0
        adda.w  #scr_incr,a2
        adda.w  #scr_incr,a3
        eor.w   d0,(a3)
        swap    d0
        eor.w   d0,(a2)
        swap    d0

boq_outl_v_xor_loop_start:              
        dbf     d5,boq_outl_v_xor_loop

boq_outl_h_2:                           
        movea.l (sp)+,a2

boq_outl_h:                             
        movem.l (sp)+,d1/d5
        move.w  d3,d7
        swap    d3
        btst    #0,d5
        beq.s   boq_outl_h_prepare
        move.w  d7,d3

boq_outl_h_prepare:                     
        swap    d3
        move.w  d5,d0
        mulu.w  #scr_incr,d0
        lea     (a2,d0.l),a3
        move.l  d1,d4
        swap    d1
        lsr.w   #3,d1
        lsr.w   #3,d4
        sub.w   d1,d4
        subq.w  #1,d4
        moveq   #$FFFFFFFF,d0
        swap    d2
        lsr.b   d2,d0
        tst.w   d4
        blt     boq_outl_h_single_word
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        swap    d2
        swap    d0
        neg.b   d2
        addq.b  #7,d2
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        move.w  d3,d6
        and.w   d0,d6
        swap    d0
        swap    d6
        move.w  d3,d6
        and.w   d0,d6
        swap    d3
        move.w  d3,d7
        and.w   d0,d7
        swap    d0
        swap    d7
        move.w  d3,d7
        and.w   d0,d7
        swap    d0
        swap    d7
        swap    d3
        btst    #3,sd_cattr(a0)         ; character attributes
        bne.s   boq_outl_h_xor
        not.l   d0
        and.w   d0,(a2)
        or.w    d6,(a2)+
        and.w   d0,(a3)
        or.w    d7,(a3)+
        bra.s   boq_outl_h_loop_start
; ---------------------------------------------------------------------------

boq_outl_h_loop:                        
        move.w  d3,(a2)+
        swap    d3
        move.w  d3,(a3)+
        swap    d3

boq_outl_h_loop_start:                  
        dbf     d4,boq_outl_h_loop
        swap    d0
        swap    d6
        swap    d7
        and.w   d0,(a2)
        or.w    d6,(a2)
        and.w   d0,(a3)
        or.w    d7,(a3)
        bra.s   boq_outl_ok
; ---------------------------------------------------------------------------

boq_outl_h_xor:                         
        eor.w   d6,(a2)+
        eor.w   d7,(a3)+
        bra.s   boq_outl_h_xor_loop_start
; ---------------------------------------------------------------------------

boq_outl_h_xor_loop:                    
        eor.w   d3,(a2)+
        swap    d3
        eor.w   d3,(a3)+
        swap    d3

boq_outl_h_xor_loop_start:              
        dbf     d4,boq_outl_h_xor_loop
        swap    d6
        swap    d7
        eor.w   d6,(a2)
        eor.w   d7,(a3)
        bra.s   boq_outl_ok
; ---------------------------------------------------------------------------

boq_outl_h_single_word:                 
        swap    d2
        neg.b   d2
        addq.b  #7,d2
        lsr.b   d2,d0
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        move.w  d3,d6
        and.w   d0,d6
        swap    d6
        swap    d3
        move.w  d3,d6
        and.w   d0,d6
        btst    #3,sd_cattr(a0)         ; character attributes
        bne.s   boq_outl_h_sw_xor
        not.w   d0
        and.w   d0,(a3)
        or.w    d6,(a3)
        swap    d6
        and.w   d0,(a2)
        or.w    d6,(a2)
        bra.s   boq_outl_ok
; ---------------------------------------------------------------------------

boq_outl_h_sw_xor:                      
        eor.w   d6,(a3)
        swap    d6
        eor.w   d6,(a2)

boq_outl_ok:                            
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================

boq_prepare_ptrs:                       
        move.w  d2,d0
        mulu.w  #scr_incr,d0
        movea.l sd_scrb(a0),a1          ; base address of screen
        adda.l  d0,a1
        move.l  #$70007,d2
        and.l   d1,d2
        swap    d1
        lsr.w   #3,d1
        add.w   d1,d1
        rts
; ---------------------------------------------------------------------------
boq_filled:                             
        move.w  d2,d5
        swap    d2
        move.l  sd_imask(a0),d3         ; ink colour mask
        btst    #0,d2
        beq.s   boq_fill_prepare
        swap    d3

boq_fill_prepare:                       
        sub.w   d2,d5
        addq.w  #1,d5
        bsr.s   boq_prepare_ptrs
        adda.w  d1,a1
        lsr.w   #1,d1
        move.l  d1,d4
        swap    d4
        lsr.w   #3,d4
        sub.w   d1,d4
        subq.w  #1,d4
        swap    d2
        moveq   #$FFFFFFFF,d0
        lsr.b   d2,d0
        swap    d2
        tst.w   d4
        blt.s   boq_fill_single_word
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        swap    d0
        neg.b   d2
        addq.b  #7,d2
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        swap    d0
        swap    d2
        bra.s   boq_fill_prepare_imask
; ---------------------------------------------------------------------------

boq_fill_single_word:                   
        neg.b   d2
        addq.b  #7,d2
        lsr.b   d2,d0
        lsl.b   d2,d0
        move.b  d0,d7
        lsl.w   #8,d0
        move.b  d7,d0
        move.l  d3,d6
        and.w   d0,d6
        swap    d6
        and.w   d0,d6
        swap    d6
        btst    #3,sd_cattr(a0)         ; character attributes
        bne.s   boq_fill_swx_loop_start
        not.w   d0
        bra.s   boq_fill_sw_loop_start
; ---------------------------------------------------------------------------

boq_fill_sw_loop:                       
        and.w   d0,(a1)
        or.w    d6,(a1)
        swap    d6
        adda.w  #scr_incr,a1

boq_fill_sw_loop_start:                 
        dbf     d5,boq_fill_sw_loop
        bra     boq_ok
; ---------------------------------------------------------------------------

boq_fill_swx_loop:                      
        eor.w   d6,(a1)
        adda.w  #scr_incr,a1

boq_fill_swx_loop_start:                
        dbf     d5,boq_fill_swx_loop
        bra.s   boq_ok
; ---------------------------------------------------------------------------

boq_fill_prepare_imask:                 
        movea.l a1,a2
        move.l  d4,d2
        move.w  d3,d6
        and.w   d0,d6
        swap    d0
        swap    d6
        move.w  d3,d6
        and.w   d0,d6
        swap    d6
        swap    d3
        move.w  d3,d7
        and.w   d0,d7
        swap    d0
        swap    d7
        move.w  d3,d7
        and.w   d0,d7
        swap    d3
        btst    #3,sd_cattr(a0)         ; character attributes
        bne.s   boq_fillx_loop_start
        not.l   d0
        bra.s   boq_fill_loop_start
; ---------------------------------------------------------------------------

boq_fill_line_loop:                     
        and.w   d0,(a1)
        or.w    d6,(a1)+
        bra.s   boq_fill_word_loop_start
; ---------------------------------------------------------------------------

boq_fill_word_loop:                     
        move.w  d3,(a1)+

boq_fill_word_loop_start:               
        dbf     d2,boq_fill_word_loop
        swap    d0
        swap    d6
        and.w   d0,(a1)
        or.w    d6,(a1)
        swap    d0
        swap    d6
        move.w  d4,d2
        movea.l a2,a1
        adda.w  #scr_incr,a1
        movea.l a1,a2
        swap    d3
        exg     d6,d7

boq_fill_loop_start:                    
        dbf     d5,boq_fill_line_loop
        bra.s   boq_ok
; ---------------------------------------------------------------------------

boq_fillx_line_loop:                    
        eor.w   d6,(a1)+
        bra.s   boq_fillx_word_loop_start
; ---------------------------------------------------------------------------

boq_fillx_word_loop:                    
        eor.w   d3,(a1)+

boq_fillx_word_loop_start:              
        dbf     d2,boq_fillx_word_loop
        swap    d6
        eor.w   d6,(a1)+
        swap    d6
        move.w  d4,d2
        movea.l a2,a1
        adda.w  #scr_incr,a1
        movea.l a1,a2
        swap    d3
        exg     d6,d7

boq_fillx_loop_start:                   
        dbf     d5,boq_fillx_line_loop

boq_ok:                                 
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================

boq_rotate_coords:                      
        swap    d2
        move.w  sd_ysize(a0),d5         ; window height, exclusive of border
        subq.w  #1,d5
        sub.w   d2,d5
        move.w  d5,d2
        rts

; =============== S U B R O U T I N E =======================================

boq_coords_abs:                         
        tst.b   sys_dfrz(a6)            ; Display FRoZen (T or F)
        bne.s   boq_frozen
        cmp.w   sd_ysize(a0),d2         ; window height, exclusive of border
        bcc.s   boq_oor
        add.w   sd_ymin(a0),d2          ; window top pixel, exclusive of border
        swap    d2
        cmp.w   sd_ysize(a0),d2         ; window height, exclusive of border
        bcc.s   boq_oor
        add.w   sd_ymin(a0),d2          ; window top pixel, exclusive of border
        cmp.w   sd_xsize(a0),d1         ; window width, exclusive of border
        bcc.s   boq_oor
        add.w   sd_xmin(a0),d1          ; window left pixel, exclusive of border
        swap    d1
        cmp.w   sd_xsize(a0),d1         ; window width, exclusive of border
        bcc.s   boq_oor
        add.w   sd_xmin(a0),d1          ; window left pixel, exclusive of border
        move.w  #$8080,d7
        btst    #3,sys_qlmr(a6)         ; QL Master chip Register value
        beq.s   boq_coords_ret
        andi.l  #$FFFEFFFE,d1
        move.b  #$C0,d7

boq_coords_ret:                         
        swap    d1
        swap    d2
        rts
; ---------------------------------------------------------------------------

boq_frozen:                             
        moveq   #err.nc,d0              ; operation Not Complete
        bra.s   boq_ret4
; ---------------------------------------------------------------------------

boq_oor:                                
        moveq   #0,d0

boq_ret4:                               
        addq.l  #4,sp
        rts

; =============== S U B R O U T I N E =======================================
; err = Q_ERR - Returned trapped error or 0

q_err:                                  
        moveq   #2,d1
        movea.w qa.resri,a2    
        jsr     (a2)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        subq.l  #2,a1
        move.w  sb_erno+2(a6),(a6,a1.l) ; long    last error number
        move.l  a1,sys_sbtb(a6)         ; Slave Block Table Base
        moveq   #nt.in,d4
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; Q_ERR_LIST - List Q_ERR_ON enabled keywords

q_err_list:                             
        st      d7                      ; Set for "list" mode
        move.l  sb_chanb(a6),d0         ; channel table base
        movea.l (a6,d0.l),a0            ; Channel table base (absolute)
        movea.l (a0),a0                 ; First channel
        bra.s   q_err_do

; =============== S U B R O U T I N E =======================================
; Q_ERR_OFF keyword$

q_err_off:                              
        sf      d7                      ; Set for "off" mode
        cmpa.l  a3,a5
        bne.s   q_err_names_lookup

q_err_do:                               
        movea.l sb_nmtbb(a6),a2         ; name table base
        movea.l sb_nmtbp(a6),a3         ; name table pointer

q_err_name_lookup_loop:                 
        move.w  (a6,a2.l),d0
        cmpi.w  #nt.mcprc<<8,d0
        bne.s   q_err_name_table_next
        move.l  4(a6,a2.l),d2
        bpl.s   q_err_name_table_next
        tst.b   d7                      ; 0 = get/set, ff = list
        beq.s   q_err_clear_name
        move.w  nt_name(a6,a2.l),d0
        movea.l sb_nmlsb(a6),a1         ; name list base
        adda.w  d0,a1
        move    sr,d6
        trap    #0                      ; Go supervisor so we can make pointers absolute
        adda.l  a6,a1
        moveq   #0,d2
        move.b  (a1)+,d2                ; Length of name
        suba.l  a0,a0
        moveq   #-1,d3
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        trap    #3
        move    d6,sr
        moveq   #' ',d1
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        trap    #3
        bra.s   q_err_name_table_next
; ---------------------------------------------------------------------------

q_err_clear_name:                       
        bsr.s   q_err_do_disable

q_err_name_table_next:                  
        addq.l  #nt.len,a2
        cmpa.l  a2,a3
        bne.s   q_err_name_lookup_loop
        tst.b   d7
        beq.s   q_err_list_ok
        moveq   #10,d1
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        trap    #3

q_err_list_ok:                          
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; Q_ERR_ON keyword$

q_err_on:                               
        st      d7

q_err_names_lookup:                     
        movea.l a5,a4

q_err_names_loop:                       
        cmpa.l  a3,a4
        beq.s   q_err_rts
        lea     nt.len(a3),a5
        movea.w sb.gtstr,a2    
        jsr     (a2)
        bne.s   q_err_rts
        move.w  (a6,a1.l),d0
        lea     2(a1),a0
        bsr     q_err_lookup_name
        bne.s   q_err_name_not_found
        cmpi.w  #nt.mcprc<<8,d1
        bne.s   q_err_ipar
        tst.b   d7
        beq.s   q_err_disable
        bsr.s   q_err_enable
        bne.s   q_err_rts

q_err_next:                             
        movea.l a5,a3
        bra.s   q_err_names_loop
; ---------------------------------------------------------------------------

q_err_name_not_found:                   
        tst.l   sb_grphb(a6)            ; Are we in compiled code?
        beq.s   q_err_next              ; Yes, just continue

q_err_ipar:                             
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)

q_err_rts:                              
        rts
; ---------------------------------------------------------------------------

q_err_disable:                          
        tst.l   d2
        bpl.s   q_err_ipar
        bsr.s   q_err_do_disable
        bra.s   q_err_next

; =============== S U B R O U T I N E =======================================

q_err_do_disable:                       
        lsl.l   #1,d2                   ; Clear sign bit
        lsr.l   #1,d2
        movea.l d2,a0
        move.l  -(a0),nt_value(a6,a2.l) ; Restore previous function address
        clr.l   (a0)                    ; Mark wrapper as free
        rts

; =============== S U B R O U T I N E =======================================

q_err_enable:                           
        tst.l   4(a6,a2.l)
        bmi.s   q_err_create_wrappers_exit
        move.l  sbq_qerr_wrappers(a6),d0
        bne.s   q_err_check_wrapper_block

q_err_create_more_wrappers:             
        movem.l a2-a3,-(sp)
        moveq   #-1,d2
        move.l  #512,d1
        moveq   #sms.achp,d0            ; Allocate space in Common HeaP
        trap    #1
        movem.l (sp)+,a2-a3
        tst.l   d0
        bne.s   q_err_create_wrappers_exit
        move.l  sbq_qerr_wrappers(a6),d0
        move.l  a0,sbq_qerr_wrappers(a6)
        move.l  d0,(a0)+
        moveq   #27,d1                  ; 512 / 18 = ~28

generate_wrappers:                      
        clr.l   (a0)+
        move.l  #$207AFFFA,(a0)+        ; move.l -4(pc),a0
        move.l  #$4E902D40,(a0)+        ; jsr (a0) / move.l d0,$C2(a6)
        move.l  #$C27000,(a0)+          ; moveq #0,d0
        move.w  #$4E75,(a0)+            ; rts
        dbf     d1,generate_wrappers

q_err_check_wrapper_block:              
        movea.l sbq_qerr_wrappers(a6),a0

q_err_check_next_wrapper_block:         
        moveq   #27,d1
        move.l  (a0)+,d0

q_err_next_wrapper:                     
        tst.l   (a0)
        beq.s   q_err_wrapper_empty
        adda.w  #18,a0                  ; Wrapper size
        dbf     d1,q_err_next_wrapper
        tst.l   d0
        beq.s   q_err_create_more_wrappers
        movea.l d0,a0
        bra.s   q_err_check_next_wrapper_block
; ---------------------------------------------------------------------------

q_err_wrapper_empty:                    
        move.l  nt_value(a6,a2.l),(a0)+
        move.l  a0,d0
        ori.l   #$80000000,d0           ; Mark function as wrapped (!!WTF!!)
        move.l  d0,nt_value(a6,a2.l)
        moveq   #0,d0

q_err_create_wrappers_exit:             
        rts

; =============== S U B R O U T I N E =======================================

q_err_lookup_name:                      
        movem.l a3-a4,-(sp)
        movea.l sb_nmtbb(a6),a2         ; name table base

q_err_name_loop:                        
        movea.w nt_name(a6,a2.l),a4
        adda.l  sb_nmlsb(a6),a4         ; name list base
        cmp.b   (a6,a4.l),d0
        beq.s   q_err_name_size_match

q_err_name_next:                        
        addq.l  #nt.len,a2
        cmpa.l  sb_nmtbp(a6),a2         ; name table pointer
        bls.s   q_err_name_loop
        movem.l (sp)+,a3-a4
        moveq   #err.fdnf,d0            ; File or Device Not Found
        rts
; ---------------------------------------------------------------------------

q_err_name_size_match:                  
        addq.l  #1,a4
        move.w  d0,d1
        subq.w  #1,d1
        movea.l a0,a3

q_err_name_compare:                     
        move.b  (a6,a4.l),d2
        move.b  (a6,a3.l),d3
        ori.b   #' ',d2
        ori.b   #' ',d3
        cmp.b   d2,d3
        bne.s   q_err_name_next
        addq.l  #1,a3
        addq.l  #1,a4
        dbf     d1,q_err_name_compare
        movem.l (sp)+,a3-a4
        move.w  (a6,a2.l),d1
        move.l  nt_value(a6,a2.l),d2
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------
vfrsp_ret_d4:                           
        move.l  a1,sb_arthp(a6)         ; arithmetic stack pointer
        move.w  d4,(a6,a1.l)
        moveq   #nt.in,d4
        moveq   #0,d0

vgrsp_ret:                              
        rts
; ---------------------------------------------------------------------------

vgrsp_ipar:                             
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        bra.s   vgrsp_ret

; =============== S U B R O U T I N E =======================================
; VGRSP x,y - Get memory needed for sprite

vgrsp:                                  
        movea.w sb.gtint,a2    
        jsr     (a2)
        bne.s   vgrsp_ret
        subq.w  #2,d3                   ; 2 parameters
        bne.s   vgrsp_ipar
        moveq   #15,d4
        add.w   (a6,a1.l),d4            ; x
        andi.w  #$FFF0,d4               ; Round x up to nearest 16
        lsr.w   #1,d4                   ; / 2
        mulu.w  2(a6,a1.l),d4           ; * y
        addi.w  #$18,d4                 ; Sprite header size
        addq.l  #2,a1
        bra.s   vfrsp_ret_d4

; =============== S U B R O U T I N E =======================================
; VGPAT patt_addr,pic_addr - Make sprite out of PIC

vgpat:                                  
        movea.w sb.gtlin,a2    
        jsr     (a2)
        bne.s   vgpat_ret
        movea.l (a6,a1.l),a0            ; patt_addr
        movea.l 4(a6,a1.l),a2           ; pic_addr
        subq.l  #4,a2                   ; pic_addr-4
        move.l  a0,d0
        move.l  a2,d1
        or.l    d1,d0
        ror.b   #1,d0                   ; Check no address is odd
        bcs.s   vgpat_ipar              ; Error otherwise
        cmpi.w  #$4AFC,pic_id+4(a2)     ; $4AFC
        bne.s   vgpat_ipar
        move.w  #$100,d0                ; Sprite mode
        tst.b   pic_mode+4(a2)          ; Mode of image
        beq.s   loc_1128C
        addq.w  #1,d0                   ; $101 = mode 8

loc_1128C:                              
        move.w  d0,(a0)+                ; Pattern mode
        clr.w   (a0)+                   ; Version / sprite control
        move.w  pic_xs+4(a2),d0         ; Width in pixels
        andi.w  #$FFF0,d0
        move.w  d0,d2
        beq.s   vgpat_ipar
        move.w  d0,(a0)+                ; x-size
        move.w  pic_ys+4(a2),(a0)+      ; y-size
        beq.s   vgpat_ipar
        clr.l   (a0)+                   ; Offset 0
        move.l  #$C,(a0)+               ; Relative pointer to pattern
        clr.l   (a0)+                   ; No mask
        clr.l   (a0)+                   ; No next sprite
        lea     pic_image+4(a2),a1      ; Image data
        move.w  pic_incr+4(a2),d1
        asr.w   #2,d2                   ; width / 4
        sub.w   d2,d1                   ; incr - (width / 4)
        asr.w   #2,d2                   ; In long words
        subq.w  #1,d2
        move.w  pic_ys+4(a2),d0         ; Height in pixels
        bra.s   vgpat_start
; ---------------------------------------------------------------------------

vgpart_line_loop:                       
        move.w  d2,d3

vgpart_copy_loop:                       
        move.l  (a1)+,(a0)+
        dbf     d3,vgpart_copy_loop
        adda.w  d1,a1                   ; Add spare bytes

vgpat_start:                            
        dbf     d0,vgpart_line_loop
        moveq   #0,d0

vgpat_ret:                              
        rts
; ---------------------------------------------------------------------------

vgpat_ipar:                             
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        bra.s   vgpat_ret

; =============== S U B R O U T I N E =======================================
; A_MONO addr - OR red and green colour bits to white

a_mono:                                 
        movea.w sb.gtlin,a2    
        jsr     (a2)
        tst.w   d3
        beq.s   err_ipar
        move.l  (a6,a1.l),d1
        move.w  #$3FFF,d0
        movea.l d1,a0

a_mono_loop:                            
        move.w  (a0),d1
        rol.w   #8,d1
        or.w    d1,(a0)+                ; Red+green=white
        dbf     d0,a_mono_loop
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; SWAP addr - Mirror QL screen in y direction

swap:                                   
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #1,d3
        bne.s   err_ipar
        move.l  (a6,a1.l),d1            ; Base address
        movea.l d1,a0
        movea.l d1,a1
        adda.l  #scr_size-scr_incr,a1
        move.w  #256/2-1,d0

swap_y_loop:                            
        moveq   #(scr_incr/4)-1,d1

swap_x_loop:                            
        move.l  (a0),d2
        move.l  (a1),(a0)+
        move.l  d2,(a1)+
        dbf     d1,swap_x_loop
        suba.l  #scr_incr*2,a1
        dbf     d0,swap_y_loop
        clr.l   d0
        rts
; ---------------------------------------------------------------------------

err_ipar:                               
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts

; =============== S U B R O U T I N E =======================================
; MIX src,dest,bytes,mode (0 = or, 1 = eor) - OR or XOR a block of memory

mix:                                    
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #4,d3
        bne.s   err_ipar
        move.l  (a6,a1.l),d4            ; src
        move.l  4(a6,a1.l),d5           ; dest
        move.l  8(a6,a1.l),d0           ; len
        move.l  12(a6,a1.l),d1          ; mode
        subq.l  #1,d0
        movea.l d4,a1
        movea.l d5,a0
        tst.l   d1
        bne.s   mix_eor_loop

mix_or_loop:                            
        move.b  (a1)+,d1
        or.b    d1,(a0)+
        dbf     d0,mix_or_loop
        clr.l   d0
        rts
; ---------------------------------------------------------------------------

mix_eor_loop:                           
        move.b  (a1)+,d1
        eor.b   d1,(a0)+
        dbf     d0,mix_eor_loop
        clr.l   d0
        rts

; =============== S U B R O U T I N E =======================================
; MONOISE addr,bytes per line,lines/2 - Convert colours to B/W

monoise:                                
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #3,d3                   ; 3 parameters
        bne     err_ipar2
        move.l  (a6,a1.l),d1            ; Addr
        move.l  4(a6,a1.l),d2           ; Bytes
        move.l  8(a6,a1.l),d0           ; Lines/2 because every other lines is stippled differently
        lsr.l   #1,d2                   ; In words
        subq.l  #1,d2
        movea.l d2,a5
        movea.l d1,a0
        lea     m8_mask_table(pc),a3
        lea     col_index_table(pc),a4
        clr.l   d3

monoise_line_loop:                      
        move.l  a5,d1
        lea     monoise_table1(pc),a2

monoise_loop1:                          
        bsr.s   col_substitution        ; a0 = image base, a2 = dest col table, a3 = mask base, a4 = source col table
        dbf     d1,monoise_loop1
        move.l  a5,d1
        lea     monoise_table2(pc),a2

monoise_loop2:                          
        bsr.s   col_substitution        ; a0 = image base, a2 = dest col table, a3 = mask base, a4 = source col table
        dbf     d1,monoise_loop2
        dbf     d0,monoise_line_loop
        clr.l   d0
        rts

; =============== S U B R O U T I N E =======================================
; a0 = image base, a2 = dest col table, a3 = mask base, a4 = source col table

col_substitution:                       
        moveq   #3,d2                   ; 4 pixels
        clr.l   d4

col_next_pixel:                         
        move.w  (a0),d3                 ; Get pixel word
        lsl.w   d4,d3
        andi.w  #$C0C0,d3               ; Mask mode 8 pixel bits
        clr.l   d7

col_table_loop:                         
        move.w  (a4,d7.l),d6
        cmp.w   d3,d6
        beq.s   col_found
        addq.l  #2,d7
        cmpi.w  #32,d7
        blt.s   col_table_loop
        bra.s   col_skip_pixel
; ---------------------------------------------------------------------------

col_found:                              
        move.w  (a2,d7.l),d5
        lsr.w   d4,d5
        move.w  (a3,d4.l),d6
        and.w   d6,(a0)
        or.w    d5,(a0)

col_skip_pixel:                         
        addq.w  #2,d4
        dbf     d2,col_next_pixel
        adda.l  #2,a0
        rts
; ---------------------------------------------------------------------------
col_index_table:dc.w 0,$40,$4000,$4040,$C0,$80,$4080,$40C0,$C000,$8000,$8040,$C040,$C0C0,$8080,$80C0,$C080 
monoise_table1:dc.w 0,$4040,$4040,$4040,$4040,$4040,$4040,$4040,$4040,$4040,$4040,$4040,$C0C0,$8080,$4040,$8080 
monoise_table2:dc.w 0,0,$8080,$4040,0,0,$8080,$C0C0,$8080,$8080,$8080,$C0C0,$C0C0,$8080,$C0C0,$C0C0 
m8_mask_table:dc.w $3F3F,$CFCF,$F3F3,$FCFC 

; =============== S U B R O U T I N E =======================================
; CONVERT addr,bytes,lines

convert:                                
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #3,d3
        bne     err_ipar2
        move.l  (a6,a1.l),d1            ; Address
        move.l  4(a6,a1.l),d2           ; Bytes
        move.l  8(a6,a1.l),d0           ; Lines
        lsr.l   #1,d2
        subq.l  #1,d2
        movea.l d2,a5
        movea.l d1,a0
        lea     m8_mask_table(pc),a3
        clr.l   d3

convert_lines_loop:                     
        move.l  a5,d1
        lea     convert_col_table1(pc),a2

convert_word_loop1:                     
        bsr.s   convert_word
        dbf     d1,convert_word_loop1
        move.l  a5,d1
        lea     convert_col_table2(pc),a2

convert_word_loop2:                     
        bsr.s   convert_word
        dbf     d1,convert_word_loop2
        dbf     d0,convert_lines_loop
        clr.l   d0
        rts

; =============== S U B R O U T I N E =======================================

convert_word:                           
        moveq   #3,d2                   ; 4 pixels
        clr.l   d4

convert_pixel_loop:                     
        move.w  (a0),d3                 ; Image word
        lsl.w   d4,d3
        andi.w  #$80C0,d3               ; %A0000000BC000000 Mode 8 pixel (minus flash bit)
        move.w  d3,d5
        lsr.w   #7,d5                   ; %0000000A0000000B
        or.w    d5,d3                   ; %A000000ABC00000B
        lsr.w   #5,d3                   ; %00000A000000ABC0
        andi.w  #$E,d3                  ; %000000000000ABC0 - All bits shifted together
        move.w  (a2,d3.l),d5            ; Table lookup
        lsr.w   d4,d5                   ; Pixel shift
        move.w  (a3,d4.l),d6            ; Pixel mask
        and.w   d6,(a0)
        or.w    d5,(a0)
        addq.w  #2,d4
        dbf     d2,convert_pixel_loop
        adda.l  #2,a0
        rts
; ---------------------------------------------------------------------------
convert_col_table2:dc.w 0,$40,$C0,$4080,$C000,$C040,$C080,$C0C0 
convert_col_table1:dc.w 0,$80,$C0,$8040,$C000,$C080,$C0C0,$C0C0 

; =============== S U B R O U T I N E =======================================
; ENHANCE addr - Blur picture?

enhance:                                
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #1,d3
        bne     err_ipar2
        move.l  (a6,a1.l),d1
        movea.l d1,a0
        clr.w   d7                      ; x-pos

enhance_x_loop:                         
        clr.w   d6                      ; y-pos

enhance_y_loop:                         
        clr.l   d0
        move.w  d6,d4                   ; y
        lsl.w   #7,d4                   ; y * 128
        move.w  d7,d5                   ; x
        lsr.w   #3,d5
        lsl.w   #1,d5                   ; INT(x / 8) * 2 = x address
        add.w   d5,d4                   ; Now in line
        lea     (a0,d4.w),a1            ; Now absolute
        movea.l a1,a2
        movea.l a1,a3
        adda.l  #scr_incr,a3            ; Pixel word below
        movea.l a3,a4
        move.w  d7,d5                   ; x
        andi.w  #7,d5                   ; pixel within word
        move.w  d5,-(sp)
        cmpi.w  #7,d5
        bne.s   enhance_start
        addq.l  #2,a2                   ; Pixel word to right (it spilled into next word)
        addq.l  #2,a4                   ; Pixel word down and right (it spilled into next word)

enhance_start:                          
        move.w  #$8080,d2               ; Mask mode 4 pixel
        move.w  (a1),d1                 ; Main pixel word
        move.w  (a3),d3                 ; Pixel word below
        lsl.w   d5,d1                   ; Shift to mask
        lsl.w   d5,d3
        and.w   d2,d1                   ; Mask it
        and.w   d2,d3
        move.w  d1,d4                   ; %A0000000B0000000 - Main pixel bits
        lsr.w   #7,d1                   ; %0000000A0000000B
        lsr.w   #8,d4                   ; %00000000A0000000
        lsr.w   #6,d4                   ; %00000000000000A0
        or.w    d4,d1                   ; %00000000000000AB
        add.b   d1,d0
        move.w  d3,d4
        lsr.w   #7,d3
        lsr.w   #8,d4
        lsr.w   #6,d4
        or.w    d4,d3
        add.b   d3,d0                   ; Add pixel below
        move.w  (a2),d1                 ; Pixel word of right pixel
        move.w  (a4),d3                 ; Pixel word of down/right pixel
        move.w  d7,d5
        addq.w  #1,d5                   ; The right pixel
        andi.w  #7,d5                   ; Wrap around (we'll have advanced to the next word in this case)
        lsl.w   d5,d1
        lsl.w   d5,d3
        and.w   d2,d1
        and.w   d2,d3
        move.w  d1,d4
        lsr.w   #7,d1
        lsr.w   #8,d4
        lsr.w   #6,d4
        or.w    d4,d1
        add.b   d1,d0                   ; Add pixel value of right pixel
        move.w  d3,d4
        lsr.w   #7,d3
        lsr.w   #8,d4
        lsr.w   #6,d4
        or.w    d4,d3
        add.b   d3,d0                   ; Add pixel value of right/down pixel
        cmpi.b  #2,d0
        bgt.s   enhance_more_2
        clr.w   d0
        bra.s   enhance_write
; ---------------------------------------------------------------------------

enhance_more_2:                         
        cmpi.b  #6,d0
        bgt.s   enhance_more_6
        move.w  #$80,d0
        bra.s   enhance_write
; ---------------------------------------------------------------------------

enhance_more_6:                         
        cmpi.b  #9,d0
        bgt.s   enhance_more_9
        move.w  #$8000,d0
        bra.s   enhance_write
; ---------------------------------------------------------------------------

enhance_more_9:                         
        move.w  #$8080,d0

enhance_write:                          
        move.w  (a1),d1
        move.w  (sp)+,d3
        lsr.w   d3,d2
        eori.w  #$FFFF,d2
        and.w   d2,d1
        lsr.w   d3,d0
        or.w    d0,d1
        move.w  d1,(a1)
        addq.w  #1,d6
        cmpi.w  #255,d6
        blt     enhance_y_loop
        clr.w   d6
        addq.w  #1,d7
        cmpi.w  #511,d7
        blt     enhance_x_loop
        clr.l   d0
        rts

; =============== S U B R O U T I N E =======================================
; OUTLINE addr - Outline screen

outline:                                
        movea.w sb.gtlin,a2    
        jsr     (a2)
        subq.w  #1,d3
        bne     err_ipar2
        move.l  (a6,a1.l),d1
        movea.l d1,a0
        clr.w   d7                      ; x

outline_next_x:                         
        clr.w   d6                      ; y

outline_next_y:                         
        clr.l   d0
        move.w  d6,d4                   ; y
        lsl.w   #7,d4                   ; y * 128
        move.w  d7,d5                   ; x
        lsr.w   #3,d5
        lsl.w   #1,d5                   ; INT(x / 8) * 2 = x address
        add.w   d4,d5
        lea     (a0,d5.w),a1            ; Abs pixel word
        move.w  (a1),d0                 ; Main pixel word
        move.w  d7,d5                   ; x
        andi.w  #7,d5
        lsl.w   d5,d0
        andi.w  #$8080,d0
        move.w  d0,d1                   ; %A0000000B0000000 - Main pixel bits
        lsr.w   #7,d0                   ; %0000000A0000000B
        lsr.w   #8,d1                   ; %00000000A0000000
        lsr.w   #6,d1                   ; %00000000000000A0
        or.w    d1,d0                   ; %00000000000000AB
        movea.l a1,a2
        adda.l  #scr_incr,a2
        move.w  (a2),d1                 ; Pixel word below
        lsl.w   d5,d1
        andi.w  #$8080,d1
        move.w  d1,d2
        lsr.w   #7,d1
        lsr.w   #8,d2
        lsr.w   #6,d2
        or.w    d2,d1
        cmp.w   d1,d0                   ; Pixel same as the one below?
        bne.s   outline_different
        move.w  d7,d5                   ; x
        addq.w  #1,d5                   ; Next pixel in x direction
        lsr.w   #3,d5
        lsl.w   #1,d5
        add.w   d4,d5
        lea     (a0,d5.w),a3            ; Pixel to the right
        move.w  (a3),d1
        move.w  d7,d5
        addq.w  #1,d5
        andi.w  #7,d5
        lsl.w   d5,d1
        andi.w  #$8080,d1
        move.w  d1,d2
        lsr.w   #7,d1
        lsr.w   #8,d2
        lsr.w   #6,d2
        or.w    d2,d1
        cmp.w   d1,d0                   ; Pixel to the right the same?
        bne.s   outline_different
        movea.l a3,a4
        adda.l  #scr_incr,a4            ; Pixel down and right
        move.w  (a4),d1
        lsl.w   d5,d1
        andi.w  #$8080,d1
        move.w  d1,d2
        lsr.w   #7,d1
        lsr.w   #8,d2
        lsr.w   #6,d2
        or.w    d2,d1
        cmp.w   d1,d0                   ; Same as pixel down/right
        bne.s   outline_different
        clr.w   d0                      ; Black
        bra.s   outline_write
; ---------------------------------------------------------------------------

outline_different:                      
        move.w  #$8080,d0               ; White

outline_write:                          
        move.w  d7,d5
        andi.w  #7,d5
        move.w  (a1),d1
        move.w  #$8080,d2
        lsr.w   d5,d2
        eori.w  #$FFFF,d2
        and.w   d2,d1
        lsr.w   d5,d0
        or.w    d0,d1
        move.w  d1,(a1)
        addq.w  #1,d6
        cmpi.w  #255,d6
        blt     outline_next_y
        clr.w   d6
        addq.w  #1,d7
        cmpi.w  #511,d7
        blt     outline_next_x
        clr.l   d0
        rts
; ---------------------------------------------------------------------------

err_ipar2:                              
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts

; =============== S U B R O U T I N E =======================================
; s$ = C_STRG$(index)

c_strg$:                                
        bsr     c_getint_d1             ; Get exactly one integer parameter in D1
        bne.s   c_ret
        moveq   #0,d4                   ; Item type
        bsr     c_get_item
        bne.s   c_strg$_empty
        addq.w  #2,a0
        adda.w  (a0),a0
        addq.w  #2,a0
        movea.l a0,a4
        move.w  (a0),d1                 ; BUG! Was d0!!!
        addq.w  #2,d1                   ; BUG! Was d0!!!
        ext.l   d1                      ; BUG! Was d0!!!
        move.l  a1,sb_arthp(a6)         ; arithmetic stack pointer
        movea.w qa.resri,a0    
        jsr     (a0)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.w  (a4)+,d0
; +++ BUG! We also need the lines
        moveq   #3,d1
        add.w   d0,d1
        bclr    #0,d1
        sub.w   d1,a1
        move.l  a1,sb_arthp(a6)
; --- BUG
        movea.l a1,a2
        move.w  d0,(a2,a6.l)
        addq.l  #2,a2
        bra.s   c_strg$_copy
; ---------------------------------------------------------------------------

c_strg$_loop:                           
        move.b  (a4)+,(a2,a6.l)
        addq.l  #1,a2

c_strg$_copy:                           
        dbf     d0,c_strg$_loop
        moveq   #nt.st,d4

c_ok:                                   
        moveq   #0,d0

c_ret:                                  
        rts
; ---------------------------------------------------------------------------

c_strg$_empty:                          
        clr.w   (a1,a6.l)
        moveq   #nt.st,d4
        bra.s   c_ok

; =============== S U B R O U T I N E =======================================
; s$ = C_CHAR$(index)

c_char$:                                
        bsr.s   c_getint_d1             ; Get exactly one integer parameter in D1
        bne.s   c_ret
        moveq   #2,d4                   ; Item type
        bsr.s   c_get_item
        bne.s   c_strg$_empty
        addq.w  #2,a0
        adda.w  (a0),a0
        move.w  #1,(a1,a6.l)            ; Return as single char string
        move.b  (a0),2(a1,a6.l)
        moveq   #nt.st,d4
        bra.s   c_ok

; =============== S U B R O U T I N E =======================================
; c = C_CODE(index)

c_code:                                 
        bsr.s   c_getint_d1             ; Get exactly one integer parameter in D1
        bne.s   c_ret
        moveq   #4,d4                   ; Item type
        bsr.s   c_get_item
        addq.w  #2,a0
        adda.w  (a0),a0
        move.b  (a0),d0
        ext.w   d0
        move.w  d0,(a1,a6.l)
        moveq   #nt.in,d4
        bra.s   c_ok

; =============== S U B R O U T I N E =======================================
; b = C_BYTE(index)

c_byte:                                 
        bsr.s   c_getint_d1             ; Get exactly one integer parameter in D1
        bne.s   c_ret
        moveq   #8,d4                   ; Item type
        bsr.s   c_get_item
        addq.w  #2,a0
        adda.w  (a0),a0
        move.b  (a0),d0
        ext.w   d0
        move.w  d0,(a1,a6.l)
        moveq   #nt.in,d4
        bra.s   c_ok

; =============== S U B R O U T I N E =======================================
; w = C_WORD(index)

c_word:                                 
        bsr.s   c_getint_d1             ; Get exactly one integer parameter in D1
        bne.s   c_ret
        moveq   #10,d4                  ; Item type
        bsr.s   c_get_item
        addq.w  #2,a0
        adda.w  (a0),a0
        move.w  (a0),(a1,a6.l)
        moveq   #nt.in,d4
        bra.s   c_ok

; =============== S U B R O U T I N E =======================================
; Get exactly one integer parameter in D1

c_getint_d1:                            
        movea.w sb.gtint,a0    
        jsr     (a0)
        bne.s   c_getint_ipar
        subq.w  #1,d3
        bne.s   c_getint_ipar
        move.w  (a1,a6.l),d1
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

c_getint_ipar:                          
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts

; =============== S U B R O U T I N E =======================================

c_get_item:                             
        move.w  d1,d0
        lea     config(pc),a0
        bsr.s   c_skip_string
        bsr.s   c_skip_string

c_get_item_loop:                        
        move.b  (a0),d3
        cmp.b   d4,d3
        beq.s   c_get_item_check_index

c_get_item_next:                        
        adda.w  #$C,a0
        move.w  (a0),d1
        addq.w  #1,d1
        beq.s   c_get_item_nf
        bra.s   c_get_item_loop
; ---------------------------------------------------------------------------

c_get_item_check_index:                 
        subq.w  #1,d0
        bne.s   c_get_item_next
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

c_get_item_nf:                          
        moveq   #err.fdnf,d0            ; File or Device Not Found
        rts

; =============== S U B R O U T I N E =======================================

c_skip_string:                          
        move.w  (a0)+,d1
        btst    #0,d1
        beq.s   c_skip_string_ret
        addq.w  #1,d1

c_skip_string_ret:                      
        adda.w  d1,a0
        rts
; ---------------------------------------------------------------------------
        dc.b '<<QCFX>>01'
config: dc.w 7                          
        dc.b 'QDesign',0
        dc.w 4
        dc.b '4.04'
; Opt. X-resolution (512-3200)
        dc.b $A                         ; Type: word
        dc.b 0                          ; Keystroke
        dc.w cfg_xres-*                 ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_xres-*                 ; Description
        dc.w attr_xres-*                ; Attributes
; Opt. Y-resolution (256-4800)
        dc.b $A                         ; Type: word
        dc.b 0                          ; Keystroke
        dc.w cfg_yres-*                 ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_yres-*                 ; Description
        dc.w attr_yres-*                ; Attributes
; Start resolution
        dc.b 4                          ; Type: code
        dc.b 0                          ; Keystroke
        dc.w cfg_start_res-*            ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_start_res-*            ; Description
        dc.w attr_start_res-*           ; Attributes
; QDesign graphic mode
        dc.b 4                          ; Type: code
        dc.b 0                          ; Keystroke
        dc.w cfg_graphics_mode-*        ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_graphics_mode-*        ; Description
        dc.w attr_graphics_mode-*       ; Attributes
; Printertyp
        dc.b 4                          ; Type: code
        dc.b 0                          ; Keystroke
        dc.w cfg_printer_type-*         ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_printer_type-*         ; Description
        dc.w attr_printer_type-*        ; Attributes
; Multitasking printing
        dc.b 4                          ; Type: code
        dc.b 0                          ; Keystroke
        dc.w cfg_printer_multitask-*    ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_printer_multitask-*    ; Description
        dc.w attr_printer_multitask-*   ; Attributes
; Do you have real sub-directories ?
        dc.b 4                          ; Type: code
        dc.b 0                          ; Keystroke
        dc.w cfg_real_subdir-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_real_subdir-*          ; Description
        dc.w attr_real_subdir-*         ; Attributes
; Pointer speed 1 (0-9)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_mouse_speed-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_mouse_speed-*          ; Description
        dc.w attr_mouse_speed-*         ; Attributes
; Pointer speed 2 (0-9)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_mouse_speed2-*         ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_mouse_speed2-*         ; Description
        dc.w attr_mouse_speed2-*        ; Attributes
; Pointer wakeup  (0-9)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_mouse_wakeup-*         ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_mouse_wakeup-*         ; Description
        dc.w attr_mouse_wakeup-*        ; Attributes
; Grid - width   (4-60)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_grid_width-*           ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_grid_width-*           ; Description
        dc.w attr_grid_width-*          ; Attributes
; Max. no. of QL-fonts (1-28)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_ql_font_max-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_ql_font_max-*          ; Description
        dc.w attr_ql_font_max-*         ; Attributes
; Buffer size for fill (4-128 Kb)
        dc.b 8                          ; Type: byte
        dc.b 0                          ; Keystroke
        dc.w cfg_fill_buffer_size-*     ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_fill_buffer_size-*     ; Description
        dc.w attr_fill_buffer_size-*    ; Attributes
; Help - filename
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_help_filename-*        ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_help_filename-*        ; Description
        dc.w atr_help_filename-*        ; Attributes
; Config - filename
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_config_filename-*      ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_config_filename-*      ; Description
        dc.w attr_config_filename-*     ; Attributes
; Laserprinter - filename
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_printer_filename-*     ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_printer_filename-*     ; Description
        dc.w attr_printer_filename-*    ; Attributes
; Default - filename
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_default_filename-*     ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_default_filename-*     ; Description
        dc.w attr_default_filename-*    ; Attributes
; QL-font extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_ql_font_ext-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_ql_font_ext-*          ; Description
        dc.w attr_ql_font_ext-*         ; Attributes
; Hi-font extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_hi_font_ext-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_hi_font_ext-*          ; Description
        dc.w attr_hi_font_ext-*         ; Attributes
; Screen  extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_scr_ext-*              ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_scr_ext-*              ; Description
        dc.w attr_scr_ext-*             ; Attributes
; Page    extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_page_ext-*             ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_page_ext-*             ; Description
        dc.w attr_page_ext-*            ; Attributes
; Cut     extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_cut_ext-*              ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_cut_ext-*              ; Description
        dc.w attr_cut_ext-*             ; Attributes
; Pattern extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_pattern_ext-*          ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_pattern_ext-*          ; Description
        dc.w attr_pattern_ext-*         ; Attributes
; Config  extension
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_config_ext-*           ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_config_ext-*           ; Description
        dc.w attr_config_ext-*          ; Attributes
; Local default device to dump
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_dump_dev-*             ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_dump_dev-*             ; Description
        dc.w attr_dump_dev-*            ; Attributes
; Local default device for fonts and data
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_prog_dir-*             ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_prog_dir-*             ; Description
        dc.w attr_prog_dir-*            ; Attributes
; Position X-fakt 0-200
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_x_factor-*             ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_x_factor-*             ; Description
        dc.w attr_x_factor-*            ; Attributes
; Position Y-fakt 0-200
        dc.b 0                          ; Type: string
        dc.b 0                          ; Keystroke
        dc.w cfg_y_factor-*             ; Item
        dc.w 0                          ; Pre processing routine
        dc.w 0                          ; Post processing routine
        dc.w txt_y_factor-*             ; Description
        dc.w attr_y_factor-*            ; Attributes
        dc.w -1
        dc.w 0
cfg_xres:dc.w $780                      
txt_xres:dc.w 29                        
        dc.b 'Opt. X-resolution (512-3200) ',0
attr_xres:dc.w $200,$C80                
                                        ; Min/max
cfg_yres:dc.w $708                      
txt_yres:dc.w 29                        
        dc.b 'Opt. Y-resolution (256-4800) ',0
attr_yres:dc.w $100,$12C0               
                                        ; Min/max
cfg_start_res:dc.b 3                    
        dc.b   0
txt_start_res:dc.w 17                   
        dc.b 'Start resolution ',0
attr_start_res:dc.b 1                   
        dc.b 0
        dc.w 9
        dc.b '512 x 256',0
        dc.b 2
        dc.b 0
        dc.w 9
        dc.b '512 x 512',0
        dc.b 3
        dc.b 0
        dc.w 9
        dc.b '720 x 640',0
        dc.b 4
        dc.b 0
        dc.w 9
        dc.b '640 x 400',0
        dc.b 5
        dc.b 0
        dc.w 9
        dc.b '640 x 640',0
        dc.b 6
        dc.b 0
        dc.w 9
        dc.b '960 x 640',0
        dc.b 7
        dc.b 0
        dc.w 14
        dc.b 'Opt.resolution'
        dc.w -1
cfg_graphics_mode:dc.b 1                
        dc.b   0
txt_graphics_mode:dc.w 21               
        dc.b 'QDesign graphic mode ',0
attr_graphics_mode:dc.b 0               
        dc.b 0
        dc.w 12
        dc.b 'Four colours'
        dc.b 1
        dc.b 0
        dc.w 14
        dc.b 'Monochrom mode'
        dc.w -1
cfg_printer_type:dc.b 3                 
        dc.b   0
txt_printer_type:dc.w 11                
        dc.b 'Printertyp ',0
attr_printer_type:dc.b 1                
        dc.b 0
        dc.w 14
        dc.b '9  Pin-Printer'
        dc.b 3
        dc.b 0
        dc.w 14
        dc.b '24 Pin-Printer'
        dc.b 4
        dc.b 0
        dc.w 11
        dc.b 'HP LaserJet',0
        dc.w -1
cfg_printer_multitask:dc.b 1            
        dc.b   0
txt_printer_multitask:dc.w 22           
        dc.b 'Multitasking printing '
attr_printer_multitask:dc.b 0           
        dc.b 0
        dc.w 3
        dc.b 'off',0
        dc.b 1
        dc.b 0
        dc.w 2
        dc.b 'on'
        dc.w -1
cfg_real_subdir:dc.b 0                  
        dc.b   0
txt_real_subdir:dc.w 35                 
        dc.b 'Do you have real sub-directories ? ',0
attr_real_subdir:dc.b 0                 
        dc.b 'y'
        dc.w 3
        dc.b 'yes',0
        dc.b 1
        dc.b 'n'
        dc.w 2
        dc.b 'no'
        dc.w -1
cfg_mouse_speed:dc.b 0                  
        dc.b   0
txt_mouse_speed:dc.w 22                 
        dc.b 'Pointer speed 1 (0-9) '
attr_mouse_speed:dc.b 0,9              
                                        ; Min/max
cfg_mouse_speed2:dc.b 8                 
        dc.b   0
txt_mouse_speed2:dc.w 22                
        dc.b 'Pointer speed 2 (0-9) '
attr_mouse_speed2:dc.b 0,9             
                                        ; Min/max
cfg_mouse_wakeup:dc.b 2                 
        dc.b   0
txt_mouse_wakeup:dc.w 22                
        dc.b 'Pointer wakeup  (0-9) '
attr_mouse_wakeup:dc.b 0,9             
                                        ; Min/max
cfg_grid_width:dc.b $18                 
        dc.b   0
txt_grid_width:dc.w 22                  
        dc.b 'Grid - width   (4-60) '
attr_grid_width:dc.b 4,$3C              
                                        ; Min/max
cfg_ql_font_max:dc.b 6                  
        dc.b   0
txt_ql_font_max:dc.w 28                 
        dc.b 'Max. no. of QL-fonts (1-28) '
attr_ql_font_max:dc.b 1,$1C             
                                        ; Min/max
cfg_fill_buffer_size:dc.b $80           
        dc.b   0
txt_fill_buffer_size:dc.w 32            
        dc.b 'Buffer size for fill (4-128 Kb) '
attr_fill_buffer_size:dc.b 4,$80        
                                        ; Min/max
cfg_x_factor:dc.w 6                     
                                        ; Maximum string length
        dc.w 4
        dc.b '0.74'
        dcb.b 8,' '
txt_x_factor:dc.w 22                    
        dc.b 'Position X-fakt 0-200 '
attr_x_factor:dc.w 0                    
cfg_y_factor:dc.w 6                     
                                        ; Maximum string length
        dc.w 1
        dc.b '1'
        dcb.b 11,32
txt_y_factor:dc.w 22                    
        dc.b 'Position Y-fakt 0-200 '
attr_y_factor:dc.w 0                    
cfg_help_filename:dc.w 30               
                                        ; Maximum string length
        dc.w 11
        dc.b 'QDesign_Hlp'
        dcb.b 20,32
        dc.b   0
txt_help_filename:dc.w 16               
        dc.b 'Help - filename '
atr_help_filename:dc.w 0                
cfg_config_filename:dc.w 30             
                                        ; Maximum string length
        dc.w 11
        dc.b 'QDesign_Dat'
        dcb.b 20,32
        dc.b   0
txt_config_filename:dc.w 18             
        dc.b 'Config - filename '
attr_config_filename:dc.w 0             
cfg_printer_filename:dc.w 30            
                                        ; Maximum string length
        dc.w 9
        dc.b 'Laser_Prt'
        dcb.b 22,32
        dc.b   0
txt_printer_filename:dc.w 24            
        dc.b 'Laserprinter - filename '
attr_printer_filename:dc.w 0            
cfg_default_filename:dc.w 36            
                                        ; Maximum string length
txt_default:dc.w 7
        dc.b 'Default'
        dc.b '                        ',0
txt_default_filename:dc.w 18            
        dc.b 'Default - filename'
attr_default_filename:dc.w 0            
cfg_ql_font_ext:dc.w 5                  
                                        ; Maximum string length
        dc.w 4
        dc.b '_Fnt'
        dcb.b 6,' '
txt_ql_font_ext:dc.w 18                 
        dc.b 'QL-font extension '
attr_ql_font_ext:dc.w 0                 
cfg_hi_font_ext:dc.w 5                  
                                        ; Maximum string length
        dc.w 4
        dc.b '_Hir'
        dcb.b 6,' '
txt_hi_font_ext:dc.w 18                 
        dc.b 'Hi-font extension '
attr_hi_font_ext:dc.w 0                 
cfg_scr_ext:dc.w 5                      
                                        ; Maximum string length
        dc.w 4
        dc.b '_Scr'
        dcb.b 6,' '
txt_scr_ext:dc.w 18                     
        dc.b 'Screen  extension '
attr_scr_ext:dc.w 0                     
cfg_page_ext:dc.w 5                     
                                        ; Maximum string length
        dc.w 4
        dc.b '_Pgn'
        dcb.b 6,' '
txt_page_ext:dc.w 18                    
        dc.b 'Page    extension '
attr_page_ext:dc.w 0                    
cfg_cut_ext:dc.w 5                      
                                        ; Maximum string length
        dc.w 4
        dc.b '_Cut'
        dcb.b 6,' '
txt_cut_ext:dc.w 18                     
        dc.b 'Cut     extension '
attr_cut_ext:dc.w 0                     
cfg_pattern_ext:dc.w 5                  
                                        ; Maximum string length
        dc.w 4
        dc.b '_Pat'
        dcb.b 6,' '
txt_pattern_ext:dc.w 18                 
        dc.b 'Pattern extension '
attr_pattern_ext:dc.w 0                 
cfg_config_ext:dc.w 5                   
                                        ; Maximum string length
        dc.w 4
        dc.b '_Dat'
        dcb.b 6,' '
txt_config_ext:dc.w 18                  
        dc.b 'Config  extension '
attr_config_ext:dc.w 0                  
cfg_dump_dev:dc.w 30                    
                                        ; Maximum string length
        dc.w 4
        dc.b 'SER1'
        dcb.b $1B,' '
        dc.b   0
txt_dump_dev:dc.w 29                    
        dc.b 'Local default device to dump ',0
attr_dump_dev:dc.w 0                    
cfg_prog_dir:dc.w 30                    
                                        ; Maximum string length
        dc.w     5
        dc.b 'flp1_'
        dcb.b $1A,$20
        dc.b   0
        dc.w 0
txt_prog_dir:dc.w 40                    
        dc.b 'Local default device for fonts and data '
attr_prog_dir:dc.w 0                    

; =============== S U B R O U T I N E =======================================
; M_CONV mode (2,4,8),addr,words

m_conv:                                 
        movea.w sb.gtlin,a0             ; Convert one line
                                        ;
                                        ; Mode 2: 8bit -> 16bit, skipping every 2nd byte
                                        ; Mode 4: 8bit -> 16bit, doubling every 2nd byte
                                        ; Mode 8: 8bit -> 8bit. All ORed together somehow
        jsr     (a0)
        tst.w   d0
        bne.s   m_conv_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   m_conv_ret
        move.l  (a6,a1.l),d1            ; Mode
        movea.l 4(a6,a1.l),a0           ; Addr
        move.l  8(a6,a1.l),d7           ; Len
        beq.s   m_conv_ret
        cmpi.w  #2,d1
        beq.s   conv_m2
        cmpi.w  #4,d1
        beq.s   conv_m4
        cmpi.w  #8,d1
        beq.s   conv_m8
        bra.s   m_conv_ret              ; Return ipar
; ---------------------------------------------------------------------------

conv_m2:                                
        movea.l a0,a1                   ; Address

conv_m2_loop:                           
        move.b  (a0)+,(a1)+
        addq.l  #1,a0
        subq.l  #1,d7
        bne.s   conv_m2_loop
        bra.s   m_conv_ok
; ---------------------------------------------------------------------------

conv_m4:                                
        lsl.l   #1,d7                   ; *2
        movea.l a0,a1
        adda.l  d7,a0
        adda.l  d7,a1
        adda.l  d7,a1

conv_m4_loop:                           
        move.b  -(a0),-(a1)
        move.b  (a0),-(a1)
        subq.l  #1,d7
        bne.s   conv_m4_loop
        bra.s   m_conv_ok
; ---------------------------------------------------------------------------

conv_m8:                                
        lsl.l   #1,d7                   ; *2

conv_m8_loop:                           
        move.b  (a0),d0
        move.b  d0,d1
        move.b  d0,d2
        lsl.b   #1,d1
        lsr.b   #1,d2
        or.b    d1,d0
        or.b    d2,d0
        move.b  d0,(a0)+
        subq.l  #1,d7
        bne.s   conv_m8_loop

m_conv_ok:                              
        moveq   #0,d0

m_conv_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; P_PARA mode,addr,llen,x_size,y_size

p_para:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   p_para_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #5,d3
        bne.s   p_para_ret
        move.w  2(a6,a1.l),qthg_paint_with_pattern(a4) ; True to paint with pattern, false to paint with colour
        move.l  4(a6,a1.l),qthg_patt_addr(a4) ; Paint pattern address
        move.l  8(a6,a1.l),qthg_patt_llen_l(a4) ; Long version of qthg_paint_llen (used to set)
        move.l  12(a6,a1.l),qthg_patt_width_l(a4) ; Long version of qthg_paint_width (used to set)
        move.l  16(a6,a1.l),qthg_patt_height_l(a4) ; Long version of qthg_paint_height (used to set)
        moveq   #0,d0

p_para_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; MOVE_ID chan - Set channel as main channel for toolkit

move_id:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   move_id_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   move_id_ret
        move.w  (a6,a1.l),d7
        mulu.w  #ch.len,d7
        add.l   sb_chanb(a6),d7         ; channel table base
        move.l  (a6,d7.l),qthg_chid(a4)
        moveq   #0,d0

move_id_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; ROTATE r - Set rotation

rotate:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   rotate_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   rotate_ret
        move.w  (a6,a1.l),qthg_rotate(a4) ; Exchange X/Y during INOUT or PRINT
        moveq   #0,d0

rotate_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; HC_GOOD val

hc_good:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   hc_good_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   hc_good_ret
        move.w  (a6,a1.l),qthg_hc_good(a4) ; Use "good" quality during INOUT/PRINT
        moveq   #0,d0

hc_good_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_CLR addr,words,colour - Quickly clear memory

vg_clr:                                 
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_clr_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   vg_clr_ret
        movea.l (a6,a1.l),a0            ; Addr
        move.l  4(a6,a1.l),d7           ; Words
        move.l  8(a6,a1.l),d5           ; Colour
        andi.l  #7,d5
        lea     colour_tab4(pc),a1
        lsl.l   #1,d5
        move.w  (a1,d5.w),d6
        swap    d6
        move.w  (a1,d5.w),d6
        ror.l   #4,d7                   ; /16 (blocks)
        bra.s   vg_clr_start
; ---------------------------------------------------------------------------

vg_clr_loop:                            
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+
        move.l  d6,(a0)+

vg_clr_start:                           
        dbf     d7,vg_clr_loop
        clr.w   d7                      ; Just clear one more word? Weird
        bra.s   vg_clr_word
; ---------------------------------------------------------------------------

vg_clr_word_loop:                       
        move.w  d6,(a0)+

vg_clr_word:                            
        dbf     d7,vg_clr_word_loop
        moveq   #0,d0

vg_clr_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; VG_INV addr,words - Quickly invert memory

vg_inv:                                 
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_inv_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #2,d3
        bne.s   vg_inv_ret
        movea.l (a6,a1.l),a0            ; Addr
        move.l  4(a6,a1.l),d7           ; Words
        ror.l   #4,d7
        bra.s   vg_inv_start
; ---------------------------------------------------------------------------

vg_inv_loop:                            
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+
        not.l   (a0)+

vg_inv_start:                           
        dbf     d7,vg_inv_loop
        clr.w   d7                      ; Just one more word? Weird
        bra.s   vg_inv_word
; ---------------------------------------------------------------------------

vg_inv_word_loop:                       
        not.w   (a0)+

vg_inv_word:                            
        dbf     d7,vg_inv_word_loop
        moveq   #0,d0

vg_inv_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; VG_MODE mode (1 = mode 4,2 = mono)

vg_mode:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_mode_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_mode_ret
        clr.w   qthg_mono_mode(a4)
        move.w  (a6,a1.l),d0
        cmpi.w  #2,d0
        bne.s   vg_mode_ok
        move.w  #1,qthg_mono_mode(a4)

vg_mode_ok:                             
        moveq   #0,d0

vg_mode_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; HC_PATT p1,p2

hc_patt:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   hc_patt_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #2,d3
        bne.s   hc_patt_ret
        clr.w   qthg_prt_patt1(a4)      ; Useless...
        clr.w   qthg_prt_patt2(a4)
        move.w  (a6,a1.l),qthg_prt_patt1(a4)
        move.w  2(a6,a1.l),qthg_prt_patt2(a4)
        moveq   #0,d0

hc_patt_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; INITDEST - Init DEST$ to SER1

initdest:                               
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        movea.l a0,a4
        tst.l   sys_dstd(a4)            ; pointer to DeSTination Default
        bne.s   initdest_ret
        moveq   #sms.achp,d0            ; Allocate space in Common HeaP
        moveq   #64,d1
        moveq   #0,d2
        trap    #1
        tst.w   d0
        bne.s   initdest_ret
        move.l  a0,sys_dstd(a4)         ; pointer to DeSTination Default
        move.w  #4,(a0)+
        move.l  #'SER1',(a0)
        moveq   #0,d0

initdest_ret:                           
        rts

; =============== S U B R O U T I N E =======================================
; thg = VEC_THG - Get vector fonts thing pointer

vec_thg:                                
        bsr     get_thg                 ; Get Thing system thing in a3
        tst.l   d0
        bne.s   vec_thg_ret_d0
        movea.l 8(a3),a5
        bsr.s   vec_thing_create
        tst.l   d0
        bne.s   vec_thg_ret_d0
        bsr.s   get_vec_fonts_thing     ; Get vector thing in A4
        bne.s   vec_thg_ret_d0
        move.l  a4,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------

vec_thg_ret_d0:                         
        move.l  d0,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------
txt_vec_fonts:dc.w 10                   
        dc.b 'Vec Fonts '

; =============== S U B R O U T I N E =======================================
; Get vector thing in A4

get_vec_fonts_thing:                    
        movem.l a3/a5,-(sp)
        bsr     get_thg                 ; Get Thing system thing in a3
        movea.l 8(a3),a5
        lea     txt_vec_fonts(pc),a0    ; "Vec Fonts "
        bsr     thg_free                ; Free thing
        bsr     thg_use                 ; Use thing
        movea.l a1,a4
        adda.l  #thh_qdata,a4
        moveq   #0,d0
        movem.l (sp)+,a3/a5
        rts

; =============== S U B R O U T I N E =======================================

vec_thing_create:                       
        move.l  #512,d0
        bsr     achp                    ; Allocate d0 bytes
        move.l  a0,-(sp)
        lea     txt_vec_fonts(pc),a3    ; "Vec Fonts "
        movea.l (sp),a0
        bsr.s   clear_fonts
        movea.l (sp)+,a0
        lea     th_start(a0),a1
        move.l  a1,th_thing(a0)         ; pointer to THING itself
        move.l  #'THG%',thh_flag(a1)
        move.l  #tht.data,thh_type(a1)  ; type of thing
        clr.l   th_use(a0)              ; code to USE a thing
        clr.l   th_free(a0)             ; code to FREE a thing
        clr.l   th_ffree(a0)            ; code to Force FREE a thing
        clr.l   th_remov(a0)            ; code to tidy before REMOVing thing
        clr.w   th_nshar(a0)            ; Non-SHAReable Thing if top bit set
        move.l  #'1.10',th_verid(a0)    ; version ID
        move.w  (a3)+,th_name(a0)       ; "Vec Fonts"
        move.l  (a3)+,th_name+2(a0)     ; name of thing
        move.l  (a3)+,th_name+6(a0)     ; name of thing
        move.l  (a3)+,th_name+10(a0)    ; name of thing
        move.w  (a3)+,th_name+14(a0)    ; name of thing
        movea.l a0,a1
        moveq   #sms.lthg,d0            ; Link in THinG
        jsr     (a5)
        rts

; =============== S U B R O U T I N E =======================================

clear_fonts:                            
        movea.l a0,a4
        adda.l  #th_data_base,a4
        moveq   #15,d0
        lea     vthg_fonts(a4),a0

clear_fonts_loop:                       
        clr.l   (a0)+
        dbf     d0,clear_fonts_loop
        rts

; =============== S U B R O U T I N E =======================================
; addr = VG_INIT - Initialise QDesign thing

vg_init:                                
        bsr     get_thg                 ; Get Thing system thing in a3
        tst.l   d0
        bne.s   vg_init_err
        movea.l thh_entr(a3),a5
        bsr.s   qdesign_thing_create
        tst.l   d0
        bne.s   vg_init_err
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        bne.s   vg_init_err
        move.l  a4,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------

vg_init_err:                            
        move.l  d0,d5
        bra     ret_d5                  ; Return integer in d5

; =============== S U B R O U T I N E =======================================

qdesign_thing_create:                   
        moveq   #0,d0
        lea     cfg_fill_buffer_size(pc),a1
        move.b  (a1),d0
        mulu.w  #1024,d0
        addi.l  #th_data_base,d0
        bsr     achp                    ; Allocate d0 bytes
        bne.s   qdesign_thing_create_ret
        move.l  a0,-(sp)
        bsr.s   get_qdesign_thing_name  ; Get name of job-specific QDesign thing in a3
        movea.l (sp),a0
        bsr     qdesign_thing_init
        movea.l (sp)+,a0
        lea     th_start(a0),a1
        move.l  a1,th_thing(a0)         ; pointer to THING itself
        move.l  #'THG%',(a1)
        move.l  #2,4(a1)
        clr.l   th_use(a0)              ; code to USE a thing
        clr.l   th_free(a0)             ; code to FREE a thing
        clr.l   th_ffree(a0)            ; code to Force FREE a thing
        clr.l   th_remov(a0)            ; code to tidy before REMOVing thing
        clr.w   th_nshar(a0)            ; Non-SHAReable Thing if top bit set
        move.l  #'1.10',th_verid(a0)    ; version ID
        move.w  (a3)+,th_name(a0)       ; name of thing
        move.l  (a3)+,th_name+2(a0)     ; name of thing
        move.l  (a3)+,th_name+6(a0)     ; name of thing
        move.l  (a3)+,th_name+10(a0)    ; name of thing
        move.l  (a3)+,th_name+14(a0)    ; name of thing
        movea.l a0,a1
        moveq   #sms.lthg,d0            ; Link in THinG
        jsr     (a5)

qdesign_thing_create_ret:               
        rts

; =============== S U B R O U T I N E =======================================
; Get name of job-specific QDesign thing in a3

get_qdesign_thing_name:                 
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        moveq   #40,d0                  ; Bytes to allocate
        bsr     achp                    ; Allocate d0 bytes
        move.l  a0,-(sp)
        lea     (a0),a0                 ; WTF? This does nothing
        move.l  d1,(a0)                 ; Save job ID
        movea.l a0,a1
        suba.l  a6,a1
        lea     10(a1),a0
        movea.w cv.ilhex,a2             ; Convert stack value in A1 to string in A0 (all rel A6)
        jsr     (a2)
        subq.l  #4,a1                   ; Was updated, go back to start of block
        move.l  #'QDes',2(a6,a1.l)      ; 16,"QDesign xxxxxxxx" (x = JobID)
        move.l  #'ign ',6(a6,a1.l)
        move.w  #16,(a6,a1.l)
        lea     (a6,a1.l),a3
        lea     (a6,a1.l),a0
        movea.l (sp)+,a2
        bsr.s   rchp                    ; Release memory now??? -> race condition!
        rts

; =============== S U B R O U T I N E =======================================
; Get QDesign thing in A4

get_qdesign_thing:                      
        movem.l a3/a5,-(sp)
        bsr.s   get_thg                 ; Get Thing system thing in a3
        movea.l thh_entr(a3),a5
        bsr.s   get_qdesign_thing_name  ; Get name of job-specific QDesign thing in a3
        bsr.s   thg_free                ; Free thing
        bsr.s   thg_use                 ; Use thing
        movea.l a1,a4
        adda.l  #thh_qdata,a4
        moveq   #0,d0
        movem.l (sp)+,a3/a5
        rts

; =============== S U B R O U T I N E =======================================
; Release memory in a2

rchp:                                   
        movem.l d1-d3/a0-a3,-(sp)
        movea.l a2,a0
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        trap    #1
        movem.l (sp)+,d1-d3/a0-a3
        rts

; =============== S U B R O U T I N E =======================================
; Get Thing system thing in a3

get_thg:                                
        move    sr,d0
        trap    #0
        move.w  d0,-(sp)
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        moveq   #err.fdnf,d0            ; File or Device Not Found
        move.l  sys_thgl(a0),d5         ; pointer to THinG List
        beq.s   get_thg_ret

get_thg_loop:                           
        movea.l d5,a0
        move.l  (a0),d5
        bne.s   get_thg_loop
        movea.l th_thing(a0),a3         ; pointer to THING itself
        cmpi.l  #'THG%',thh_flag(a3)
        bne.s   get_thg_ret
        cmpi.l  #-1,thh_type(a3)        ; type of thing
        bne.s   get_thg_ret
        moveq   #0,d0

get_thg_ret:                            
        move    (sp)+,sr
        rts

; =============== S U B R O U T I N E =======================================
; Use thing

thg_use:                                
        moveq   #sms.uthg,d0            ; Use THinG
        moveq   #-1,d1
        moveq   #0,d2
        moveq   #-1,d3
        jsr     (a5)
        rts

; =============== S U B R O U T I N E =======================================
; Free thing

thg_free:                               
        moveq   #sms.fthg,d0            ; Free THinG
        moveq   #-1,d1
        jsr     (a5)
        rts

; =============== S U B R O U T I N E =======================================

qdesign_thing_init:                     
        movea.l a0,a4
        adda.l  #th_data_base,a4
        clr.w   qthg_x_min(a4)
        move.w  #511,qthg_x_max(a4)
        clr.w   qthg_y_min(a4)
        move.w  #255,qthg_y_max(a4)
        move.l  #scr_base,qthg_scr_base(a4)
        move.w  #scr_incr,qthg_scr_llen(a4) ; Scr line length (bytes)
        move.w  #256,qthg_scr_yres(a4)
        move.w  #$FFFF,qthg_curr_ink_col(a4)
        move.w  #$FFFF,qthg_ink_col(a4)
        move.w  #$FFFF,qthg_shadow_col(a4)
        move.w  #8,qthg_font_size_x(a4)
        move.w  #8,qthg_font_size_y(a4)
        clr.w   qthg_font_angle(a4)
        move.w  #90,qthg_font_italic_angle(a4)
        move.w  #90,qthg_font_italic_slant(a4)
        clr.w   qthg_font_flags(a4)     ; Bold 0..15, right 16, down 32, left 64, top 128, shadow 256, pixel 512
        clr.w   qthg_font_ql2ibm(a4)
        clr.w   qthg_font_mirror_x(a4)
        clr.w   qthg_font_mirror_y(a4)
        clr.w   qthg_font_outline(a4)
        move.l  #scr_base,qthg_move_scr_base(a4) ; Screen address
        move.l  #64,qthg_move_scr_width(a4) ; Width in words
        move.l  #256,qthg_move_scr_height(a4) ; Height in lines
        move.l  #scr_base,qthg_img_base(a4)
        move.l  #scr_incr/2,qthg_img_llen_w(a4)
        clr.l   qthg_move_scr_x(a4)     ; X address in words
        clr.l   qthg_move_scr_y(a4)     ; y position in lines
        clr.w   qthg_over_mode_copy(a4)
        clr.w   qthg_over_mode(a4)
        moveq   #15,d0
        lea     qthg_fonts(a4),a0

qdesign_thing_font_clear:               
        clr.l   (a0)+
        dbf     d0,qdesign_thing_font_clear
        move.w  #4,qthg_ptr_dev(a4)
        move.l  #'SER1',qthg_prt_device(a4)
        move.l  #$11800,qthg_prt_can(a4) ; CAN
        move.w  #3,qthg_ptr_start(a4)
        move.l  #$1B2A0600,qthg_ptr_start+2(a4) ; ESC * 0x06 - Select dot printing, 90x180dpi
        move.w  #4,qthg_prt_space1(a4)
        move.l  #$1B33010D,qthg_prt_space1+2(a4) ; ESC 3 0x01 0x0D - Set 1/180" line spacing
        move.w  #4,qthg_ptr_space24(a4)
        move.l  #$1B33180D,qthg_ptr_space24+2(a4) ; ESC 3 0x18 0x0D - Set 24/180" line spacing
        move.w  #4,qthg_prt_space30(a4)
        move.l  #$1B320D0D,qthg_prt_space30+2(a4) ; ESC 2 0x0D 0x0D - Set 1/6" line spacing
        move.w  #720,qthg_prt_dpi_hor(a4)
        move.w  #480,qthg_prt_dpi_ver(a4)
        move.w  #1,qthg_prt_type(a4)    ; 1 = 9-pin, 3 = 24-pin, 4 = laser
        move.w  #2,qthg_prt_colour(a4)
        move.w  #$FAFA,qthg_prt_patt1(a4) ; %11111010 11111010
        move.w  #$5555,qthg_prt_patt2(a4) ; %01010101 01010101
        clr.w   qthg_rotate(a4)         ; Exchange X/Y during INOUT or PRINT
        clr.l   qthg_chid(a4)
        rts

; =============== S U B R O U T I N E =======================================
; Allocate d0 bytes

achp:                                   
        movem.l d1-d3/a1-a3,-(sp)
        moveq   #-1,d2
        move.l  d0,d1
        moveq   #sms.achp,d0            ; Allocate space in Common HeaP
        trap    #1
        tst.l   d0
        movem.l (sp)+,d1-d3/a1-a3
        rts

; =============== S U B R O U T I N E =======================================
; PUNKT x,y,{colour} - Draw point

punkt:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   punkt_ret
        movem.l d3/a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_punkt(pc),a2
        trap    #3

punkt_ret:                              
        rts

; =============== S U B R O U T I N E =======================================

xtop_punkt:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4
        movem.l qthg_workspace(a4),d3/a1/a6
        tst.w   qthg_over_mode(a4)
        bne     p_over
        tst.w   qthg_mono_mode(a4)
        bne.s   p_mono
        moveq   #0,d0
        move.w  qthg_curr_ink_col(a4),d6 ; Default to foreground colour
        cmpi.w  #2,d3
        beq.s   p_start
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   p_ret
        lea     colour_tab4(pc),a2
        move.w  4(a6,a1.l),d6           ; Colour
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  (a2,d6.w),d6            ; Colour pattern

p_start:                                
        move.w  #$8080,d2               ; Pixel mask
        moveq   #0,d0
        move.w  (a6,a1.l),d0            ; x
        move.w  2(a6,a1.l),d1           ; y
        movea.l qthg_img_base(a4),a0
        move.l  qthg_img_llen_w(a4),d7
        lsl.l   #1,d7                   ; In bytes
        mulu.w  d1,d7                   ; Line offset
        adda.l  d7,a0                   ; Line start
        move.l  d0,d3                   ; x
        lsr.l   #3,d3                   ; /8 = x-word
        lsl.l   #1,d3                   ; x-offset
        adda.l  d3,a0                   ; Pixel-word start
        andi.w  #7,d0
        lsr.w   d0,d2                   ; Shit pixel mask
        not.w   d2
        and.w   d2,(a0)                 ; Mask out our pixel
        not.w   d2
        and.w   d2,d6
        or.w    d6,(a0)                 ; Or in our colour
        moveq   #0,d0

p_ret:                                  
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts
; ---------------------------------------------------------------------------

p_mono:                                 
        moveq   #0,d0
        move.w  qthg_curr_ink_col(a4),d6 ; Default to foreground colour
        cmpi.w  #2,d3
        beq.s   p_mono_start
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   p_mono_ret
        lea     colour_tab4(pc),a2
        move.w  4(a6,a1.l),d6           ; Colour
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  (a2,d6.w),d6

p_mono_start:                           
        move.w  #$8000,d2               ; Pixel mask
        moveq   #0,d0
        move.w  (a6,a1.l),d0
        move.w  2(a6,a1.l),d1
        movea.l qthg_img_base(a4),a0
        move.l  qthg_img_llen_w(a4),d7
        lsl.l   #1,d7                   ; In bytes
        mulu.w  d1,d7                   ; Line offset
        adda.l  d7,a0                   ; Line start
        move.l  d0,d3                   ; x
        lsr.l   #4,d3                   ; /16 = x-word
        lsl.l   #1,d3                   ; x-offset
        adda.l  d3,a0
        andi.w  #15,d0
        lsr.w   d0,d2                   ; Shift pixel mask
        not.w   d2
        and.w   d2,(a0)                 ; Mask out our pixel
        not.w   d2
        and.w   d2,d6
        or.w    d6,(a0)
        moveq   #0,d0

p_mono_ret:                             
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts
; ---------------------------------------------------------------------------

p_over:                                 
        tst.w   qthg_mono_mode(a4)
        bne.s   p_mono_over
        moveq   #0,d0
        move.w  qthg_curr_ink_col(a4),d6 ; Default to foreground colour
        cmpi.w  #2,d3
        beq.s   p_over_start
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   p_over_ret
        lea     colour_tab4(pc),a2
        move.w  4(a6,a1.l),d6
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  (a2,d6.w),d6

p_over_start:                           
        move.w  #$8080,d2
        moveq   #0,d0
        move.w  (a6,a1.l),d0
        move.w  2(a6,a1.l),d1
        movea.l $3A(a4),a0
        move.l  $3E(a4),d7
        lsl.l   #1,d7
        mulu.w  d1,d7
        adda.l  d7,a0
        move.l  d0,d3
        lsr.l   #3,d3
        lsl.l   #1,d3
        adda.l  d3,a0
        andi.w  #7,d0
        lsr.w   d0,d2
        and.w   d2,d6
        eor.w   d6,(a0)                 ; Same as others, but with EOR
        moveq   #0,d0

p_over_ret:                             
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts
; ---------------------------------------------------------------------------

p_mono_over:                            
        moveq   #0,d0
        move.w  qthg_curr_ink_col(a4),d6
        cmpi.w  #2,d3
        beq.s   p_mono_over_start
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   p_mono_over_ret
        lea     colour_tab4(pc),a2
        move.w  4(a6,a1.l),d6
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  (a2,d6.w),d6

p_mono_over_start:                      
        move.w  #$8000,d2
        moveq   #0,d0
        move.w  (a6,a1.l),d0
        move.w  2(a6,a1.l),d1
        movea.l $3A(a4),a0
        move.l  $3E(a4),d7
        lsl.l   #1,d7
        mulu.w  d1,d7
        adda.l  d7,a0
        move.l  d0,d3
        lsr.l   #4,d3
        lsl.l   #1,d3
        adda.l  d3,a0
        andi.w  #$F,d0
        lsr.w   d0,d2
        and.w   d2,d6
        eor.w   d6,(a0)                 ; Same as others, but with EOR
        moveq   #0,d0

p_mono_over_ret:                        
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts

; =============== S U B R O U T I N E =======================================
; LINIE x1,y1,x2,y2,{colour} - Draw line

linie:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        move.w  qthg_over_mode(a4),qthg_over_mode_copy(a4) ; Why not just use the original? No idea
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   line_ret
        movem.l d3/a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_linie(pc),a2
        trap    #3

line_ret:                               
        rts

; =============== S U B R O U T I N E =======================================

xtop_linie:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4
        movem.l qthg_workspace(a4),d3/a1/a6
        move.w  qthg_curr_ink_col(a4),d6 ; Default to foreground colour
        cmpi.w  #4,d3
        beq.s   linie_start
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #5,d3
        bne.s   linie_ret
        lea     colour_tab4(pc),a2
        move.w  8(a6,a1.l),d6           ; Colour
        andi.w  #7,d6
        lsl.w   #1,d6
        move.w  (a2,d6.w),d6

linie_start:                            
        move.w  (a6,a1.l),d0            ; x1
        move.w  2(a6,a1.l),d1           ; y1
        move.w  4(a6,a1.l),d2           ; x2
        move.w  6(a6,a1.l),d3           ; y2
        bsr     line_do                 ; d0 = x1, d1 = y1, d2 = x2, d3 = y2, d6 = colour
        moveq   #0,d0

linie_ret:                              
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts

; =============== S U B R O U T I N E =======================================
; VG_WEG font-index - Remove font

vg_weg:                                 
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_weg_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_weg_ret
        move.w  (a6,a1.l),d7
        andi.w  #$F,d7
        lsl.w   #2,d7
        moveq   #0,d0
        move.l  vthg_fonts(a4,d7.w),d1
        beq.s   vg_weg_ret
        clr.l   vthg_fonts(a4,d7.w)
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        movea.l d1,a0
        trap    #1

vg_weg_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; height% = VG_HOCH(font_index) - Return height of font

vg_hoch:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        move.l  a4,-(sp)
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_hoch_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_hoch_ret
        move.w  (a6,a1.l),d7            ; Font index
        andi.w  #$F,d7
        lsl.w   #2,d7
        move.l  vthg_fonts(a4,d7.w),d0
        bne.s   vg_hoch_font_exists
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        clr.w   (a6,a1.l)               ; Return 0 if font doesn't exist
        bra.s   vg_hoch_ret_d1
; ---------------------------------------------------------------------------

vg_hoch_font_exists:                    
        movea.l d0,a0
        moveq   #0,d0
        moveq   #0,d1
        move.b  font_ascender(a0),d0
        move.b  font_descender(a0),d1
        neg.b   d1
        add.w   d0,d1
        movea.l (sp),a4
        mulu.w  qthg_font_size_y(a4),d1
        asr.l   #3,d1                   ; /8
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.w  d1,(a6,a1.l)

vg_hoch_ret_d1:                         
        moveq   #0,d0
        moveq   #nt.in,d4
        movea.l (sp)+,a4

vg_hoch_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; width% = VG_BREIT font_index,character - Return width of font

vg_breit:                               
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        move.l  a4,-(sp)
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_breit_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #2,d3                   ; Two parameters
        bne.s   vg_hoch_ret
        move.w  (a6,a1.l),d7            ; Font index
        andi.w  #15,d7
        lsl.w   #2,d7                   ; /4
        move.l  vthg_fonts(a4,d7.w),d0
        bne.s   vg_breit_font_exists
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        clr.w   (a6,a1.l)               ; Return 0 if font doesn't exist
        bra.s   vg_breit_ret_d1
; ---------------------------------------------------------------------------

vg_breit_font_exists:                   
        move.w  2(a6,a1.l),d6           ; Character code
        movea.l d0,a0
        lea     font_base(a0),a0
        sub.b   font_first_char-font_base(a0),d6
        moveq   #0,d0
        move.b  font_char_count-font_base(a0),d0
        lsl.w   #1,d0
        lea     font_width_table-font_base(a0,d0.w),a0
        moveq   #0,d1
        move.b  (a0,d6.w),d1
        movea.l (sp),a4                 ; QDesign thing
        mulu.w  qthg_font_size_x(a4),d1
        asr.l   #3,d1                   ; /8
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.w  d1,(a6,a1.l)

vg_breit_ret_d1:                        
        moveq   #0,d0
        moveq   #nt.in,d4
        movea.l (sp)+,a4

vg_breit_ret:                           
        rts

; =============== S U B R O U T I N E =======================================
; name$ = VG_NAME(font_index) - Return name of font

vg_name:                                
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_name_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_name_ret
        move.w  (a6,a1.l),d7
        addq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer
        lsl.w   #2,d7
        move.l  vthg_fonts(a4,d7.w),d0
        bne.s   vg_name_font_exists     ; Font pointer
        lea     txt_leer(pc),a0         ; Return "LEER" (empty)
        bra.s   ret_font_name           ; 4-char font name
; ---------------------------------------------------------------------------

vg_name_font_exists:                    
        movea.l d0,a0                   ; Font pointer

vg_name_skip_loop:                      
        cmpi.b  #$1A,(a0)+
        bne.s   vg_name_skip_loop
        addq.l  #2,a0

ret_font_name:                          
        move.l  (a0),d7                 ; 4-char font name

ret_4char_str_d7:                       
        moveq   #6,d1                   ; Reserve 6 bytes
        moveq   #6,d6
        move.l  d6,-(sp)
        movea.w qa.resri,a2    
        jsr     (a2)
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.l  (sp)+,d6
        suba.w  d6,a1
        move.w  #0,(a6,a1.l)
        tst.l   d7
        beq.s   ret_4char
        move.w  #4,(a6,a1.l)            ; 4 characters
        move.l  d7,2(a6,a1.l)           ; The characters

ret_4char:                              
        move.l  a1,sb_arthp(a6)         ; arithmetic stack pointer
        moveq   #0,d0
        moveq   #nt.st,d4

vg_name_ret:                            
        rts
; ---------------------------------------------------------------------------
txt_leer:dc.l 'LEER'                    

; =============== S U B R O U T I N E =======================================
; length% = VG_LANG(font_index) - Return size of font data

vg_lang:                                
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_lang_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_lang_ret
        move.w  (a6,a1.l),d7
        lsl.w   #2,d7
        move.l  vthg_fonts(a4,d7.w),d0
        bne.s   vg_lang_font_exists
        moveq   #0,d0
        bra.s   vg_lang_exit
; ---------------------------------------------------------------------------

vg_lang_font_exists:                    
        movea.l d0,a0

vg_lang_skip_loop:                      
        cmpi.b  #$1A,(a0)+              ; $1A = end of font description
        bne.s   vg_lang_skip_loop
        move.b  7(a0),d0                ; Read possibly unaligned little endian word - font data block size
        lsl.w   #8,d0
        move.b  6(a0),d0

vg_lang_exit:                           
        movea.l sb_arthp(a6),a1         ; arithmetic stack pointer
        move.w  d0,(a6,a1.l)
        moveq   #0,d0
        moveq   #nt.in,d4

vg_lang_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_LOAD filename,font_index - Load BGI font

vg_load:                                
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        move.l  a5,-(sp)
        lea     8(a3),a5
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne     vg_load_ret
        cmpi.w  #1,d3
        bne     vg_load_ret
        lea     vthg_fonts(a4),a0
        move.w  (a6,a1.l),d7
        andi.w  #$F,d7
        lsl.w   #2,d7
        lea     (a0,d7.w),a0
        move.l  (a0),d0                 ; Font slot taken?
        beq.s   vg_load_filename         no
        clr.l   (a0)                    ; Clear and release
        move.l  a0,-(sp)
        movea.l d0,a0
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        trap    #1
        movea.l (sp)+,a0

vg_load_filename:                       
        move.l  a0,-(sp)
        movea.l 4(sp),a5                ; Vec thing
        lea     -8(a5),a3
        movea.w sb.gtstr,a0    
        jsr     (a0)
        movea.l (sp)+,a5
        tst.w   d0
        bne     vg_load_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_load_ret
        lea     vthg_workspace(a4),a0
        move.w  (a6,a1.l),d0            ; String length
        addq.w  #1,d0                   ; Adjust for dbf

vg_load_copy_filename:                  
        move.b  (a6,a1.l),(a0)+
        addq.l  #1,a1
        dbf     d0,vg_load_copy_filename
        moveq   #ioa.open,d0            ; OPEN IOSS channel
        moveq   #-1,d1
        moveq   #ioa.kexc,d3            ; Key for EXClusive use (read/write)
        lea     vthg_workspace(a4),a0
        trap    #2
        tst.w   d0
        bne.s   vg_load_ret
        moveq   #iof.rhdr,d0            ; Read file HeaDeR
        move.w  #14,d2
        moveq   #-1,d3
        lea     vthg_workspace(a4),a1
        trap    #3
        tst.w   d0
        bne.s   vg_load_close
        moveq   #sms.achp,d0            ; Allocate space in Common HeaP
        move.l  vthg_workspace+hdr_flen(a4),d1 ; File LENgth
        moveq   #-1,d2
        move.l  a0,-(sp)
        trap    #1
        movea.l a0,a1
        movea.l (sp)+,a0
        tst.w   d0
        bne.s   vg_load_close
        move.l  a1,(a5)
        moveq   #iof.load,d0            ; (scatter) LOAD file
        move.l  vthg_workspace(a4),d2
        moveq   #-1,d3
        trap    #3
        movea.l (a5),a1
        cmpi.w  #'PK',(a1)              ; Check signature
        beq.s   vg_load_close
        clr.l   (a4)
        move.l  a0,-(sp)
        moveq   #sms.rchp,d0            ; Release space in Common HeaP
        movea.l a1,a0
        trap    #1
        movea.l (sp)+,a0
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        trap    #2
        addq.l  #4,sp
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts
; ---------------------------------------------------------------------------

vg_load_close:                          
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        trap    #2

vg_load_ret:                            
        addq.l  #4,sp
        rts

; =============== S U B R O U T I N E =======================================
; VG_WIND x_min,x_max,y_min,y_max - Define window

vg_wind:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_wind_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #4,d3
        bne.s   vg_wind_ret
        move.w  (a6,a1.l),qthg_x_min(a4)
        move.w  2(a6,a1.l),qthg_x_max(a4)
        move.w  4(a6,a1.l),qthg_y_min(a4)
        move.w  6(a6,a1.l),qthg_y_max(a4)
        moveq   #0,d0

vg_wind_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_RESO scr_base,words_per_line,lines - Define screen resolution

vg_reso:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_reso_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   vg_reso_ret
        move.l  (a6,a1.l),qthg_scr_base(a4) ; scr_base
        move.w  6(a6,a1.l),d0           ; word_per_line
        lsl.l   #1,d0
        move.w  d0,qthg_scr_llen(a4)    ; Scr line length (bytes)
        clr.w   qthg_x_min(a4)
        lsl.w   #2,d0                   ; *4
        subq.w  #1,d0
        move.w  d0,qthg_x_max(a4)
        move.w  10(a6,a1.l),d0          ; lines
        move.w  d0,qthg_scr_yres(a4)
        clr.w   qthg_y_min(a4)
        subq.w  #1,d0
        move.w  d0,qthg_y_max(a4)
        moveq   #0,d0

vg_reso_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_INK colour

vg_ink:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_ink_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_ink_ret
        move.w  (a6,a1.l),d0
        andi.w  #7,d0
        lsl.w   #1,d0
        lea     colour_tab4(pc),a2
        move.w  (a2,d0.w),qthg_ink_col(a4)
        move.w  (a2,d0.w),qthg_curr_ink_col(a4)
        moveq   #0,d0

vg_ink_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; VG_SHAD colour

vg_shad:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_shad_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_shad_ret
        move.w  (a6,a1.l),d0
        andi.w  #7,d0
        lsl.w   #1,d0
        lea     colour_tab4(pc),a2
        move.w  (a2,d0.w),qthg_shadow_col(a4)
        moveq   #0,d0

vg_shad_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_OVER over

vg_over:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_over_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   vg_over_ret
        move.w  (a6,a1.l),qthg_over_mode(a4) ; 0/1
        moveq   #0,d0

vg_over_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_PARA size_x,size_y,angle,ibm,it_angle,it_slant,flags,mirror_x,mirror_y,outline

vg_para:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   vg_para_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #10,d3
        bne.s   vg_para_ret
        move.w  (a6,a1.l),d0            ; size_x
        andi.w  #$7F,d0
        move.w  d0,qthg_font_size_x(a4)
        move.w  2(a6,a1.l),d0           ; size_y
        andi.w  #$7F,d0
        move.w  d0,qthg_font_size_y(a4)
        move.w  4(a6,a1.l),d0           ; angle

vg_para_angle:                          
        subi.w  #360,d0
        bpl.s   vg_para_angle
        addi.w  #360,d0
        move.w  d0,qthg_font_angle(a4)
        move.w  6(a6,a1.l),qthg_font_ql2ibm(a4)
        move.w  8(a6,a1.l),d0           ; Italic angle

vg_para_italic_angle:                   
        subi.w  #180,d0
        bpl.s   vg_para_italic_angle
        addi.w  #180,d0
        move.w  d0,qthg_font_italic_angle(a4)
        move.w  10(a6,a1.l),d0          ; Italic slant

vg_para_italic_slant:                   
        subi.w  #180,d0
        bpl.s   vg_para_italic_slant
        addi.w  #180,d0
        move.w  d0,qthg_font_italic_slant(a4)
        move.w  12(a6,a1.l),qthg_font_flags(a4) ; Bold 0..15, right 16, down 32, left 64, top 128, shadow 256, pixel 512
        move.w  14(a6,a1.l),qthg_font_mirror_x(a4)
        move.w  16(a6,a1.l),qthg_font_mirror_y(a4)
        move.w  18(a6,a1.l),qthg_font_outline(a4)
        moveq   #0,d0

vg_para_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; VG_PRINT x,y,font,str$

vg_print:                               
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        move.l  a4,-(sp)
        bsr     get_vec_fonts_thing     ; Get vector thing in A4
        move.l  a4,d7
        movea.l (sp)+,a4
        move.l  a5,d0
        sub.l   a3,d0
        lsr.l   #3,d0
        cmpi.w  #4,d0                   ; Want 4 parameters
        bne.s   print_ret               ; $$$ No valid error return
        move.l  a5,-(sp)
        lea     3*8(a3),a5
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   print_ret4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #3,d3
        bne.s   print_ret4
        move.w  qthg_over_mode(a4),qthg_over_mode_copy(a4) ; Why not just use the original? No idea
        movea.l (sp),a5
        lea     -8(a5),a3
        movea.w sb.gtstr,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   print_ret4
        moveq   #err.nc,d0              ; $$$ Wrong error return?
        cmpi.w  #1,d3
        bne.s   print_ret
        movem.l a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        move.l  d7,d1                   ; Vector font thing
        lea     xtop_print(pc),a2
        trap    #3

print_ret4:                             
        addq.l  #4,sp

print_ret:                              
        rts

; =============== S U B R O U T I N E =======================================

xtop_print:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4
        movem.l qthg_workspace(a4),a1/a6
        move.w  (a6,a1.l),d0            ; String size
        addq.w  #1,d0
        bclr    #0,d0                   ; Round up to get to integer parameters
        move.l  d1,-(sp)                ; Vector font thing
        lea     2(a1,d0.w),a2
        move.w  (a6,a2.l),d0            ; X
        move.w  2(a6,a2.l),d1           ; Y
        move.w  4(a6,a2.l),d7           ; Font index
        andi.w  #$F,d7                  ; 0..15
        lsl.w   #2,d7                   ; *4
        move.l  a4,-(sp)
        movea.l 4(sp),a4                ; Vector font thing
        movea.l vthg_fonts(a4,d7.w),a0
        movea.l (sp)+,a4
        addq.l  #4,sp                   ; Forget font thing
        lea     font_base(a0),a0
        move.w  (a6,a1.l),d7            ; String length
        subq.w  #1,d7
        bmi     xtop_print_ok

xtop_print_char_loop:                   
        move.b  2(a6,a1.l),d2           ; Character
        tst.w   qthg_font_outline(a4)
        beq.s   xtop_print_normal
        movem.l d2/d7/a0-a1/a4/a6,-(sp)
        movem.w d0-d1,-(sp)             ; X/Y
        sub.w   qthg_font_outline(a4),d0
        bsr     print_char              ; a0 = ptr to BGI font
        movem.w (sp)+,d0-d1
        add.w   qthg_font_outline(a4),d0
        movem.l (sp),d2/d7/a0-a1/a4/a6
        bsr     print_char              ; a0 = ptr to BGI font
        movem.l (sp)+,d2/d7/a0-a1/a4/a6
        bra     xtop_print_next_char
; ---------------------------------------------------------------------------

xtop_print_normal:                      
        movem.w d0-d1,qthg_workspace(a4) ; X/Y
        move.w  qthg_font_flags(a4),d6  ; Bold 0..15, right 16, down 32, left 64, top 128, shadow 256, pixel 512
        move.w  d6,d3
        lsr.w   #4,d3
        andi.w  #$3F,d3 ; '?'           ; Other flags
        andi.w  #$F,d6                  ; Boldness
        tst.b   d3
        bne.s   xtop_print_bold
        moveq   #0,d6                   ; No flag -> not bold

xtop_print_bold:                        
        btst    #4,d3                   ; Shadow?
        beq.s   xtop_print_bold_loop
        move.w  qthg_shadow_col(a4),qthg_curr_ink_col(a4)

xtop_print_bold_loop:                   
        movem.w qthg_workspace(a4),d0-d1 ; X/Y
        tst.w   d6                      ; Another iteration?
        bne.s   xtop_print_is_bold
        move.w  qthg_ink_col(a4),qthg_curr_ink_col(a4)

xtop_print_is_bold:                     
        btst    #0,d3                   ; Right?
        beq.s   xtop_print_check_down
        add.w   d6,d0                   ; Adjust X
        bra.s   xtop_print_check_pixel
; ---------------------------------------------------------------------------

xtop_print_check_down:                  
        btst    #1,d3                   ; Down?
        beq.s   xtop_print_check_left
        sub.w   d6,d1                   ; Adjust Y
        bra.s   xtop_print_check_pixel
; ---------------------------------------------------------------------------

xtop_print_check_left:                  
        btst    #2,d3                   ; Left?
        beq.s   xtop_print_check_top
        sub.w   d6,d0                   ; Adjust X
        sub.w   d6,d1                   ; Adjust Y
        bra.s   xtop_print_check_pixel
; ---------------------------------------------------------------------------

xtop_print_check_top:                   
        btst    #3,d3                   ; Top?
        beq.s   xtop_print_check_pixel
        add.w   d6,d0                   ; Adjust X
        sub.w   d6,d1                   ; Adjust Y

xtop_print_check_pixel:                 
        btst    #5,d3                   ; Pixel?
        beq.s   xtop_print_char
        bclr    #5,d3                   ; Clear flag
        moveq   #1,d6                   ; Print 2 times

xtop_print_char:                        
        movem.l d2-d3/d6-d7/a0-a1/a4/a6,-(sp)
        bsr.s   print_char              ; a0 = ptr to BGI font
        movem.l (sp)+,d2-d3/d6-d7/a0-a1/a4/a6
        movem.w d0-d1,qthg_work_par2(a4)
        dbf     d6,xtop_print_bold_loop
        movem.w qthg_work_par2(a4),d0-d1

xtop_print_next_char:                   
        addq.l  #1,a1                   ; Next char
        dbf     d7,xtop_print_char_loop

xtop_print_ok:                          
        moveq   #0,d0
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts

; =============== S U B R O U T I N E =======================================
; a0 = ptr to BGI font

print_char:                             
        andi.w  #$FF,d2                 ; Character
        tst.w   qthg_font_ql2ibm(a4)    ; QL -> IBM?
        beq.s   pc_ibm
        lea     ql2ibm_table(pc),a1
        move.b  (a1,d2.w),d2            ; Get IBM character from QL character

pc_ibm:                                 
        moveq   #0,d3
        move.b  4(a0),d3                ; Start character
        sub.w   d3,d2                   ; Printable?
        bmi     pc_ret
        moveq   #0,d3
        move.b  1(a0),d3                ; Characters in font (is WORD really)
        sub.w   d2,d3
        bmi     pc_ret
        moveq   #0,d7
        move.b  1(a0),d7                ; Characters in font
        move.w  d7,d6
        lsl.w   #1,d7                   ; 2 * characters in font
        movem.l d0-d2/d7/a0,-(sp)       ; d0 = X, d1 = Y, d2 = char index in font, d7 = 2 * max char in font, a0 = font addr
        add.w   d7,d6
        lea     $10(a0,d6.w),a1         ; Stroke offset table
        lsl.w   #1,d2
        move.b  $11(a0,d2.w),d5         ; Get little endian word
        lsl.w   #8,d5
        move.b  $10(a0,d2.w),d5
        lea     (a1,d5.w),a0            ; Stroke data
        movem.w d0-d1,-(sp)             ; X/Y

pc_next_stroke:                         
        move.b  (a0)+,d6                ; Operation bit (7) + X ordinate (bits 6..0)
        move.b  (a0)+,d7                ; Operation bit (7) + Y ordinate (bits 6..0)
        move.b  d6,d4
        andi.b  #$80,d4                 ; Code 1
        lsr.b   #6,d4
        move.b  d7,d5
        andi.b  #$80,d5                 ; Code 2
        lsr.b   #7,d5
        add.b   d5,d4                   ; Code 1+2
        beq     pc_end_stroke
        andi.b  #$7F,d6                 ; X ordinate
        lsl.b   #1,d6
        asr.b   #1,d6                   ; Sign extend
        ext.w   d6
        muls.w  qthg_font_size_x(a4),d6
        andi.b  #$7F,d7                 ; Y ordinate
        lsl.b   #1,d7
        asr.b   #1,d7                   ; Sign extend
        ext.w   d7
        muls.w  qthg_font_size_y(a4),d7
        tst.w   qthg_font_mirror_x(a4)
        beq.s   pc_check_mirror_y
        neg.w   d6

pc_check_mirror_y:                      
        tst.w   qthg_font_mirror_y(a4)
        beq.s   pc_check_op
        neg.w   d7

pc_check_op:                            
        move.w  qthg_font_angle(a4),d5
        cmpi.b  #1,d4
        beq.s   pc_next_stroke
        cmpi.b  #2,d4
        bne     pc_draw_stroke
        movem.w (sp),d0-d1              ; OP 2 = only move plotter
        cmpi.w  #0,d5
        bne.s   pc_move_check_90
        asr.w   #3,d6                   ; /8
        asr.w   #3,d7
        add.w   d6,d0                   ; Change X/Y
        sub.w   d7,d1
        bra.s   pc_move_check_italic_angle
; ---------------------------------------------------------------------------

pc_move_check_90:                       
        cmpi.w  #90,d5
        bne.s   pc_move_check_180
        asr.w   #3,d6                   ; 90 degrees is easy
        asr.w   #3,d7
        add.w   d7,d0
        add.w   d6,d1
        bra.s   pc_move_check_italic_angle
; ---------------------------------------------------------------------------

pc_move_check_180:                      
        cmpi.w  #180,d5
        bne.s   pc_move_check_270
        asr.w   #3,d6                   ; 180 dregrees is easy
        asr.w   #3,d7
        sub.w   d6,d0
        add.w   d7,d1
        bra.s   pc_move_check_italic_angle
; ---------------------------------------------------------------------------

pc_move_check_270:                      
        cmpi.w  #270,d5
        bne.s   pc_move_angle
        asr.w   #3,d6                   ; 270 dregrees is easy
        asr.w   #3,d7
        sub.w   d7,d0
        sub.w   d6,d1
        bra.s   pc_move_check_italic_angle
; ---------------------------------------------------------------------------

pc_move_angle:                          
        lea     sincos_table(pc),a1
        lsl.w   #2,d5                   ; *4
        move.w  (a1,d5.w),d2            ; Get SIN value
        move.w  2(a1,d5.w),d3           ; Get COS value
        moveq   #17,d4
        movem.w d6-d7,-(sp)
        muls.w  d3,d6
        muls.w  d2,d7
        add.l   d6,d7
        asr.l   d4,d7
        add.w   d7,d0                   ; x += dx * cos(angle) + dy * sin(angle)
        movem.w (sp),d6-d7
        muls.w  d2,d6
        muls.w  d3,d7
        sub.l   d7,d6
        asr.l   d4,d6
        add.w   d6,d1                   ; y += dx * sin(angle) - dy * cos(angle)
        movem.w (sp)+,d6-d7

pc_move_check_italic_angle:             
        cmpi.w  #90,qthg_font_italic_angle(a4)
        beq.s   pc_check_italic_slant
        move.w  qthg_font_italic_angle(a4),d5
        lsl.w   #2,d5
        lea     sincos_table(pc),a1
        move.w  2(a1,d5.w),d5           ; COS
        muls.w  d5,d7                   ; COS(dy)
        moveq   #14,d5
        asr.l   d5,d7
        add.w   d7,d0                   ; x += dy * COS(angle)

pc_check_italic_slant:                  
        cmpi.w  #90,qthg_font_italic_slant(a4)
        beq     pc_next_stroke
        move.w  qthg_font_italic_slant(a4),d5
        lsl.w   #2,d5
        lea     sincos_table(pc),a1
        move.w  2(a1,d5.w),d5
        muls.w  d5,d6
        moveq   #14,d5
        asr.l   d5,d6
        sub.w   d6,d1                   ; y -= COS(angle)
        bra     pc_next_stroke
; ---------------------------------------------------------------------------

pc_draw_stroke:                         
        movem.w (sp),d2-d3              ; X/Y
        cmpi.w  #0,d5                   ; Font angle
        bne.s   pc_draw_check_90
        asr.w   #3,d6
        asr.w   #3,d7
        add.w   d6,d2
        sub.w   d7,d3
        bra.s   pc_draw_check_italic_angle
; ---------------------------------------------------------------------------

pc_draw_check_90:                       
        cmpi.w  #90,d5
        bne.s   pc_draw_check_180
        asr.w   #3,d6
        asr.w   #3,d7
        add.w   d7,d2
        add.w   d6,d3
        bra.s   pc_draw_check_italic_angle
; ---------------------------------------------------------------------------

pc_draw_check_180:                      
        cmpi.w  #180,d5
        bne.s   pc_draw_check_270
        asr.w   #3,d6
        asr.w   #3,d7
        sub.w   d6,d2
        add.w   d7,d3
        bra.s   pc_draw_check_italic_angle
; ---------------------------------------------------------------------------

pc_draw_check_270:                      
        cmpi.w  #270,d5
        bne.s   pc_draw_angle
        asr.w   #3,d6
        asr.w   #3,d7
        sub.w   d7,d2
        sub.w   d6,d3
        bra.s   pc_draw_check_italic_angle
; ---------------------------------------------------------------------------

pc_draw_angle:                          
        lea     sincos_table(pc),a1
        lsl.w   #2,d5
        movem.w d0-d1,-(sp)
        movem.w d6-d7,-(sp)
        move.w  (a1,d5.w),d0            ; SIN
        move.w  2(a1,d5.w),d1           ; COS
        moveq   #17,d4
        muls.w  d1,d6
        muls.w  d0,d7
        add.l   d6,d7
        asr.l   d4,d7
        add.w   d7,d2                   ; x += dx * cos(angle) + dy * sin(angle)
        movem.w (sp),d6-d7
        muls.w  d0,d6
        muls.w  d1,d7
        sub.l   d7,d6
        asr.l   d4,d6
        add.w   d6,d3                   ; y += dx * sin(angle) - dy * cos(angle)
        movem.w (sp)+,d6-d7
        movem.w (sp)+,d0-d1

pc_draw_check_italic_angle:             
        cmpi.w  #90,qthg_font_italic_angle(a4)
        beq.s   pc_draw_check_italic_slant
        move.w  qthg_font_italic_angle(a4),d5
        lsl.w   #2,d5
        lea     sincos_table(pc),a1
        move.w  2(a1,d5.w),d5
        muls.w  d5,d7
        moveq   #14,d5
        asr.l   d5,d7
        add.w   d7,d2                   ; x += dy * COS(angle)

pc_draw_check_italic_slant:             
        cmpi.w  #90,qthg_font_italic_slant(a4)
        beq.s   pc_draw_do
        move.w  qthg_font_italic_slant(a4),d5
        lsl.w   #2,d5
        lea     sincos_table(pc),a1
        move.w  2(a1,d5.w),d5
        muls.w  d5,d6
        moveq   #14,d5
        asr.l   d5,d6
        sub.w   d6,d3                   ; y -= COS(angle)

pc_draw_do:                             
        move.w  qthg_curr_ink_col(a4),d6
        bsr.s   line_do                 ; d0 = x1, d1 = y1, d2 = x2, d3 = y2, d6 = colour
        bra     pc_next_stroke
; ---------------------------------------------------------------------------

pc_end_stroke:                          
        addq.l  #4,sp
        movem.l (sp)+,d0-d2/d7/a0       ; d0 = X, d1 = Y, d2 = char index, d7 = 2*max char, a0 = font addr
        add.w   d2,d7                   ; d7 now index into character width table
        moveq   #0,d5
        move.b  $10(a0,d7.w),d5         ; Character width
        muls.w  qthg_font_size_x(a4),d5 ; Scale
        tst.w   qthg_font_mirror_x(a4)
        beq.s   pc_end_check_angle
        neg.w   d5

pc_end_check_angle:                     
        move.w  qthg_font_angle(a4),d4
        cmpi.w  #0,d4
        bne.s   pc_end_check_90
        asr.w   #3,d5
        add.w   d5,d0
        rts
; ---------------------------------------------------------------------------

pc_end_check_90:                        
        cmpi.w  #90,d4
        bne.s   pc_end_check_180
        asr.w   #3,d5
        add.w   d5,d1
        rts
; ---------------------------------------------------------------------------

pc_end_check_180:                       
        cmpi.w  #180,d4
        bne.s   pc_end_check_270
        asr.w   #3,d5
        sub.w   d5,d0
        rts
; ---------------------------------------------------------------------------

pc_end_check_270:                       
        cmpi.w  #270,d4
        bne.s   pc_end_all_angles
        asr.w   #3,d5
        sub.w   d5,d1
        rts
; ---------------------------------------------------------------------------

pc_end_all_angles:                      
        lea     sincos_table(pc),a1
        lsl.w   #2,d4
        move.w  (a1,d4.w),d2            ; SIN
        move.w  2(a1,d4.w),d3           ; COS
        moveq   #17,d4
        move.w  d5,d6
        muls.w  d3,d6
        asr.l   d4,d6
        add.w   d6,d0                   ; x += width * cos(angle)
        move.w  d5,d6
        muls.w  d2,d6
        asr.l   d4,d6
        add.w   d6,d1                   ; y += width * sin(angle)

pc_ret:                                 
        rts

; =============== S U B R O U T I N E =======================================
; d0 = x1, d1 = y1, d2 = x2, d3 = y2, d6 = colour

line_do:                                
        movem.l d2-d3/d6/a0,-(sp)
        cmp.w   d0,d2                   ; x1 > x2
        bge.s   line_prepare
        exg     d0,d2                   ; Swap x1/x2 and y1/y2
        exg     d1,d3

line_prepare:                           
        move.w  qthg_x_min(a4),d4
        move.w  qthg_x_max(a4),d5
        move.w  qthg_y_min(a4),d6
        move.w  qthg_y_max(a4),d7
        cmp.w   d4,d0                   ; x1 > x_min?
        bpl.s   line_x1_min_ok          ; Yes
        cmp.w   d4,d2                   ; x2 < x_min?
        bmi     linie_hori_ret          ; Yes -> line not visible
        movem.l d2-d3,-(sp)
        sub.w   d0,d2                   ; delta_x
        beq.s   line_x1_to_min
        sub.w   d1,d3                   ; delta_y
        sub.w   d4,d0                   ; x1_rel = x1 - x_min
        ext.l   d3
        lsl.l   #8,d3                   ; delta_y * 256
        divs.w  d2,d3                   ; slope * 256 = 256 * delta_y / delta_x
        muls.w  d0,d3                   ; x1_rel * slope * 256
        lsr.l   #8,d3                   ; x1_rel * slope
        sub.w   d3,d1                   ; y1 = y1 - x_rel * slope

line_x1_to_min:                         
        move.w  d4,d0                   ; x1 = x_min
        movem.l (sp)+,d2-d3

line_x1_min_ok:                         
        cmp.w   d5,d0                   ; x1 > x_max?
        bgt     linie_hori_ret          ; Yes -> line not visible
        cmp.w   d5,d2                   ; x2 < x_max?
        bmi.s   line_x2_max_ok
        movem.l d0-d1,-(sp)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ; delta_x
        beq.s   line_x2_to_max
        add.w   d3,d1                   ; delta_y
        ext.l   d1
        lsl.l   #8,d1                   ; delta_y * 256
        sub.w   d5,d2                   ; x2_rel = x_max - x2
        neg.w   d2
        divs.w  d0,d1                   ; slope * 256 = delta_y * 256 / delta_x
        muls.w  d2,d1                   ; x2_rel * slope * 256
        lsr.l   #8,d1                   ; x2_rel * slope
        add.w   d1,d3                   ; y2 = y2 + x2_rel * slope

line_x2_to_max:                         
        move.w  d5,d2                   ; x2 = x_max
        movem.l (sp)+,d0-d1

line_x2_max_ok:                         
        cmp.w   d6,d1                   ; y1 > y_min?
        bpl.s   line_y1_min_ok
        cmp.w   d6,d3                   ; y2 < y_min?
        bmi     linie_hori_ret          ; Yes -> line not visible
        movem.l d2-d3,-(sp)
        sub.w   d0,d2                   ; delta_x
        sub.w   d1,d3                   ; delta_y
        beq.s   line_y1_to_min
        ext.l   d2
        sub.w   d6,d1                   ; y1_rel = y1 - y_min
        lsl.l   #8,d2                   ; delta_x * 256
        divs.w  d3,d2                   ; slope * 256 = delta_x * 256 / delta_y
        muls.w  d1,d2                   ; y2_rel * slope * 256
        lsr.l   #8,d2                   ; y2_rel *slope
        sub.w   d2,d0                   ; x1 = x1 - y2_rel * slope

line_y1_to_min:                         
        move.w  d6,d1                   ; y1 = y_min
        movem.l (sp)+,d2-d3

line_y1_min_ok:                         
        cmp.w   d7,d1                   ; y1 <= y_max?
        bmi.s   line_y1_max_ok
        cmp.w   d7,d3
        bgt     linie_hori_ret
        movem.l d2-d3,-(sp)
        sub.w   d0,d2                   ; delta_x
        sub.w   d1,d3                   ; delta_y
        beq.s   line_y1_to_max
        ext.l   d2
        lsl.l   #8,d2                   ; delta_x * 256
        sub.w   d7,d1                   ; y1_rel = y_max - y1
        neg.w   d1
        divs.w  d3,d2                   ; slope * 256 = delta_x * 256 / delta_y
        muls.w  d1,d2                   ; y1_rel * slope * 256
        lsr.l   #8,d2                   ; y1_rel * slope
        add.w   d2,d0                   ; x1 = x1 + y1_rel * slope

line_y1_to_max:                         
        move.w  d7,d1                   ; y1 = y_max
        movem.l (sp)+,d2-d3

line_y1_max_ok:                         
        cmp.w   d6,d3                   ; y2 > y_min?
        bpl.s   line_y2_min_ok
        movem.l d0-d1,-(sp)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ; delta_x
        add.w   d3,d1                   ; delta_y
        beq.s   line_y2_to_min
        ext.l   d0
        sub.w   d6,d3                   ; y2_rel = y_min - y2
        lsl.l   #8,d0                   ; delta_x * 256
        divs.w  d1,d0                   ; slope * 256 = delta_x * 256 / delta_y
        muls.w  d3,d0                   ; y2_rel * slope * 256
        lsr.l   #8,d0                   ; y2_rel * slope
        sub.w   d0,d2                   ; x2 = x2 - y2_rel * slope

line_y2_to_min:                         
        move.w  d6,d3                   ; y2 = y_min
        movem.l (sp)+,d0-d1

line_y2_min_ok:                         
        cmp.w   d7,d3                   ; y2 < y_max?
        bmi.s   line_y2_max_ok
        movem.l d0-d1,-(sp)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   ; delta_x
        add.w   d3,d1                   ; delta_y
        beq.s   line_y2_to_max
        ext.l   d0
        lsl.l   #8,d0                   ; delta_x * 256
        sub.w   d7,d3                   ; y2_rel = y2 - y_max
        neg.w   d3
        divs.w  d1,d0                   ; slope * 256 = delta_x * 256 / delta_y
        muls.w  d3,d0                   ; y2_rel * slope * 256
        lsr.l   #8,d0                   ; y2_rel * slope
        add.w   d0,d2                   ; x2 = x2 + y2_rel * slope

line_y2_to_max:                         
        move.w  d7,d3                   ; y1 = y_max
        movem.l (sp)+,d0-d1

line_y2_max_ok:                         
        tst.w   qthg_over_mode_copy(a4)
        bne     line_over
        tst.w   qthg_mono_mode(a4)
        bne     line_mono
        move.l  8(sp),d6                ; Colour
        movea.l qthg_scr_base(a4),a0
        sub.w   d0,d2                   ; delta_x
        beq     line_vert               ; Vertical line
        move.w  d0,d5                   ; x1
        andi.w  #7,d5                   ; Pixel shift within first word
        lsr.w   #3,d0                   ; 8 pixels per word
        lsl.w   #1,d0                   ; Only even addresses
        adda.w  d0,a0                   ; Start address of column
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3                   ; delta_y
        beq     line_hori               ; Horizontal line
        bpl.s   line_pos_slope
        neg.w   d3
        neg.w   d4

line_pos_slope:                         
        move.w  #$8080,d0               ; Pixel mask
        ror.w   d5,d0                   ; Bitmask for line start
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0                   ; Start address of line
        cmp.w   d2,d3                   ; x or y direction?
        beq     line_diag               ; Diagonal
        bgt     line_y_dir               y direction
        move.w  d2,d7                    x direction
        neg.w   d7                      ; Prepare flag
        asr.w   #1,d7
        move.w  d2,d5
        move.w  d0,d1                   ; Bit mask
        ror.w   #1,d0                   ; Next column
        bcs.s   line_x_dir_next_word
        dbf     d5,line_x_dir_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_x_dir_next_pixel:                  
        add.w   d3,d7                   ; Check flag
        bpl.s   line_x_dir_next_line
        or.w    d0,d1                   ; Pixel mask
        ror.w   #1,d0                   ; Next column
        bcs.s   line_x_dir_next_word
        dbf     d5,line_x_dir_next_pixel ; Cumulate neighbouring pixels
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set all pixels in one go
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_x_dir_next_word:                   
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)+                ; Set pixel and advance word
        moveq   #0,d1
        dbf     d5,line_x_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_x_dir_next_line:                   
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixels before advancing line
        move.w  d0,d1
        adda.w  d4,a0                   ; Next screen line
        sub.w   d2,d7                   ; Subtract delta_x
        ror.w   #1,d0
        bcs.s   line_x_dir_next_word
        dbf     d5,line_x_dir_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_diag:                              
        move.w  d0,d1                   ; Diagonal line
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixel
        adda.w  d4,a0                   ; Next screen line
        ror.w   #1,d0
        bcs.s   line_diag_next_word
        dbf     d2,line_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_diag_next_word:                    
        addq.w  #2,a0
        dbf     d2,line_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_y_dir:                             
        move.w  d3,d7                   ; Prepare flag
        asr.w   #1,d7
        move.w  d3,d5
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixel
        adda.w  d4,a0                   ; Next screen line
        dbf     d5,line_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_y_dir_next_pixel:                  
        sub.w   d2,d7                   ; Check flag
        bmi.s   line_y_advance_x

line_y_dir_set_pixel:                   
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixel
        adda.w  d4,a0                   ; Next screen line
        dbf     d5,line_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_y_advance_x:                       
        add.w   d3,d7                   ; Flag
        ror.w   #1,d0                   ; Next bit column
        bcc.s   line_y_dir_set_pixel
        addq.w  #2,a0                   ; Next word
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        adda.w  d4,a0                   ; Next screen line
        dbf     d5,line_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_hori:                              
        move.w  #$8080,d0               ; Horzintal line
        ror.w   d5,d0                   ; Bitmask for column
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        addq.w  #1,d2                   ; d2 = delta_x
        tst.w   d5                      ; Word boundary
        beq.s   line_hori_full_words    ; Special
        subq.w  #1,d2
        moveq   #0,d1

line_hori_next_pixel:                   
        or.w    d0,d1                   ; Accumulate pixel
        ror.w   #1,d0
        bcs.s   line_hori_next_word
        dbf     d2,line_hori_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)                 ; Set pixels
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_hori_next_word:                    
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)+                ; Set pixels and advnce word
        bra.s   line_hori_full_words
; ---------------------------------------------------------------------------

line_hori_solid_word:                   
        move.w  d6,(a0)+                ; Fill all 8 pixels

line_hori_full_words:                   
        subq.w  #8,d2
        bpl.s   line_hori_solid_word
        cmpi.w  #$FFF8,d2
        beq.s   linie_hori_ret
        addq.w  #7,d2
        move.w  #$8080,d0
        move.w  d0,d1
        dbf     d2,line_hori_rest_pixels
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)

linie_hori_ret:                         
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_hori_rest_pixels:                  
        ror.w   #1,d0
        or.w    d0,d1
        dbf     d2,line_hori_rest_pixels
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_vert:                              
        move.w  d0,d5                   ; x in d5
        andi.w  #7,d5                   ; For colour mask
        lsr.w   #3,d0                   ; 8 pixels per word
        lsl.w   #1,d0                   ; Only even addresses
        adda.w  d0,a0                   ; Start of column
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3                   ; delta_y
        bpl.s   line_vert_pos_slope
        neg.w   d3
        neg.w   d4

line_vert_pos_slope:                    
        move.w  #$8080,d0               ; Bitmask for white
        ror.w   d5,d0                   ; Bitmask for line start
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0                   ; Start of line
        move.w  d0,d1
        and.w   d6,d1
        not.w   d0

line_vert_loop:                         
        and.w   d0,(a0)
        or.w    d1,(a0)                 ; Set point
        adda.w  d4,a0
        dbf     d3,line_vert_loop
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_mono:                              
        move.l  8(sp),d6                ; Colour
        movea.l qthg_scr_base(a4),a0
        sub.w   d0,d2
        beq     lm_vert
        move.w  d0,d5
        andi.w  #$F,d5
        lsr.w   #4,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        beq     lm_hori
        bpl.s   lm_pos_slope
        neg.w   d3
        neg.w   d4

lm_pos_slope:                           
        move.w  #$8000,d0
        ror.w   d5,d0
        mulu.w  $C(a4),d1
        adda.l  d1,a0
        cmp.w   d2,d3
        beq     lm_diag
        bgt     lm_y_dir
        move.w  d2,d7
        neg.w   d7
        asr.w   #1,d7
        move.w  d2,d5
        move.w  d0,d1
        ror.w   #1,d0
        bcs.s   lm_x_dir_next_word
        dbf     d5,lm_x_dir_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_x_dir_next_pixel:                    
        add.w   d3,d7
        bpl.s   lm_x_dir_next_line
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lm_x_dir_next_word
        dbf     d5,lm_x_dir_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_x_dir_next_word:                     
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)+
        moveq   #0,d1
        dbf     d5,lm_x_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_x_dir_next_line:                     
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        move.w  d0,d1
        adda.w  d4,a0
        sub.w   d2,d7
        ror.w   #1,d0
        bcs.s   lm_x_dir_next_word
        dbf     d5,lm_x_dir_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_diag:                                
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        adda.w  d4,a0
        ror.w   #1,d0
        bcs.s   lm_diag_next_word
        dbf     d2,lm_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_diag_next_word:                      
        addq.w  #2,a0
        dbf     d2,lm_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_y_dir:                               
        move.w  d3,d7
        asr.w   #1,d7
        move.w  d3,d5
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        adda.w  d4,a0
        dbf     d5,lm_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_y_dir_next_pixel:                    
        sub.w   d2,d7
        bmi.s   lm_y_advance_x

lm_y_dir_set_pixel:                     
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        adda.w  d4,a0
        dbf     d5,lm_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_y_advance_x:                         
        add.w   d3,d7
        ror.w   #1,d0
        bcc.s   lm_y_dir_set_pixel
        addq.w  #2,a0
        move.w  d0,d1
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        adda.w  d4,a0
        dbf     d5,lm_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_hori:                                
        move.w  #$8000,d0
        ror.w   d5,d0
        mulu.w  $C(a4),d1
        adda.l  d1,a0
        addq.w  #1,d2
        tst.w   d5
        beq.s   lm_h_full_words
        subq.w  #1,d2
        moveq   #0,d1

lm_h_next_pixel:                        
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lm_hi_next_word
        dbf     d2,lm_h_next_pixel
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_hi_next_word:                        
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)+
        bra.s   lm_h_full_words
; ---------------------------------------------------------------------------

lm_h_soli_word:                         
        move.w  d6,(a0)+

lm_h_full_words:                        
        subi.w  #$10,d2
        bpl.s   lm_h_soli_word
        cmpi.w  #$FFF0,d2
        beq.s   lm_h_ret
        addi.w  #15,d2
        move.w  #$8000,d0
        move.w  d0,d1
        dbf     d2,lm_h_rest_pixels
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)

lm_h_ret:                               
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_h_rest_pixels:                       
        ror.w   #1,d0
        or.w    d0,d1
        dbf     d2,lm_h_rest_pixels
        not.w   d1
        and.w   d1,(a0)
        not.w   d1
        and.w   d6,d1
        or.w    d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lm_vert:                                
        move.w  d0,d5
        andi.w  #15,d5
        lsr.w   #4,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        bpl.s   lm_v_pos_slope
        neg.w   d3
        neg.w   d4

lm_v_pos_slope:                         
        move.w  #%1000000000000000,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        move.w  d0,d1
        and.w   d6,d1
        not.w   d0

lm_v_loop:                              
        and.w   d0,(a0)
        or.w    d1,(a0)
        adda.w  d4,a0
        dbf     d3,lm_v_loop
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_over:                              
        tst.w   qthg_mono_mode(a4)
        bne     line_mono_over
        move.l  8(sp),d6                ; Colour
        movea.l qthg_scr_base(a4),a0
        sub.w   d0,d2
        beq     lo_vert
        move.w  d0,d5
        andi.w  #7,d5
        lsr.w   #3,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        beq     lo_hori
        bpl.s   lo_pos_slope
        neg.w   d3
        neg.w   d4

lo_pos_slope:                           
        move.w  #$8080,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        cmp.w   d2,d3
        beq.s   lo_diag
        bgt     lo_y_dir
        move.w  d2,d7
        neg.w   d7
        asr.w   #1,d7
        move.w  d2,d5
        move.w  d0,d1
        ror.w   #1,d0
        bcs.s   lo_x_dir_next_word
        dbf     d5,lo_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_x_dir_next_pixel:                    
        add.w   d3,d7
        bpl.s   lo_x_dir_next_line
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lo_x_dir_next_word
        dbf     d5,lo_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_x_dir_next_word:                     
        and.w   d6,d1
        eor.w   d1,(a0)+
        moveq   #0,d1
        dbf     d5,lo_x_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_x_dir_next_line:                     
        and.w   d6,d1
        eor.w   d1,(a0)
        move.w  d0,d1
        adda.w  d4,a0
        sub.w   d2,d7
        ror.w   #1,d0
        bcs.s   lo_x_dir_next_word
        dbf     d5,lo_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_diag:                                
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        ror.w   #1,d0
        bcs.s   lo_diag_next_word
        dbf     d2,lo_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_diag_next_word:                      
        addq.w  #2,a0
        dbf     d2,lo_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_y_dir:                               
        move.w  d3,d7
        asr.w   #1,d7
        move.w  d3,d5
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lo_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_y_dir_next_pixel:                    
        sub.w   d2,d7
        bmi.s   lo_y_advance_x

lo_y_dir_set_pixel:                     
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lo_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_y_advance_x:                         
        add.w   d3,d7
        ror.w   #1,d0
        bcc.s   lo_y_dir_set_pixel
        addq.w  #2,a0
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lo_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_hori:                                
        move.w  #$8080,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        addq.w  #1,d2
        tst.w   d5
        beq.s   lo_h_full_words
        subq.w  #1,d2
        moveq   #0,d1

lo_h_next_pixel:                        
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lo_h_next_word
        dbf     d2,lo_h_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_h_next_word:                         
        and.w   d6,d1
        eor.w   d1,(a0)+
        bra.s   lo_h_full_words
; ---------------------------------------------------------------------------

lo_h_solid_word:                        
        eor.w   d6,(a0)+

lo_h_full_words:                        
        subq.w  #8,d2
        bpl.s   lo_h_solid_word
        cmpi.w  #$FFF8,d2
        beq.s   lo_h_ret
        addq.w  #7,d2
        move.w  #$8080,d0
        move.w  d0,d1
        dbf     d2,lo_h_rest_pixels
        and.w   d6,d1
        eor.w   d1,(a0)

lo_h_ret:                               
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_h_rest_pixels:                       
        ror.w   #1,d0
        or.w    d0,d1
        dbf     d2,lo_h_rest_pixels
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lo_vert:                                
        move.w  d0,d5
        andi.w  #7,d5
        lsr.w   #3,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        bpl.s   lo_v_pos_slope
        neg.w   d3
        neg.w   d4

lo_v_pos_slope:                         
        move.w  #$8080,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        move.w  d0,d1
        and.w   d6,d1

lo_v_loop:                              
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d3,lo_v_loop
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

line_mono_over:                         
        move.l  8(sp),d6
        movea.l qthg_scr_base(a4),a0
        sub.w   d0,d2
        beq     lom_vert
        move.w  d0,d5
        andi.w  #15,d5
        lsr.w   #4,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        beq     lom_hori
        bpl.s   lom_pos_slope
        neg.w   d3
        neg.w   d4

lom_pos_slope:                          
        move.w  #$8000,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        cmp.w   d2,d3
        beq.s   lom_diag
        bgt     lom_y_dir
        move.w  d2,d7
        neg.w   d7
        asr.w   #1,d7
        move.w  d2,d5
        move.w  d0,d1
        ror.w   #1,d0
        bcs.s   lom_x_dir_next_word
        dbf     d5,lom_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_x_dir_next_pixel:                   
        add.w   d3,d7
        bpl.s   lom_x_dir_next_line
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lom_x_dir_next_word
        dbf     d5,lom_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_x_dir_next_word:                    
        and.w   d6,d1
        eor.w   d1,(a0)+
        moveq   #0,d1
        dbf     d5,lom_x_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_x_dir_next_line:                    
        and.w   d6,d1
        eor.w   d1,(a0)
        move.w  d0,d1
        adda.w  d4,a0
        sub.w   d2,d7
        ror.w   #1,d0
        bcs.s   lom_x_dir_next_word
        dbf     d5,lom_x_dir_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_diag:                               
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        ror.w   #1,d0
        bcs.s   lom_diag_next_word
        dbf     d2,lom_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_diag_next_word:                     
        addq.w  #2,a0
        dbf     d2,lom_diag
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_y_dir:                              
        move.w  d3,d7
        asr.w   #1,d7
        move.w  d3,d5
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lom_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_y_dir_next_pixel:                   
        sub.w   d2,d7
        bmi.s   lom_y_advance_x

lom_y_dir_set_pixel:                    
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lom_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_y_advance_x:                        
        add.w   d3,d7
        ror.w   #1,d0
        bcc.s   lom_y_dir_set_pixel
        addq.w  #2,a0
        move.w  d0,d1
        and.w   d6,d1
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d5,lom_y_dir_next_pixel
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_hori:                               
        move.w  #$8000,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        addq.w  #1,d2
        tst.w   d5
        beq.s   lom_h_full_words
        subq.w  #1,d2
        moveq   #0,d1

lom_h_next_pixel:                       
        or.w    d0,d1
        ror.w   #1,d0
        bcs.s   lom_h_next_word
        dbf     d2,lom_h_next_pixel
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_h_next_word:                        
        and.w   d6,d1
        eor.w   d1,(a0)+
        bra.s   lom_h_full_words
; ---------------------------------------------------------------------------

lom_h_solid_word:                       
        eor.w   d6,(a0)+

lom_h_full_words:                       
        subi.w  #$10,d2
        bpl.s   lom_h_solid_word
        cmpi.w  #$FFF0,d2
        beq.s   lom_h_ret
        addi.w  #$F,d2
        move.w  #$8000,d0
        move.w  d0,d1
        dbf     d2,lom_h_rest_pixels
        and.w   d6,d1
        eor.w   d1,(a0)

lom_h_ret:                              
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_h_rest_pixels:                      
        ror.w   #1,d0
        or.w    d0,d1
        dbf     d2,lom_h_rest_pixels
        and.w   d6,d1
        eor.w   d1,(a0)
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------

lom_vert:                               
        move.w  d0,d5
        andi.w  #15,d5
        lsr.w   #4,d0
        lsl.w   #1,d0
        adda.w  d0,a0
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        sub.w   d1,d3
        bpl.s   lom_v_pos_slope
        neg.w   d3
        neg.w   d4

lom_v_pos_slope:                        
        move.w  #$8000,d0
        ror.w   d5,d0
        mulu.w  qthg_scr_llen(a4),d1    ; Scr line length (bytes)
        adda.l  d1,a0
        move.w  d0,d1
        and.w   d6,d1

lom_v_loop:                             
        eor.w   d1,(a0)
        adda.w  d4,a0
        dbf     d3,lom_v_loop
        movem.l (sp)+,d0-d1/d6/a0
        rts
; ---------------------------------------------------------------------------
colour_tab4:dc.w 0,0,$FF,$FF,$FF00,$FF00,$FFFF,$FFFF 
ql2ibm_table:dc.b 0,1,2,3,4,5,6,7,8,9,$A,$B,$C,$D,$E,$F 
        dc.b $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F
        dc.b $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F
        dc.b $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F
        dc.b $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
        dc.b $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F
        dc.b $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F
        dc.b $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F
        dc.b $84,$86,$86,$82,$94,$95,$ED,$81,$80,$A4,$9E,$91,$A0,$85,$83,$89
        dc.b $8A,$88,$8B,$A1,$8D,$8C,$A2,$95,$93,$A3,$97,$96,$E1,$9B,$9D,$8B
        dc.b $8E,$8F,$8F,$90,$99,$A2,$ED,$9A,$87,$A5,$92,$92,$E0,$EB,$E9,$20
        dc.b $E6,$E3,$20,$A1,$A8,$20,$24,$20,$AE,$AF,$F8,$F6,$3C,$3E,$5E,$20
        dc.b $20,$20,$20,$20,$20,$6E,$20,$E2,5,3,4,6,$5E,$20,$EC,$EA
        dc.b $EF,$20,$20,$E4,$30,$59,$C5,$C5,$F0,$F1,$87,$F0,$F3,$F0,$F2,$F7
        dc.b $FE,$DB,$DB,$91,$20,$EE,$20,$79,$20,$20,$20,$20,$AC,$AB,$20,$20
        dc.b $20,$20,$20,$E5,$E7,$20,$FB,$20,$20,$20,$20,$20,$B3,$20,$20,$20
sincos_table:dc.w 0,$4000,$11D,$3FFD,$23B,$3FF6,$359,$3FE9,$476,$3FD8,$593,$3FC1,$6B0,$3FA6,$7CC,$3F85 
        dc.w $8E8,$3F60,$A03,$3F36,$B1D,$3F07,$C36,$3ED2,$D4E,$3E99,$E65,$3E5C,$F7B,$3E19,$1090,$3DD1
        dc.w $11A4,$3D85,$12B6,$3D34,$13C6,$3CDE,$14D6,$3C83,$15E3,$3C23,$16EF,$3BBF,$17F9,$3B56,$1901,$3AE9
        dc.w $1A07,$3A77,$1B0C,$3A00,$1C0E,$3985,$1D0E,$3906,$1E0B,$3882,$1F07,$37F9,$2000,$376C,$20F6,$36DB
        dc.w $21EA,$3646,$22DB,$35AC,$23C9,$350E,$24B5,$346C,$259E,$33C6,$2684,$331C,$2766,$326E,$2846,$31BC
        dc.w $2923,$3106,$29FC,$304D,$2AD3,$2F8F,$2BA5,$2ECE,$2C75,$2E09,$2D41,$2D41,$2E09,$2C75,$2ECE,$2BA5
        dc.w $2F8F,$2AD3,$304D,$29FC,$3106,$2923,$31BC,$2846,$326E,$2766,$331C,$2684,$33C6,$259E,$346C,$24B5
        dc.w $350E,$23C9,$35AC,$22DB,$3646,$21EA,$36DB,$20F6,$376C,$2000,$37F9,$1F07,$3882,$1E0B,$3906,$1D0E
        dc.w $3985,$1C0E,$3A00,$1B0C,$3A77,$1A07,$3AE9,$1901,$3B56,$17F9,$3BBF,$16EF,$3C23,$15E3,$3C83,$14D6
        dc.w $3CDE,$13C6,$3D34,$12B6,$3D85,$11A4,$3DD1,$1090,$3E19,$F7B,$3E5C,$E65,$3E99,$D4E,$3ED2,$C36
        dc.w $3F07,$B1D,$3F36,$A03,$3F60,$8E8,$3F85,$7CC,$3FA6,$6B0,$3FC1,$593,$3FD8,$476,$3FE9,$359
        dc.w $3FF6,$23B,$3FFD,$11D,$4000,0,$3FFD,$FEE2,$3FF6,$FDC4,$3FE9,$FCA6,$3FD8,$FB89,$3FC1,$FA6C
        dc.w $3FA6,$F94F,$3F85,$F833,$3F60,$F717,$3F36,$F5FC,$3F07,$F4E2,$3ED2,$F3C9,$3E99,$F2B1,$3E5C,$F19A
        dc.w $3E19,$F084,$3DD1,$EF6F,$3D85,$EE5B,$3D34,$ED49,$3CDE,$EC39,$3C83,$EB29,$3C23,$EA1C,$3BBF,$E910
        dc.w $3B56,$E806,$3AE9,$E6FE,$3A77,$E5F8,$3A00,$E4F3,$3985,$E3F1,$3906,$E2F1,$3882,$E1F4,$37F9,$E0F8
        dc.w $376C,$E000,$36DB,$DF09,$3646,$DE15,$35AC,$DD24,$350E,$DC36,$346C,$DB4A,$33C6,$DA61,$331C,$D97B
        dc.w $326E,$D899,$31BC,$D7B9,$3106,$D6DC,$304D,$D603,$2F8F,$D52C,$2ECE,$D45A,$2E09,$D38A,$2D41,$D2BE
        dc.w $2C75,$D1F6,$2BA5,$D131,$2AD3,$D070,$29FC,$CFB2,$2923,$CEF9,$2846,$CE43,$2766,$CD91,$2684,$CCE3
        dc.w $259E,$CC39,$24B5,$CB93,$23C9,$CAF1,$22DB,$CA53,$21EA,$C9B9,$20F6,$C924,$2000,$C893,$1F07,$C806
        dc.w $1E0B,$C77D,$1D0E,$C6F9,$1C0E,$C67A,$1B0C,$C5FF,$1A07,$C588,$1901,$C516,$17F9,$C4A9,$16EF,$C440
        dc.w $15E3,$C3DC,$14D6,$C37C,$13C6,$C321,$12B6,$C2CB,$11A4,$C27A,$1090,$C22E,$F7B,$C1E6,$E65,$C1A3
        dc.w $D4E,$C166,$C36,$C12D,$B1D,$C0F8,$A03,$C0C9,$8E8,$C09F,$7CC,$C07A,$6B0,$C059,$593,$C03E
        dc.w $476,$C027,$359,$C016,$23B,$C009,$11D,$C002,0,$C000,$FEE2,$C002,$FDC4,$C009,$FCA6,$C016
        dc.w $FB89,$C027,$FA6C,$C03E,$F94F,$C059,$F833,$C07A,$F717,$C09F,$F5FC,$C0C9,$F4E2,$C0F8,$F3C9,$C12D
        dc.w $F2B1,$C166,$F19A,$C1A3,$F084,$C1E6,$EF6F,$C22E,$EE5B,$C27A,$ED49,$C2CB,$EC39,$C321,$EB29,$C37C
        dc.w $EA1C,$C3DC,$E910,$C440,$E806,$C4A9,$E6FE,$C516,$E5F8,$C588,$E4F3,$C5FF,$E3F1,$C67A,$E2F1,$C6F9
        dc.w $E1F4,$C77D,$E0F8,$C806,$E000,$C893,$DF09,$C924,$DE15,$C9B9,$DD24,$CA53,$DC36,$CAF1,$DB4A,$CB93
        dc.w $DA61,$CC39,$D97B,$CCE3,$D899,$CD91,$D7B9,$CE43,$D6DC,$CEF9,$D603,$CFB2,$D52C,$D070,$D45A,$D131
        dc.w $D38A,$D1F6,$D2BE,$D2BE,$D1F6,$D38A,$D131,$D45A,$D070,$D52C,$CFB2,$D603,$CEF9,$D6DC,$CE43,$D7B9
        dc.w $CD91,$D899,$CCE3,$D97B,$CC39,$DA61,$CB93,$DB4A,$CAF1,$DC36,$CA53,$DD24,$C9B9,$DE15,$C924,$DF09
        dc.w $C893,$DFFF,$C806,$E0F8,$C77D,$E1F4,$C6F9,$E2F1,$C67A,$E3F1,$C5FF,$E4F3,$C588,$E5F8,$C516,$E6FE
        dc.w $C4A9,$E806,$C440,$E910,$C3DC,$EA1C,$C37C,$EB29,$C321,$EC39,$C2CB,$ED49,$C27A,$EE5B,$C22E,$EF6F
        dc.w $C1E6,$F084,$C1A3,$F19A,$C166,$F2B1,$C12D,$F3C9,$C0F8,$F4E2,$C0C9,$F5FC,$C09F,$F717,$C07A,$F833
        dc.w $C059,$F94F,$C03E,$FA6C,$C027,$FB89,$C016,$FCA6,$C009,$FDC4,$C002,$FEE2,$C000,$FFFF,$C002,$11D
        dc.w $C009,$23B,$C016,$359,$C027,$476,$C03E,$593,$C059,$6B0,$C07A,$7CC,$C09F,$8E8,$C0C9,$A03
        dc.w $C0F8,$B1D,$C12D,$C36,$C166,$D4E,$C1A3,$E65,$C1E6,$F7B,$C22E,$1090,$C27A,$11A4,$C2CB,$12B6
        dc.w $C321,$13C6,$C37C,$14D6,$C3DC,$15E3,$C440,$16EF,$C4A9,$17F9,$C516,$1901,$C588,$1A07,$C5FF,$1B0C
        dc.w $C67A,$1C0E,$C6F9,$1D0E,$C77D,$1E0B,$C806,$1F07,$C893,$1FFF,$C924,$20F6,$C9B9,$21EA,$CA53,$22DB
        dc.w $CAF1,$23C9,$CB93,$24B5,$CC39,$259E,$CCE3,$2684,$CD91,$2766,$CE43,$2846,$CEF9,$2923,$CFB2,$29FC
        dc.w $D070,$2AD3,$D131,$2BA5,$D1F6,$2C75,$D2BE,$2D41,$D38A,$2E09,$D45A,$2ECE,$D52C,$2F8F,$D603,$304D
        dc.w $D6DC,$3106,$D7B9,$31BC,$D899,$326E,$D97B,$331C,$DA61,$33C6,$DB4A,$346C,$DC36,$350E,$DD24,$35AC
        dc.w $DE15,$3646,$DF09,$36DB,$DFFF,$376C,$E0F8,$37F9,$E1F4,$3882,$E2F1,$3906,$E3F1,$3985,$E4F3,$3A00
        dc.w $E5F8,$3A77,$E6FE,$3AE9,$E806,$3B56,$E910,$3BBF,$EA1C,$3C23,$EB29,$3C83,$EC39,$3CDE,$ED49,$3D34
        dc.w $EE5B,$3D85,$EF6F,$3DD1,$F084,$3E19,$F19A,$3E5C,$F2B1,$3E99,$F3C9,$3ED2,$F4E2,$3F07,$F5FC,$3F36
        dc.w $F717,$3F60,$F833,$3F85,$F94F,$3FA6,$FA6C,$3FC1,$FB89,$3FD8,$FCA6,$3FE9,$FDC4,$3FF6,$FEE2,$3FFD

; =============== S U B R O U T I N E =======================================
; MOVEPARA scr_addr, scr_width, scr_height, scr_x, scr_y, mem_base, mem_llen_words
;
; Initialise parameters for TOSCR/TOMEM

movepara:                               
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   movepara_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #7,d3                   ; Want 7 parameters
        bne.s   movepara_ret
        move.l  (a6,a1.l),qthg_move_scr_base(a4) ; Screen address
        move.l  4(a6,a1.l),qthg_move_scr_width(a4) ; Width in words
        move.l  8(a6,a1.l),qthg_move_scr_height(a4) ; Height in lines
        move.l  12(a6,a1.l),qthg_move_scr_x(a4) ; X address in words
        move.l  16(a6,a1.l),qthg_move_scr_y(a4) ; y position in lines
        move.l  20(a6,a1.l),qthg_img_base(a4)
        move.l  24(a6,a1.l),qthg_img_llen_w(a4)
        moveq   #0,d0

movepara_ret:                           
        rts

; =============== S U B R O U T I N E =======================================
; TOSCR x_pos, y_pos

toscr:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4

do_toscr:                               
        bsr     get_xy_para             ; Get X and Y, a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        movem.l d3-d4/d7/a0/a2,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_toscr(pc),a2
        trap    #3
        rts

; =============== S U B R O U T I N E =======================================

xtop_toscr:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movem.l qthg_workspace(a1),d3-d4/d7/a0/a2 ; a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        tst.w   qthg_mono_mode(a1)
        bne.s   toscr_mono
        move.l  d4,d6                   ; Scr height
        move.l  d3,d5                   ; Scr width (words)
        lsl.l   #1,d5                   ; Bytes
        sub.l   d5,d7                   ; Image line gap (bytes)
        moveq   #0,d5
        move.w  qthg_scr_llen(a1),d5    ; Scr line length (words)
        lsr.l   #1,d5                   ; In words
        sub.l   d3,d5                   ; Scr line gap (words)
        lsl.l   #1,d5                   ; Scr line gap (bytes)
        bra.s   toscr_loop_start
; ---------------------------------------------------------------------------

toscr_loop:                             
        move.l  d3,d4
        ror.l   #4,d4
        bra.s   toscr_line_copy_start
; ---------------------------------------------------------------------------

toscr_line_copy_loop:                   
        movem.l (a2)+,d0-d2/a1/a3-a6    ; Fast copy
        movem.l d0-d2/a1/a3-a6,(a0)
        lea     32(a0),a0

toscr_line_copy_start:                  
        dbf     d4,toscr_line_copy_loop
        clr.w   d4
        rol.l   #4,d4
        bra.s   toscr_rest_copy_start
; ---------------------------------------------------------------------------

toscr_rest_copy_loop:                   
        move.w  (a2)+,(a0)+

toscr_rest_copy_start:                  
        dbf     d4,toscr_rest_copy_loop
        adda.l  d5,a0
        adda.l  d7,a2

toscr_loop_start:                       
        dbf     d6,toscr_loop           ; Loop over lines
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

toscr_mono:                             
        move.l  d4,d6                   ; Scr height
        move.l  d3,d5                   ; Scr width (words)
        sub.l   d5,d7                   ; Image line gap
        moveq   #0,d5
        move.w  qthg_scr_llen(a1),d5    ; Scr line length (bytes)
        lsr.l   #1,d5                   ; Scr line length (words)
        sub.l   d3,d5                   ; Scr line gap (words)
        lsl.l   #1,d5                   ; Scr line gap (bytes)
        bra.s   toscr_mono_loop_start
; ---------------------------------------------------------------------------

toscr_mono_loop:                        
        move.l  d3,d4
        ror.l   #4,d4
        bra.s   toscr_mono_copy_line_start
; ---------------------------------------------------------------------------

toscr_mono_copy_line_loop:              
        move.l  (a2)+,d0
        movep.l d0,0(a0)
        movep.l d0,1(a0)
        move.l  (a2)+,d0
        movep.l d0,8(a0)
        movep.l d0,9(a0)
        move.l  (a2)+,d0
        movep.l d0,$10(a0)
        movep.l d0,$11(a0)
        move.l  (a2)+,d0
        movep.l d0,$18(a0)
        movep.l d0,$19(a0)
        lea     32(a0),a0

toscr_mono_copy_line_start:             
        dbf     d4,toscr_mono_copy_line_loop
        clr.w   d4
        rol.l   #4,d4
        bra.s   toscr_mono_copy_rest_start
; ---------------------------------------------------------------------------

toscr_mono_copy_rest_loop:              
        move.b  (a2),(a0)+
        move.b  (a2)+,(a0)+

toscr_mono_copy_rest_start:             
        dbf     d4,toscr_mono_copy_rest_loop
        adda.l  d5,a0
        adda.l  d7,a2

toscr_mono_loop_start:                  
        dbf     d6,toscr_mono_loop
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; TOMEM x,y

tomem:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        bsr     get_xy_para             ; Get X and Y, a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        movem.l d3-d4/d7/a0/a2,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_tomem(pc),a2
        trap    #3
        rts

; =============== S U B R O U T I N E =======================================

xtop_tomem:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movem.l qthg_workspace(a1),d3-d4/d7/a0/a2 ; a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        tst.w   qthg_mono_mode(a1)
        bne.s   tomem_mono
        exg     a2,a0
        move.l  d4,d6                   ; Scr height
        move.l  d3,d5                   ; Scr width (words)
        lsl.l   #1,d5                   ; Scr width (bytes)
        sub.l   d5,d7                   ; Image line gap (bytes)
        moveq   #0,d5
        move.w  qthg_scr_llen(a1),d5    ; Scr line length (bytes)
        lsr.l   #1,d5                   ; Scr line length (words)
        sub.l   d3,d5                   ; Scr line gap (words)
        lsl.l   #1,d5                   ; Scr line gap (bytes)
        bra.s   tomem_loop_start
; ---------------------------------------------------------------------------

tomem_loop:                             
        move.l  d3,d4
        ror.l   #4,d4
        bra.s   tomem_copy_line_start
; ---------------------------------------------------------------------------

tomem_copy_line_loop:                   
        movem.l (a2)+,d0-d2/a1/a3-a6
        movem.l d0-d2/a1/a3-a6,(a0)
        lea     32(a0),a0

tomem_copy_line_start:                  
        dbf     d4,tomem_copy_line_loop
        clr.w   d4
        rol.l   #4,d4
        bra.s   tomem_copy_rest_start
; ---------------------------------------------------------------------------

tomem_copy_rest_loop:                   
        move.w  (a2)+,(a0)+

tomem_copy_rest_start:                  
        dbf     d4,tomem_copy_rest_loop
        adda.l  d5,a2
        adda.l  d7,a0

tomem_loop_start:                       
        dbf     d6,tomem_loop
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

tomem_mono:                             
        exg     a2,a0
        move.l  d4,d6                   ; Scr height
        move.l  d3,d5                   ; Scr width (words)
        sub.l   d5,d7                   ; Scr width (bytes)
        moveq   #0,d5
        move.w  qthg_scr_llen(a1),d5    ; Scr line length (bytes)
        lsr.l   #1,d5                   ; Scr line length (words)
        sub.l   d3,d5                   ; Image line gap (words)
        lsl.l   #1,d5                   ; Image line gap (bytes)
        bra.s   tomem_mono_loop_start
; ---------------------------------------------------------------------------

tomem_mono_loop:                        
        move.l  d3,d4
        ror.l   #4,d4
        bra.s   tomem_mono_copy_loop_start
; ---------------------------------------------------------------------------

tomem_mono_copy_line_loop:              
        movep.l 0(a2),d0
        move.l  d0,(a0)+
        movep.l 8(a2),d0
        move.l  d0,(a0)+
        movep.l $10(a2),d0
        move.l  d0,(a0)+
        movep.l $18(a2),d0
        move.l  d0,(a0)+
        lea     $20(a2),a2

tomem_mono_copy_loop_start:             
        dbf     d4,tomem_mono_copy_line_loop
        clr.w   d4
        rol.l   #4,d4
        bra.s   tomem_mono_copy_rest_start
; ---------------------------------------------------------------------------

tomem_mono_copy_rest_loop:              
        move.b  (a2),(a0)+
        addq.l  #2,a2

tomem_mono_copy_rest_start:             
        dbf     d4,tomem_mono_copy_rest_loop
        adda.l  d5,a2
        adda.l  d7,a0

tomem_mono_loop_start:                  
        dbf     d6,tomem_mono_loop
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; Get X and Y, a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen

get_xy_para:                            
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   xy_para_exit
        cmpi.w  #2,d3
        bne.s   xy_para_ipar
        movea.l qthg_move_scr_base(a4),a0 ; Screen address
        move.l  qthg_move_scr_x(a4),d1  ; X address in words
        lsl.l   #1,d1                   ; Now bytes
        adda.l  d1,a0                   ; Start of column
        move.l  qthg_move_scr_y(a4),d2  ; y position in lines
        move.w  qthg_scr_llen(a4),d3    ; Scr line length (bytes)
        mulu.w  d3,d2                   ; * line length
        adda.l  d2,a0                   ; Start of line
        move.l  qthg_move_scr_width(a4),d3 ; Width in words
        move.l  qthg_move_scr_height(a4),d4 ; Height in lines
        movea.l qthg_img_base(a4),a2    ; Address in memory
        move.l  (a6,a1.l),d5            ; X address in words
        lsl.l   #1,d5                   ; Bytes
        adda.l  d5,a2                   ; Start of column
        move.l  4(a6,a1.l),d6           ; Y-address in lines
        move.l  qthg_img_llen_w(a4),d7  ; Width in words
        lsl.l   #1,d7                   ; Bytes
        mulu.w  d7,d6                   ; d7 = bytes per line (image)
        adda.l  d6,a2
        rts
; ---------------------------------------------------------------------------

xy_para_ipar:                           
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        tst.w   d0

xy_para_exit:                           
        addq.l  #4,sp
        rts

; =============== S U B R O U T I N E =======================================
; ZOOM level, x_pos, y_pos

zoom:                                   
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        cmpi.w  #3,d1                   ; Exactly 3 parameters
        beq.s   zoom_get_int
        rts
; ---------------------------------------------------------------------------

zoom_get_int:                           
        move.l  a5,-(sp)
        lea     8(a3),a5
        movea.w sb.gtint,a0    
        jsr     (a0)
        movea.l (sp)+,a5
        lea     8(a3),a3
        tst.w   d0
        beq.s   zoom_level_check
        rts
; ---------------------------------------------------------------------------

zoom_level_check:                       
        move.w  (a6,a1.l),d1            ; Zoom level
        beq     do_toscr                ; Zoom level 0 is direct copy
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #2,d1
        beq.s   zoom_do
        cmpi.w  #4,d1
        beq.s   zoom_do
        cmpi.w  #8,d1
        beq.s   zoom_do
        rts
; ---------------------------------------------------------------------------

zoom_do:                                
        move.l  d1,qthg_workspace(a4)
        bsr     get_xy_para             ; Get X and Y, a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        movem.l d3-d4/d7/a0/a2,qthg_work_par2(a4)
        moveq   #9,d0
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_zoom(pc),a2
        trap    #3
        rts

; =============== S U B R O U T I N E =======================================

xtop_zoom:                              
        movem.l d3-d7/a0/a2-a6,-(sp)
        movem.l qthg_workspace(a1),d0/d3-d4/d7/a0/a2 ; a0=p_scr, a2=p_img, d3=scr width (words), d4=scr height, d7=img llen
        tst.w   qthg_mono_mode(a1)
        bne     zoom_mono
        move.w  qthg_scr_llen(a1),d6    ; Scr line length (bytes)
        mulu.w  d0,d6                   ; Next line in zoom level
        divu.w  d0,d4                   ; Remaining height in zoomed mode
        subq.w  #1,d4                   ; For DBRA
        move.b  #128,d5                 ; Single bit
        subq.w  #1,d0
        asr.b   d0,d5                   ; Mask for a zoomed pixel
        addq.w  #1,d0                   ; Zoomlevel++
        move.l  d6,qthg_workspace(a1)   ; Next line in zoom level
        move.l  d7,qthg_work_par2(a1)   ; Line length im image

zoom_line_loop:                         
        move.w  d3,d2                   ; Scr width (words)
        movem.l a0/a2,-(sp)

zoom_word_loop:                         
        moveq   #7,d1                   ; 8 bits per byte
        move.b  (a2)+,d6                ; Green byte
        move.b  (a2)+,d7                ; Red byte

zoom_pixel_loop:                        
        lsl.b   #1,d6
        bcc.s   zoom_green_0
        or.b    d5,(a0)                 ; Zoom pixel mask
        bra.s   zoom_check_red
; ---------------------------------------------------------------------------

zoom_green_0:                           
        not.b   d5                      ; Zoom pixel mask
        and.b   d5,(a0)
        not.b   d5

zoom_check_red:                         
        lsl.b   #1,d7
        bcc.s   zoom_red_0
        or.b    d5,1(a0)                ; Zoom pixel mask
        bra.s   zoom_next_pixel
; ---------------------------------------------------------------------------

zoom_red_0:                             
        not.b   d5
        and.b   d5,1(a0)
        not.b   d5

zoom_next_pixel:                        
        ror.b   d0,d5
        bcs.s   zoom_mask_advance
        dbf     d1,zoom_pixel_loop
        bra.s   zoom_word_loop
; ---------------------------------------------------------------------------

zoom_mask_advance:                      
        addq.l  #2,a0
        subq.w  #1,d2                   ; Scr width (words)
        beq.s   zoom_next_line
        dbf     d1,zoom_pixel_loop
        bra.s   zoom_word_loop
; ---------------------------------------------------------------------------

zoom_next_line:                         
        movem.l (sp),a0/a2
        movem.w d0/d3,-(sp)
        moveq   #0,d1
        subq.w  #1,d3                   ; Scr width (words)
        move.w  qthg_scr_llen(a1),d1    ; Scr line length (bytes)
        subq.w  #2,d0                   ; Now zoomlevel - 1

zoom_fill_rest_line_loop:               
        move.w  d0,d2                   ; Zoomlevel - 1
        movea.l a0,a2
        movea.w (a0)+,a4

zoom_fill_rest_loop:                    
        adda.l  d1,a2
        move.w  a4,(a2)
        dbf     d2,zoom_fill_rest_loop
        dbf     d3,zoom_fill_rest_line_loop
        movem.w (sp)+,d0/d3
        movem.l (sp)+,a0/a2
        adda.l  qthg_work_par2(a1),a2
        adda.l  qthg_workspace(a1),a0
        dbf     d4,zoom_line_loop       ; Height in zoomed mode
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------

zoom_mono:                              
        move.w  qthg_scr_llen(a1),d6    ; Scr line length (bytes)
        mulu.w  d0,d6
        divu.w  d0,d4
        subq.w  #1,d4
        move.b  #128,d5
        subq.w  #1,d0
        asr.b   d0,d5
        addq.w  #1,d0
        move.l  d6,qthg_workspace(a1)

zoom_mono_line_loop:                    
        move.w  d3,d2
        movem.l a0/a2,-(sp)

zoom_mono_word_loop:                    
        moveq   #7,d1
        move.b  (a2)+,d6

zoom_mono_pixel_loop:                   
        lsl.b   #1,d6
        bcc.s   zoom_mono_black
        or.b    d5,(a0)
        or.b    d5,1(a0)
        bra.s   zoom_mono_next_pixel
; ---------------------------------------------------------------------------

zoom_mono_black:                        
        not.b   d5
        and.b   d5,(a0)
        and.b   d5,1(a0)
        not.b   d5

zoom_mono_next_pixel:                   
        ror.b   d0,d5
        bcs.s   zoom_mono_mask_advance
        dbf     d1,zoom_mono_pixel_loop
        bra.s   zoom_mono_word_loop
; ---------------------------------------------------------------------------

zoom_mono_mask_advance:                 
        addq.l  #2,a0
        subq.w  #1,d2
        beq.s   zoom_mono_next_line
        dbf     d1,zoom_mono_pixel_loop
        bra.s   zoom_mono_word_loop
; ---------------------------------------------------------------------------

zoom_mono_next_line:                    
        movem.l (sp),a0/a2
        movem.w d0/d3,-(sp)
        moveq   #0,d1
        subq.w  #1,d3
        move.w  qthg_scr_llen(a1),d1    ; Scr line length (bytes)
        subq.w  #2,d0

zoom_mono_fill_rest_line_loop:          
        move.w  d0,d2
        movea.l a0,a2
        movea.w (a0)+,a4

zoom_mono_fill_rest_loop:               
        adda.l  d1,a2
        move.w  a4,(a2)
        dbf     d2,zoom_mono_fill_rest_loop
        dbf     d3,zoom_mono_fill_rest_line_loop
        movem.w (sp)+,d0/d3
        movem.l (sp)+,a0/a2
        adda.l  d7,a2
        adda.l  qthg_workspace(a1),a0
        dbf     d4,zoom_mono_line_loop
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts

; =============== S U B R O U T I N E =======================================
; PAINT x,y,colour

paint:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        move.w  qthg_mono_mode(a4),qthd_tmp_mode(a4)
        clr.w   qthg_mono_mode(a4)
        clr.w   qthg_over_mode_copy(a4)
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   paint_ret
        cmpi.w  #3,d3
        bne.s   paint_ret
        movem.l a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_paint(pc),a2
        trap    #3

paint_ret:                              
        move.l  qthd_tmp_mode(a4),qthg_mono_mode(a4) ; Long???
        rts

; =============== S U B R O U T I N E =======================================

xtop_paint:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4
        movem.l qthg_workspace(a4),a1/a6
        move.w  (a6,a1.l),d0            ; X
        move.w  2(a6,a1.l),d1           ; Y
        move.w  4(a6,a1.l),d7           ; Colour
        lea     colour_tab4(pc),a2
        andi.w  #7,d7                   ; 0..7
        lsl.w   #1,d7
        move.w  (a2,d7.w),d6            ; Colour bits
        lsr.w   #2,d7                   ; 0..3
        movea.l qthg_scr_base(a4),a0
        lea     qthg_fill_buffer(a4),a3
        moveq   #0,d4
        move.w  qthg_scr_llen(a4),d4    ; Scr line length (bytes)
        lsl.l   #2,d4                   ; *4 (pixels per byte) = xres
        move.w  qthg_scr_yres(a4),d5
        cmp.w   d4,d0
        bhi.s   paint_ok
        cmp.w   d5,d1
        bhi.s   paint_ok
        moveq   #0,d2
        lea     cfg_fill_buffer_size(pc),a5
        move.b  (a5),d2                 ; Buffer size
        mulu.w  #1024,d2                ; In kilobytes
        adda.l  d2,a4                   ; WTF?
        lea     (a4),a5                 ; WTF? Fill stack base
        suba.l  d2,a4                   ; WTF?
        lea     paint_proc_end(pc),a1
        move.l  a1,-(a5)
        bsr     read_pixel              ; Read reference colour in d3
        tst.w   qthg_paint_with_pattern(a4) ; True to paint with pattern, false to paint with colour
        bne.s   paint_patt_mode
        cmp.b   d3,d7                   ; Already same colour?
        beq.s   paint_ok                ; Yes, done

paint_patt_mode:                        
        cmp.b   d3,d7                   ; These can never be equal, can they?
        bne.s   paint_start
        not.w   d6                      ; So this can also never happen I guess

paint_start:                            
        move.w  d3,d7                   ; Reference colour
        move.w  #$FFFF,(a3)             ; Mark buffer empty for now
        bra.s   paint_do
; ---------------------------------------------------------------------------

paint_proc_end:                         
        tst.w   qthg_paint_with_pattern(a4) ; True to paint with pattern, false to paint with colour
        beq.s   paint_ok
        lea     qthg_fill_buffer(a4),a3 ; Buffer with x1/y/x2 coordinates to fill
        movea.l qthg_patt_addr(a4),a2   ; Paint pattern address
        bsr     paint_pattern

paint_ok:                               
        movem.l (sp)+,d3-d7/a0/a2-a6
        moveq   #0,d0
        rts
; ---------------------------------------------------------------------------
; Start scanning from d0 = x, d1 = y in line for its colour
; Will get d0 = left edge, d2 = right edge

paint_do:                               
        cmpa.l  a3,a5                   ; Buffer full?
        bmi.s   paint_ok                ; Yes, exit
        bsr     check_escape
        beq.s   paint_ok
        move.w  d7,d5                   ; Reference colour
        bsr     read_pixel              ; d0 = x, d1 = y, d4 = img width, a0 = img base -> d3 = colour
        move.w  d3,d7                   ; Scan colour

paint_scan_left:                        
        subq.w  #1,d0                   ; Scan pixel to the left
        cmp.w   qthg_x_min(a4),d0
        bmi.s   paint_left_edge
        bsr     read_pixel              ; d0 = x, d1 = y, d4 = img width, a0 = img base -> d3 = colour
        cmp.b   d3,d7                   ; Stil the same colour?
        beq.s   paint_scan_left         ; Continue scanning

paint_left_edge:                        
        addq.w  #1,d0                   ; Back off one pixel again
        move.w  d0,-(a5)                ; Save left edge

paint_scan_right:                       
        addq.w  #1,d0                   ; Scan to the right. Seems inefficient to not start at the left scan origin
        cmp.w   qthg_x_max(a4),d0
        bpl.s   paint_right_edge
        bsr     read_pixel              ; d0 = x, d1 = y, d4 = img width, a0 = img base -> d3 = colour
        cmp.b   d3,d7
        beq.s   paint_scan_right

paint_right_edge:                       
        subq.w  #1,d0                   ; Right edge
        move.w  (a5)+,d2                ; Left edge
        move.w  d0,-2(a5)               ; Remember right edge
        exg     d0,d2                   ; d0 = x-left, d2 = x-right
        exg     d7,d5                   ; d7 = reference colour again
        cmp.b   d7,d5
        bne.s   paint_next              ; Not the colour we want to paint
        movem.l d0-d1/d4-d7/a0,-(a5)
        move.w  d1,d3                   ; y2 = y1 for line
        tst.w   qthg_paint_with_pattern(a4) ; True to paint with pattern, false to paint with colour
        beq.s   paint_line
        movem.w d0-d2,(a3)              ; Push x-left, y and x-right into pattern fill buffer
        addq.l  #6,a3
        move.w  #$FFFF,(a3)             ; New top

paint_line:                             
        bsr     line_do                 ; Draw line. Will return x-right in d0
        move.w  d0,d2                   ; d2 = x-right again
        movem.l (a5)+,d0-d1/d4-d7/a0
        movem.w d0-d2,-(a5)             ; Push x-left, y, x-right to stack
        subq.w  #1,d1                   ; y--
        cmp.w   qthg_y_min(a4),d1
        bmi.s   paint_move_down

paint_scan_up:                          
        movem.w d0-d2,-(a5)             ; Push x-left, y, x-right to stack
        lea     paint_cb_up(pc),a1
        move.l  a1,-(a5)                ; Push routine to stack
        bra.s   paint_do
; ---------------------------------------------------------------------------

paint_cb_up:                            
        movem.w (a5)+,d0-d2             ; Pop x-left, y, x-right
        cmp.w   d3,d2                   ; d3 is x-right + 1 from paint_next
        bmi.s   paint_move_down
        move.w  d3,d0                   ; x-left = x-right + 1
        bra.s   paint_scan_up
; ---------------------------------------------------------------------------

paint_move_down:                        
        movem.w (a5),d0-d2              ; Get x-left, y, x-right
        addq.w  #1,d1                   ; y++
        cmp.w   qthg_y_max(a4),d1
        bhi.s   paint_next_pop

paint_scan_down:                        
        movem.w d0-d2,-(a5)             ; Push x-left, y, x-right
        lea     paint_cb_down(pc),a1
        move.l  a1,-(a5)                ; Push routine to stack
        bra     paint_do
; ---------------------------------------------------------------------------

paint_cb_down:                          
        movem.w (a5)+,d0-d2             ; Pop x-left, y, x-right
        cmp.w   d3,d2
        bmi.s   paint_next_pop
        move.w  d3,d0
        bra.s   paint_scan_down         ; Push x-left, y, x-right
; ---------------------------------------------------------------------------

paint_next_pop:                         
        movem.w (a5)+,d0-d2             ; Pop x-left, y, x-right

paint_next:                             
        move.w  -2(a5),d3               ; x-right
        addq.w  #1,d3
        movea.l (a5)+,a1
        jmp     (a1)

; =============== S U B R O U T I N E =======================================

paint_pattern:                          
        bsr     check_escape
        beq.s   ppatt_ret
        movem.w (a3)+,d0-d2
        tst.w   d0
        bmi.s   ppatt_ret
        cmp.w   qthg_y_min(a4),d1
        bmi.s   paint_next
        cmp.w   qthg_y_max(a4),d1
        bhi.s   paint_next
        movem.l d4/a0,qthg_work_scr_xres(a4) ; xres/screen base

ppatt_loop:                             
        movem.w d0-d2,-(a5)
        cmp.w   qthg_x_min(a4),d0
        bmi.s   ppatt_skip
        cmp.w   qthg_x_max(a4),d0
        bhi.s   ppatt_skip
        movem.l d0-d1,qthg_dst_x(a4)    ; Copy pattern pixel
        bsr.s   read_pattern_pixel
        movem.l qthg_dst_x(a4),d0-d1
        bsr     paint_pixel             ; d3 = colour 0..3
        movem.l qthg_work_scr_xres(a4),d4/a0

ppatt_skip:                             
        movem.w (a5)+,d0-d2
        addq.w  #1,d0                   ; Next pixel
        cmp.w   d0,d2
        bpl.s   ppatt_loop
        bra.s   paint_pattern
; ---------------------------------------------------------------------------

ppatt_ret:                              
        rts

; =============== S U B R O U T I N E =======================================
; d0 = x, d1 = y, d4 = img width, a0 = img base -> d3 = colour

read_pixel:                             
        move.l  a0,-(sp)
        tst.w   qthg_mono_mode(a4)
        bne.s   read_mono_pixel
        move.w  d4,d3
        lsr.w   #2,d3                   ; /4 = line length in words
        mulu.w  d1,d3
        adda.l  d3,a0                   ; Now in right line
        move.w  d0,d3
        lsr.w   #3,d3                   ; 8 pixels per word
        lsl.w   #1,d3                   ; Always even address
        adda.w  d3,a0
        move.w  d0,d2                   ; x position
        andi.w  #7,d2                   ; Shift for pixel
        move.w  #$8080,d3               ; Pixel mask
        lsr.w   d2,d3                   ; Shift mask
        and.w   (a0),d3                 ; Get pixel
        lsl.w   d2,d3                   ; G.......R.......
        ror.b   #1,d3                   ; G........R......
        rol.w   #1,d3                   .....R......G
        rol.b   #1,d3                   ...........GR
        movea.l (sp)+,a0
        rts
; ---------------------------------------------------------------------------

read_mono_pixel:                        
        move.w  d4,d3
        lsr.w   #3,d3
        mulu.w  d1,d3
        adda.l  d3,a0
        move.w  d0,d3
        lsr.w   #3,d3
        adda.w  d3,a0
        move.w  d0,d2
        andi.w  #7,d2
        moveq   #0,d3
        move.b  #$80,d3
        lsr.b   d2,d3
        and.b   (a0),d3
        lsl.b   d2,d3
        rol.b   #1,d3
        tst.b   d3
        beq.s   read_mono_pixel_exit
        moveq   #3,d3                   ; White

read_mono_pixel_exit:                   
        movea.l (sp)+,a0
        rts

; =============== S U B R O U T I N E =======================================

read_pattern_pixel:                     
        move.l  a2,-(sp)
        andi.l  #$FFFF,d0               ; x
        andi.l  #$FFFF,d1               ; y
        divu.w  qthg_patt_height(a4),d1 ; Paint pattern height (to wrap around)
        swap    d1
        divu.w  qthg_patt_width(a4),d0  ; Paint pattern width (to wrap around)
        swap    d0
        mulu.w  qthg_patt_llen(a4),d1
        adda.l  d1,a2
        move.w  d0,d3
        lsr.w   #3,d3                   ; 8 pixels per word
        lsl.w   #1,d3                   ; Always even address
        adda.w  d3,a2
        move.w  d0,d2                   ; x position
        andi.w  #7,d2                   ; Shift for pixel
        move.w  #$8080,d3               ; Pixel mask
        lsr.w   d2,d3                   ; Move into place
        and.w   (a2),d3                 ; Get colour bits
        lsl.w   d2,d3                   ; G.......R.......
        ror.b   #1,d3                   ; G........R......
        rol.w   #1,d3                   .....R......G
        rol.b   #1,d3                   ...........GR
        movea.l (sp)+,a2
        rts

; =============== S U B R O U T I N E =======================================
; S_SAVE filename,addr,size,mode

s_save:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        cmpi.w  #4,d1                   ; 4 parameters
        bne     ss_ret
        move.l  a5,-(sp)
        lea     8(a3),a5
        movea.w sb.gtstr,a0    
        jsr     (a0)
        movea.l (sp)+,a5
        tst.w   d0
        bne     ss_ret
        move.w  (a6,a1.l),d7            ; String size
        addq.w  #1,d7
        lea     qthg_workspace(a4),a0

ss_copy_name:                           
        move.b  (a6,a1.l),(a0)+
        addq.l  #1,a1
        dbf     d7,ss_copy_name
        lea     8(a3),a3                ; Skip filename
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   ss_ret
        move.l  (a6,a1.l),qthg_buffer_ptr(a4) ; Addr
        move.l  4(a6,a1.l),qthg_buffer_size(a4) ; Size
        move.l  8(a6,a1.l),qthd_tmp_mode(a4)
        moveq   #ioa.open,d0            ; OPEN IOSS channel
        moveq   #-1,d1
        moveq   #ioa.kovr,d3            ; Key for OVeRwrite (delete contents if it exists)
        lea     qthg_workspace(a4),a0
        trap    #2
        tst.w   d0
        bne.s   ss_ret
        move.l  qthg_buffer_size(a4),d7 ; Uncompressed size (in words)
        movea.l qthg_buffer_ptr(a4),a5  ; Address
        movea.l a5,a1
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        moveq   #pic_image,d2           ; 10 bytes (pic header)
        moveq   #-1,d3
        trap    #3
        adda.w  #pic_image,a5           ; Skip to image
        subq.l  #5,d7                   ; 5 words less

ss_loop:                                
        move.w  (a5),d0
        cmp.w   2(a5),d0
        bne.s   ss_diff
        cmpi.l  #2,d7                   ; Less than 2 words left?
        blt.s   ss_diff                 ; Yes, go write it
        bsr.s   save_rle                ; Do RLE
        bra.s   ss_next
; ---------------------------------------------------------------------------

ss_diff:                                
        bsr.s   save_uncompressed

ss_next:                                
        tst.w   d0
        bne.s   ss_close
        tst.l   d7
        bne.s   ss_loop
        moveq   #iof.rhdr,d0            ; Read file HeaDeR
        moveq   #14,d2
        moveq   #-1,d3
        lea     qthg_workspace(a4),a1
        trap    #3
        move.l  qthg_buffer_size(a4),qthg_workspace+hdr_info(a4) ; additional information
        move.b  qthg_file_type(a4),qthg_workspace+hdr_type(a4) ; file TYPE
        moveq   #iof.shdr,d0            ; Set file HeaDeR
        moveq   #-1,d3
        lea     qthg_workspace(a4),a1
        trap    #3
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        trap    #2

ss_ret:                                 
        rts
; ---------------------------------------------------------------------------

ss_close:                               
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        trap    #2
        moveq   #ioa.delf,d0            ; DELete file from device
        moveq   #-1,d1
        lea     qthg_workspace(a4),a0
        trap    #2
        moveq   #err.drfl,d0            ; DRive FuLl
        rts

; =============== S U B R O U T I N E =======================================

save_rle:                               
        movea.l a5,a3                   ; Image ptr
        move.w  (a5)+,d4                ; Reference word
        subq.l  #1,d7
        moveq   #0,d6

srle_loop:                              
        cmp.w   (a5),d4                 ; Still same?
        bne.s   srle_write
        addq.w  #1,d6
        subq.l  #1,d7
        beq.s   srle_write
        addq.l  #2,a5
        cmpi.w  #127,d6                 ; Maximum 127 words
        bne.s   srle_loop

srle_write:                             
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        move.w  d6,d1                   ; Write RLE counter
        addi.w  #128,d1
        moveq   #-1,d3
        trap    #3
        tst.w   d0
        bne.s   srle_ret
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        moveq   #2,d2                   ; Write the repeated word
        moveq   #-1,d3
        movea.l a3,a1
        trap    #3

srle_ret:                               
        rts

; =============== S U B R O U T I N E =======================================

save_uncompressed:                      
        movea.l a5,a3                   ; Image ptr
        moveq   #0,d6
        subq.l  #1,d7
        beq.s   sunc_write

sunc_loop:                              
        move.w  (a3)+,d0                ; Next word
        cmp.w   (a3),d0                 ; Starts repeating again?
        beq.s   sunc_write
        addq.w  #1,d6
        subq.l  #1,d7
        beq.s   sunc_write
        cmpi.w  #127,d6
        bne.s   sunc_loop

sunc_write:                             
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        move.b  d6,d1
        moveq   #-1,d3
        trap    #3
        tst.w   d0
        bne.s   sunc_ret
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        addq.w  #1,d6
        move.w  d6,d2
        lsl.w   #1,d2                   ; This many bytes
        moveq   #-1,d3
        movea.l a5,a1
        trap    #3
        movea.l a1,a5

sunc_ret:                               
        rts

; =============== S U B R O U T I N E =======================================
; S_LOAD filename,addr

s_load:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        cmpi.w  #2,d1
        bne     sl_ret
        move.l  a5,-(sp)
        lea     8(a3),a5
        movea.w sb.gtstr,a0    
        jsr     (a0)
        movea.l (sp)+,a5
        lea     8(a3),a3
        tst.w   d0
        bne     sl_ret
        move.w  (a6,a1.l),d7
        addq.w  #1,d7
        lea     qthg_workspace(a4),a0

sl_copy_filename:                       
        move.b  (a6,a1.l),(a0)+
        addq.l  #1,a1
        dbf     d7,sl_copy_filename
        movea.w sb.gtlin,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   sl_ret
        move.l  (a6,a1.l),qthg_buffer_ptr(a4)
        moveq   #ioa.open,d0            ; OPEN IOSS channel
        moveq   #-1,d1
        moveq   #ioa.kexc,d3            ; Key for EXClusive use (read/write)
        lea     qthg_workspace(a4),a0
        trap    #2
        tst.w   d0
        bne.s   sl_ret
        moveq   #iof.rhdr,d0            ; Read file HeaDeR
        moveq   #hdr_name,d2            ; file name (up to 36 characters long)
        moveq   #-1,d3
        lea     qthg_workspace(a4),a1
        trap    #3
        tst.w   d0
        bne.s   sl_close
        move.l  qthg_workspace+hdr_info(a4),qthg_buffer_size(a4) ; additional information
        movea.l qthg_buffer_ptr(a4),a5
        moveq   #iob.fmul,d0            ; Fetch MULtiple characters/bytes
        moveq   #pic_image,d2           ; Image data
        moveq   #-1,d3
        movea.l a5,a1
        trap    #3
        adda.w  #pic_image,a5           ; Image data

sl_loop:                                
        moveq   #iob.fbyt,d0            ; Fetch BYTe from input
        moveq   #-1,d3
        trap    #3
        tst.w   d0
        bne.s   sl_check_err
        andi.l  #$FF,d1
        cmpi.b  #127,d1
        bhi.s   sl_rle
        bsr.s   fmul_d1_words           ; FMUL d1+1 words to a5 (updated)
        bra.s   sl_check_err
; ---------------------------------------------------------------------------

sl_rle:                                 
        bsr.s   fmul_rle_word           ; Read one word and repeat that x times

sl_check_err:                           
        tst.w   d0
        beq.s   sl_loop

sl_close:                               
        move.l  d0,-(sp)                ; Remember error
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        trap    #2
        move.l  (sp)+,d0
        cmpi.w  #err.eof,d0             ; End Of File
        bne.s   sl_ret
        moveq   #0,d0                   ; Ignore EOF

sl_ret:                                 
        rts

; =============== S U B R O U T I N E =======================================
; FMUL d1+1 words to a5 (updated)

fmul_d1_words:                          
        moveq   #iob.fmul,d0            ; Fetch MULtiple characters/bytes
        addq.w  #1,d1
        lsl.w   #1,d1
        move.w  d1,d2
        moveq   #-1,d3
        movea.l a5,a1
        trap    #3
        movea.l a1,a5
        rts

; =============== S U B R O U T I N E =======================================
; Read one word and repeat that x times

fmul_rle_word:                          
        moveq   #iob.fmul,d0            ; Fetch MULtiple characters/bytes
        subi.w  #128,d1
        move.w  d1,d5
        moveq   #2,d2                   ; One word
        moveq   #-1,d3
        movea.l a5,a1
        trap    #3
        tst.w   d0
        bne.s   fmul_rle_ret
        move.w  (a5),d1                 ; That's out word

fmul_rle_loop:                          
        move.w  d1,(a5)+                ; Repeat it d5 times
        dbf     d5,fmul_rle_loop

fmul_rle_ret:                           
        rts

; =============== S U B R O U T I N E =======================================
; PREV mem_height, sample_x, sample_y - Make preview of image

prev:                                   
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        move.l  a5,d1
        sub.l   a3,d1
        lsr.l   #3,d1
        cmpi.w  #3,d1                   ; 3 parameters
        bne.s   prev_ret
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   prev_ret
        movem.l a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_prev(pc),a2
        trap    #3

prev_ret:                               
        rts

; =============== S U B R O U T I N E =======================================

xtop_prev:                              
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4                   ; Thing data
        movem.l qthg_workspace(a4),a1/a6
        move.w  (a6,a1.l),qthg_prev_height(a4) ; Mem height
        moveq   #0,d6
        move.w  2(a6,a1.l),d6           ; sample_x - How many pixels to sample into one
        moveq   #0,d7
        move.w  4(a6,a1.l),d7           ; sample_y - How many pixels to sample into one
        subq.w  #1,qthg_prev_height(a4)
        clr.l   qthg_work_img_y(a4)
        move.l  qthg_img_llen_w(a4),d0
        tst.w   qthg_mono_mode(a4)
        beq.s   prev_mode4
        lsl.l   #4,d0                   ; *16
        bra.s   prev_all
; ---------------------------------------------------------------------------

prev_mode4:                             
        lsl.l   #3,d0                   ; *8

prev_all:                               
        move.l  d0,qthg_work_img_width(a4)
        move.l  qthg_img_base(a4),qthg_work_img_base(a4)
        moveq   #0,d0
        move.w  qthg_y_min(a4),d0
        move.l  d0,qthg_dst_y(a4)
        move.w  qthg_scr_llen(a4),d0    ; Scr line length (bytes)
        lsl.l   #2,d0                   ; Now xres (as 4 pixel per byte)
        move.l  d0,qthg_work_scr_xres(a4)
        move.l  qthg_move_scr_base(a4),qthg_work_scr_base(a4) ; Screen address

prev_adv_y:                             
        bsr     check_escape
        beq.s   prev_exit
        clr.l   qthg_work_img_x(a4)
        moveq   #0,d0
        move.w  qthg_x_min(a4),d0
        move.l  d0,qthg_dst_x(a4)

prev_adv_x:                             
        bsr.s   sample_pixel_work       ; Return mean colour in d3
        bsr.s   paint_pixel             ; d3 = colour 0..3
        add.l   d6,qthg_work_img_x(a4)
        addq.l  #1,qthg_dst_x(a4)
        move.l  qthg_img_llen_w(a4),d0
        tst.w   qthg_mono_mode(a4)
        beq.s   prev_mode4_2
        lsl.l   #4,d0                   ; *16
        bra.s   prev_all_2
; ---------------------------------------------------------------------------

prev_mode4_2:                           
        lsl.l   #3,d0                   ; *8

prev_all_2:                             
        sub.l   qthg_work_img_x(a4),d0
        subq.l  #1,d0
        bpl.s   prev_adv_x
        add.l   d7,qthg_work_img_y(a4)
        addq.l  #1,qthg_dst_y(a4)
        moveq   #0,d0
        move.w  qthg_prev_height(a4),d0
        sub.l   qthg_work_img_y(a4),d0
        subq.l  #1,d0
        bpl.s   prev_adv_y

prev_exit:                              
        moveq   #0,d0
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts

; =============== S U B R O U T I N E =======================================
; Return mean colour in d3

sample_pixel_work:                      
        movem.l qthg_workspace(a4),d0-d1/d4/a0 ; d0 = x, d1 = y, d4 = image_width, a0 = image base

; =============== S U B R O U T I N E =======================================
; Calc mean of pixels, d0=x, d1=y, d4=img width, d6=s_width, d7=s_height, a0=img base

sample_pixel:                           
        movem.l d6-d7,-(sp)
        subq.w  #1,d6                   ; Adjust for DBF
        subq.w  #1,d7
        clr.w   qthg_pixel_accu(a4)

sample_loop_y:                          
        movem.l d0/d6,-(sp)

sample_loop_x:                          
        bsr     read_pixel              ; d0 = x, d1 = y, d4 = img width, a0 = img base -> d3 = colour
        add.w   d3,qthg_pixel_accu(a4)
        addq.w  #1,d0
        dbf     d6,sample_loop_x
        movem.l (sp)+,d0/d6
        addq.w  #1,d1
        dbf     d7,sample_loop_y
        movem.l (sp)+,d6-d7
        move.w  d6,d0
        mulu.w  d7,d0                   ; How many pixels in the sample
        moveq   #0,d3
        move.w  qthg_pixel_accu(a4),d3
        divu.w  d0,d3                   ; Calculate mean
        rts

; =============== S U B R O U T I N E =======================================
; d3 = colour 0..3

paint_pixel:                            
        movem.l qthg_dst_x(a4),d0-d1/d4/a0 ; d0 = x, d1 = y, d4 = llen * 4, a0 = img base
        lsr.l   #2,d4                   ; llen
        mulu.w  d1,d4                   ; Line offset
        adda.l  d4,a0                   ; Line in image
        move.l  d0,d1                   ; x
        lsr.l   #3,d0                   ; 8 pixels per word
        lsl.l   #1,d0                   ; Address is always even
        adda.l  d0,a0                   ; Word address in image
        andi.l  #7,d1                   ; x shift within word
        ror.w   #1,d3                   ; R00000000000000G
        lsl.b   #7,d3                   ; R0000000G0000000
        lsr.w   d1,d3                   ; Shift colour into position
        ror.w   #8,d3                   ; Exchange R and G
        move.w  #$7F7F,d0               ; Pixel mask
        ror.w   d1,d0                   ; Shift mask into position
        tst.w   qthg_over_mode(a4)
        beq.s   paint_pixel_normal
        cmpi.w  #1,qthg_over_mode(a4)
        beq.s   paint_pixel_or
        eor.w   d3,(a0)                 ; XOR pixel
        rts
; ---------------------------------------------------------------------------

paint_pixel_normal:                     
        and.w   d0,(a0)                 ; Set pixel

paint_pixel_or:                         
        or.w    d3,(a0)                 ; OR pixel
        rts

; =============== S U B R O U T I N E =======================================
; INOUT dx1,dy1,dx2,dy2,sx1,sy1,sx2,sy2 - Copy/stretch source area into destination area

inout:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   inout_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #8,d3
        bne.s   inout_ret
        movem.l a1/a6,qthg_workspace(a4)
        moveq   #iow.xtop,d0            ; eXTernal OPeration on screen
        moveq   #-1,d3
        movea.l qthg_chid(a4),a0
        movea.l a4,a1
        lea     xtop_inout(pc),a2
        trap    #3

inout_ret:                              
        rts

; =============== S U B R O U T I N E =======================================

xtop_inout:                             
        movem.l d3-d7/a0/a2-a6,-(sp)
        movea.l a1,a4
        movem.l qthg_workspace(a4),a1/a6
        moveq   #8,d5
        moveq   #0,d0
        move.w  8(a6,a1.l),d0           ; sx1
        lsl.l   d5,d0                   ; *256
        move.l  d0,qthg_sx1(a4)
        moveq   #0,d0
        move.w  10(a6,a1.l),d0          ; sy1
        lsl.l   d5,d0                   ; *256
        move.l  d0,qthg_src_y(a4)
        moveq   #0,d0
        move.w  (a6,a1.l),d0            ; dx1
        move.l  d0,qthg_io_dx1(a4)
        move.w  2(a6,a1.l),d0           ; dy1
        move.l  d0,qthg_dst_y(a4)
        moveq   #0,d7
        move.w  4(a6,a1.l),d7           ; dx2
        sub.w   (a6,a1.l),d7            ; dx1
        bpl.s   io_check_height
        neg.w   d7                      ; d7 = dst width
        move.w  4(a6,a1.l),d0           ; New dx1
        move.l  d0,qthg_io_dx1(a4)

io_check_height:                        
        moveq   #0,d6
        move.w  6(a6,a1.l),d6           ; dy2
        sub.w   2(a6,a1.l),d6           ; dy1
        bpl.s   io_prepare
        neg.w   d6
        move.w  6(a6,a1.l),d0           ; New dy1
        move.l  d0,qthg_dst_y(a4)

io_prepare:                             
        move.w  qthg_scr_llen(a4),d0    ; Scr line length (bytes)
        lsl.l   #2,d0                   ; Now in pixels
        move.l  d0,qthg_work_scr_xres(a4)
        move.l  qthg_move_scr_base(a4),qthg_work_scr_base(a4) ; Screen address
        move.l  qthg_img_llen_w(a4),d0
        tst.w   qthg_mono_mode(a4)
        beq.s   io_mode4
        lsl.l   #4,d0                   ; *16
        bra.s   io_all
; ---------------------------------------------------------------------------

io_mode4:                               
        lsl.l   #3,d0                   ; *8

io_all:                                 
        move.l  d0,qthg_work_img_width(a4)
        move.l  qthg_img_base(a4),qthg_work_img_base(a4)
        moveq   #0,d0
        move.w  12(a6,a1.l),d0          ; sx2
        sub.w   8(a6,a1.l),d0           ; sx1
        ext.l   d0                      ; src width
        asl.l   d5,d0                   ; *256
        divs.w  d7,d0                   ; / dest width
        ext.l   d0
        move.l  d0,qthg_x_ratio(a4)
        moveq   #0,d0
        move.w  14(a6,a1.l),d0          ; sy2
        sub.w   10(a6,a1.l),d0          ; sy1
        ext.l   d0
        asl.l   d5,d0                   ; *256
        divs.w  d6,d0                   ; / dest height
        ext.l   d0
        move.l  d0,qthg_y_ratio(a4)

io_line_loop:                           
        bsr     check_escape
        beq     io_ret
        move.l  d7,-(sp)                ; dest width
        move.l  qthg_src_y(a4),d0
        addi.l  #127,d0                 ; +0.5
        lsr.l   d5,d0                   ; Round
        move.l  d0,qthg_work_img_y(a4)  ; Now in pixel coordinates again
        move.l  qthg_sx1(a4),qthg_src_x(a4) ; Reset x counters
        move.l  qthg_io_dx1(a4),qthg_dst_x(a4)

io_pixels_loop:                         
        move.l  qthg_src_x(a4),d0
        addi.l  #127,d0                 ; +0.5
        lsr.l   d5,d0                   ; Round
        move.l  d0,qthg_work_img_x(a4)  ; Now in pixel coordinates again
        movem.l qthg_work_img_x(a4),d0-d1/d4/a0 ; img_x, img_y, img_width, img_base
        tst.w   qthg_rotate(a4)         ; Exchange X/Y during INOUT or PRINT
        beq.s   io_rot
        exg     d0,d1

io_rot:                                 
        movem.l d6-d7,-(sp)             ; Save x/y counter
        moveq   #1,d6                   ; Sample only 1x1 pixel if "good" is not enabled
        moveq   #1,d7
        tst.w   qthg_hc_good(a4)        ; Use "good" quality during INOUT/PRINT
        beq.s   io_sample_pixels
        move.l  qthg_src_x(a4),d6
        add.l   qthg_x_ratio(a4),d6
        addi.l  #127,d6
        lsr.l   #8,d6                   ; src_x + step
        move.l  qthg_src_y(a4),d7
        add.l   qthg_y_ratio(a4),d7
        addi.l  #127,d7
        lsr.l   #8,d7                   ; src_y + step
        tst.w   qthg_rotate(a4)         ; Exchange X/Y during INOUT or PRINT
        beq.s   io_check_src_x
        exg     d6,d7

io_check_src_x:                         
        cmp.l   d0,d6
        bpl.s   io_check_src_y
        exg     d0,d6

io_check_src_y:                         
        cmp.l   d1,d7
        bpl.s   io_src_x_pixels
        exg     d1,d7

io_src_x_pixels:                        
        sub.l   d0,d6                   ; round(src_x + step) - round(src_x) = pixels span in src
        bne.s   io_src_y_pixels
        moveq   #1,d6                   ; Sample at least one pixel...

io_src_y_pixels:                        
        sub.l   d1,d7                   ; round(src_y + step) - round(src_y) = pixel span in src
        bne.s   io_sample_pixels
        moveq   #1,d7                   ; Sample at least one pixel...

io_sample_pixels:                       
        bsr     sample_pixel            ; Calc mean of pixels, d0=x, d1=y, d4=img width, d6=s_width, d7=s_height, a0=img base
        movem.l (sp)+,d6-d7             ; x/y counter
        bsr     paint_pixel             ; d3 = colour 0..3
        addq.l  #1,qthg_dst_x(a4)
        move.l  qthg_x_ratio(a4),d0
        add.l   d0,qthg_src_x(a4)
        dbf     d7,io_pixels_loop
        move.l  (sp)+,d7
        addq.l  #1,qthg_dst_y(a4)
        move.l  qthg_y_ratio(a4),d0
        add.l   d0,qthg_src_y(a4)
        dbf     d6,io_line_loop

io_ret:                                 
        moveq   #0,d0
        movem.l (sp)+,d3-d7/a0/a2-a6
        rts

; =============== S U B R O U T I N E =======================================
; HC_PARA cancel$,start$,space1$,space24$,space30$

hc_para:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtstr,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   hc_para_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #5,d3
        bne.s   hc_para_ret
        lea     qthg_prt_can(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        lea     qthg_ptr_start(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        lea     qthg_prt_space1(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        lea     qthg_ptr_space24(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        lea     qthg_prt_space30(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        moveq   #0,d0

hc_para_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; HC_DEV dev$

hc_dev:                                 
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtstr,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   hc_dev_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #1,d3
        bne.s   hc_dev_ret
        lea     qthg_ptr_dev(a4),a0
        bsr     copy_string             ; Copy (a6,a1.l) string to (a0)
        moveq   #0,d0

hc_dev_ret:                             
        rts

; =============== S U B R O U T I N E =======================================
; HC_RESO hor,ver,type,colour

hc_reso:                                
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne.s   hc_reso_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #4,d3
        bne.s   hc_reso_ret
        move.w  (a6,a1.l),qthg_prt_dpi_hor(a4)
        move.w  2(a6,a1.l),qthg_prt_dpi_ver(a4)
        move.w  4(a6,a1.l),qthg_prt_type(a4) ; 1 = 9-pin, 3 = 24-pin, 4 = laser
        move.w  6(a6,a1.l),qthg_prt_colour(a4)
        moveq   #0,d0

hc_reso_ret:                            
        rts

; =============== S U B R O U T I N E =======================================
; HC_MULTI x1,y1,x2,y2,loops - Same as HC_DO, but leave multitasking enabled

hc_multi:                               
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        bra.s   hc_print

; =============== S U B R O U T I N E =======================================
; HC_DO x1,y1,x2,y2,loops

hc_do:                                  
        bsr     get_qdesign_thing       ; Get QDesign thing in A4
        trap    #0
        ori.w   #$2700,sr

hc_print:                               
        move.w  qthg_prt_dpi_ver(a4),qthg_ver_cnt(a4)
        subq.w  #1,qthg_ver_cnt(a4)
        movea.w sb.gtint,a0    
        jsr     (a0)
        tst.w   d0
        bne     ptr_ret
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        cmpi.w  #5,d3                   ; 5 parameters
        bne     ptr_ret
        moveq   #8,d5                   ; Fixed point shift
        moveq   #0,d0
        move.w  4(a6,a1.l),d0           ; x2
        sub.w   (a6,a1.l),d0            ; x2-x1 = width
        ext.l   d0
        asl.l   d5,d0                   ; *256
        move.w  qthg_prt_dpi_hor(a4),d1
        subq.w  #1,d1
        divs.w  d1,d0
        ext.l   d0
        move.l  d0,qthg_x_ratio(a4)
        moveq   #0,d0
        move.w  (a6,a1.l),d0            ; x1
        lsl.l   d5,d0                   ; *256
        move.l  d0,qthg_sx1(a4)
        move.l  d0,qthg_src_x(a4)
        move.w  6(a6,a1.l),d0           ; y2
        sub.w   2(a6,a1.l),d0           ; y2-y1 = height
        ext.l   d0
        asl.l   d5,d0                   ; *256
        move.w  qthg_prt_dpi_ver(a4),d1
        subq.w  #1,d1
        divs.w  d1,d0
        ext.l   d0
        move.l  d0,qthg_y_ratio(a4)
        moveq   #0,d0
        move.w  2(a6,a1.l),d0           ; y1
        lsl.l   d5,d0                   ; *256
        move.l  d0,qthg_sy1(a4)
        move.l  d0,qthg_src_y(a4)
        move.w  8(a6,a1.l),qthg_prt_loops(a4) ; loops
        movea.l qthg_img_base(a4),a3
        move.l  qthg_img_llen_w(a4),d4
        tst.w   qthg_mono_mode(a4)
        beq.s   prt_mode4
        lsl.l   #4,d4                   ; *16
        bra.s   prt_prepare
; ---------------------------------------------------------------------------

prt_mode4:                              
        lsl.l   #3,d4                   ; *8

prt_prepare:                            
        movem.l d4/a3,qthg_workspace(a4)
        moveq   #ioa.open,d0            ; OPEN IOSS channel
        moveq   #-1,d1
        moveq   #ioa.kexc,d3            ; Key for EXClusive use (read/write)
        lea     qthg_ptr_dev(a4),a0
        trap    #2
        tst.w   d0
        bne.s   ptr_ret
        move.l  a0,qthg_prt_chan(a4)
        lea     qthg_buffer(a4),a0
        move.l  a0,qthg_buffer_ptr(a4)
        lea     qthg_prt_can(a4),a1
        bsr     prt_string_a1
        bne.s   prt_close
        moveq   #sms.info,d0            ; get INFOrmation on SMS
        trap    #1
        movea.l a0,a5                   ; SysVars

prt_loop:                               
        bsr     check_escape
        beq.s   prt_end
        bsr.s   prt_clear_buffer
        bsr.s   prt_one_inch
        bsr     prt_output_pattern
        beq.s   prt_loop

prt_end:                                
        lea     qthg_prt_space30(a4),a1
        bsr     prt_string_a1

prt_close:                              
        move.l  d0,-(sp)
        moveq   #ioa.clos,d0            ; CLOSe IOSS channel
        movea.l qthg_prt_chan(a4),a0
        trap    #2
        move.l  (sp)+,d0

ptr_ret:                                
        trap    #0
        move    #0,sr
        rts

; =============== S U B R O U T I N E =======================================

prt_clear_buffer:                       
        clr.w   qthg_over_mode_copy(a4)
        move.w  qthg_prt_dpi_hor(a4),d0
        mulu.w  qthg_prt_type(a4),d0    ; 1 = 9-pin, 3 = 24-pin, 4 = laser
        subq.w  #1,d0
        movea.l qthg_buffer_ptr(a4),a0

prt_clear_buffer_loop:                  
        clr.b   (a0)+
        dbf     d0,prt_clear_buffer_loop
        rts

; =============== S U B R O U T I N E =======================================

prt_one_inch:                           
        tst.w   qthg_ver_cnt(a4)
        bmi     prt_check_bit_set
        st      qthg_over_mode_copy(a4)
        moveq   #8,d7
        mulu.w  qthg_prt_type(a4),d7    ; 8 for 9-pin printers, 24 for 24-pin printers and 32 for lasers
        moveq   #0,d5
        move.w  qthg_prt_type(a4),d5    ; 1 = 9-pin, 3 = 24-pin, 4 = laser

prt_pins_loop:                          
        move.w  qthg_prt_dpi_hor(a4),d6
        subq.w  #1,d6
        movea.l qthg_buffer_ptr(a4),a3
        move.l  qthg_sx1(a4),qthg_src_x(a4)

prt_x_loop:                             
        movem.l qthg_workspace(a4),d4/a0
        move.l  qthg_src_x(a4),d0
        addi.l  #127,d0                 ; +0.5
        lsr.l   #8,d0
        move.l  qthg_src_y(a4),d1
        addi.l  #127,d1                 ; +0.5
        lsr.l   #8,d1
        tst.w   qthg_rotate(a4)         ; Exchange X/Y during INOUT or PRINT
        beq.s   prt_rotate
        exg     d0,d1                   ; d0 = src_x, d1 = src_y

prt_rotate:                             
        movem.l d6-d7,-(sp)
        moveq   #1,d6                   ; Sample per default only 1x1 pixels
        moveq   #1,d7
        tst.w   qthg_hc_good(a4)        ; Use "good" quality during INOUT/PRINT
        beq.s   prt_sample_pixels
        move.l  qthg_src_x(a4),d6
        add.l   qthg_x_ratio(a4),d6
        addi.l  #127,d6                 ; +0.5
        lsr.l   #8,d6
        move.l  qthg_src_y(a4),d7
        add.l   qthg_y_ratio(a4),d7
        addi.l  #127,d7                 ; +0.5
        lsr.l   #8,d7
        tst.w   qthg_rotate(a4)         ; Exchange X/Y during INOUT or PRINT
        beq.s   prt_check_src_x
        exg     d6,d7

prt_check_src_x:                        
        cmp.l   d0,d6
        bpl.s   prt_check_src_y
        exg     d0,d6

prt_check_src_y:                        
        cmp.l   d1,d7
        bpl.s   prt_src_x_pixels
        exg     d1,d7

prt_src_x_pixels:                       
        sub.l   d0,d6
        bne.s   prt_src_y_pixels
        moveq   #1,d6

prt_src_y_pixels:                       
        sub.l   d1,d7
        bne.s   prt_sample_pixels
        moveq   #1,d7

prt_sample_pixels:                      
        bsr     sample_pixel            ; Calc mean of pixels, d0=x, d1=y, d4=img width, d6=s_width, d7=s_height, a0=img base
        movem.l (sp)+,d6-d7
        bsr.s   prt_add_patt            ; d3 = colour, d7 = dot 1..24
        move.l  qthg_x_ratio(a4),d0
        add.l   d0,qthg_src_x(a4)
        dbf     d6,prt_x_loop
        move.l  qthg_y_ratio(a4),d0
        add.l   d0,qthg_src_y(a4)
        subq.w  #1,qthg_ver_cnt(a4)
        subq.w  #1,d7
        tst.w   qthg_ver_cnt(a4)
        bmi.s   prt_check_bit_set
        tst.w   d7
        bne     prt_pins_loop

prt_check_bit_set:                      
        moveq   #0,d7
        movea.l qthg_buffer_ptr(a4),a0
        move.w  qthg_prt_dpi_hor(a4),d6
        mulu.w  qthg_prt_type(a4),d6    ; 1 = 9-pin, 3 = 24-pin, 4 = laser
        subq.w  #1,d6

prt_check_bit_set_loop:                 
        or.b    (a0)+,d7
        bne.s   prt_ret
        dbf     d6,prt_check_bit_set_loop

prt_ret:                                
        rts

; =============== S U B R O U T I N E =======================================
; d3 = colour, d7 = dot 1..24

prt_add_patt:                           
        andi.w  #$FF,d3
        tst.b   d3
        beq.s   prt_patt_ret
        cmpi.b  #3,d3
        beq.s   prt_patt_set            ; White
        eori.b  #3,d3
        cmpi.w  #9,qthg_prt_colour(a4)
        bne.s   prt_do_rand
        bsr.s   prt_get_patt_bit
        bra.s   prt_patt_check_bit
; ---------------------------------------------------------------------------

prt_do_rand:                            
        bsr.s   prt_rand

prt_patt_check_bit:                     
        tst.b   d3
        beq.s   prt_patt_set
        adda.l  d5,a3
        rts
; ---------------------------------------------------------------------------

prt_patt_set:                           
        cmpi.w  #1,d5
        beq.s   prt_set_buffer_bit
        cmpi.w  #16,d7
        ble.s   prt_patt_set_0_16
        subi.w  #17,d7
        bset    d7,(a3)
        addi.w  #17,d7
        bra.s   prt_patt_ret
; ---------------------------------------------------------------------------

prt_patt_set_0_16:                      
        cmpi.w  #8,d7
        ble.s   prt_patt_set_0_8
        subi.w  #9,d7
        bset    d7,1(a3)
        addi.w  #9,d7
        bra.s   prt_patt_ret
; ---------------------------------------------------------------------------

prt_patt_set_0_8:                       
        subq.w  #1,d7
        bset    d7,2(a3)
        addq.w  #1,d7

prt_patt_ret:                           
        adda.l  d5,a3
        rts
; ---------------------------------------------------------------------------

prt_set_buffer_bit:                     
        subq.w  #1,d7
        bset    d7,(a3)
        addq.w  #1,d7
        adda.l  d5,a3
        rts

; =============== S U B R O U T I N E =======================================

prt_rand:                               
        mulu.w  qthg_prt_colour(a4),d3
        moveq   #1,d0
        or.l    sb_rand(a6),d0          ; random number
        move.l  d0,d1
        mulu.w  #355,d0
        swap    d1
        mulu.w  #355,d1
        swap    d1
        clr.w   d1
        add.l   d1,d0                   ; sb_rand * 355
        move.l  d0,sb_rand(a6)          ; random number
        swap    d0
        mulu.w  d0,d3
        swap    d3
        rts

; =============== S U B R O U T I N E =======================================

prt_get_patt_bit:                       
        cmpi.b  #1,d3
        beq.s   prt_get_patt_red
        move.w  qthg_prt_patt1(a4),d3
        rol.w   #1,d3
        move.w  d3,qthg_prt_patt1(a4)
        andi.w  #1,d3
        rts
; ---------------------------------------------------------------------------

prt_get_patt_red:                       
        move.w  qthg_prt_patt2(a4),d3
        rol.w   #1,d3
        move.w  d3,qthg_prt_patt2(a4)
        andi.w  #1,d3
        rts

; =============== S U B R O U T I N E =======================================

prt_output_pattern:                     
        tst.w   qthg_over_mode_copy(a4)
        beq.s   prt_err
        tst.b   d7
        beq.s   ptr_out_no_bit_set
        moveq   #0,d0
        move.w  qthg_prt_loops(a4),d7   ; loops

prt_loops_loop:                         
        lea     qthg_ptr_start(a4),a1
        bsr.s   prt_string_a1
        bne.s   prt_err
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        movea.l qthg_prt_chan(a4),a0
        moveq   #-1,d3
        move.b  qthg_prt_dpi_hor+1(a4),d1
        trap    #3
        tst.w   d0
        bne.s   prt_err
        moveq   #iob.sbyt,d0            ; Send BYTe to output
        move.b  qthg_prt_dpi_hor(a4),d1
        moveq   #-1,d3
        trap    #3
        tst.w   d0
        bne.s   prt_err
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        move.w  qthg_prt_dpi_hor(a4),d2
        mulu.w  qthg_prt_type(a4),d2    ; 1 = 9-pin, 3 = 24-pin, 4 = laser
        moveq   #-1,d3
        movea.l qthg_prt_chan(a4),a0
        movea.l qthg_buffer_ptr(a4),a1
        trap    #3                      ; Print buffer contents
        tst.w   d0
        bne.s   prt_err
        tst.w   d7
        beq.s   prt_space24
        lea     qthg_prt_space1(a4),a1
        bsr.s   prt_string_a1
        bne.s   prt_err
        subq.w  #1,d7
        bra.s   prt_loops_loop
; ---------------------------------------------------------------------------

prt_space24:                            
        lea     qthg_ptr_space24(a4),a1
        bsr.s   prt_string_a1
        bne.s   prt_err
        moveq   #0,d1
        tst.w   d1
        rts
; ---------------------------------------------------------------------------

prt_err:                                
        moveq   #-1,d1
        tst.w   d1
        rts
; ---------------------------------------------------------------------------

ptr_out_no_bit_set:                     
        move.w  qthg_prt_loops(a4),d7

prt_out_space_loop:                     
        tst.w   d7
        beq.s   ptr_out_space_end
        lea     qthg_prt_space1(a4),a1
        bsr.s   prt_string_a1
        bne.s   prt_err
        subq.w  #1,d7
        bra.s   prt_out_space_loop
; ---------------------------------------------------------------------------

ptr_out_space_end:                      
        lea     qthg_ptr_space24(a4),a1
        bsr.s   prt_string_a1
        bne.s   prt_err
        rts

; =============== S U B R O U T I N E =======================================

prt_string_a1:                          
        movea.l qthg_prt_chan(a4),a0
        moveq   #iob.smul,d0            ; Send MULtiple bytes
        move.w  (a1)+,d2
        moveq   #-1,d3
        trap    #3
        tst.w   d0
        rts

; =============== S U B R O U T I N E =======================================
; Copy (a6,a1.l) string to (a0)

copy_string:                            
        move.w  (a6,a1.l),d7
        addq.w  #1,d7

copy_string_loop:                       
        move.b  (a6,a1.l),(a0)+
        addq.l  #1,a1
        dbf     d7,copy_string_loop
        move.l  a1,d0
        addq.l  #1,d0
        bclr    #0,d0
        movea.l d0,a1
        rts

; =============== S U B R O U T I N E =======================================

check_escape:                           
        movem.l d0-d1/d4-d5/d7/a0/a2-a3,-(sp)
        lea     hdop_keyrow(pc),a3
        moveq   #sms.hdop,d0            ; do a Hardware Dependent OPeration
        trap    #1
        btst    #3,d1
        bne.s   check_escape_pressed
        movem.l (sp)+,d0-d1/d4-d5/d7/a0/a2-a3
        moveq   #-1,d2
        tst.w   d2
        rts
; ---------------------------------------------------------------------------

check_escape_pressed:                   
        movem.l (sp)+,d0-d1/d4-d5/d7/a0/a2-a3
        moveq   #0,d2
        tst.w   d2
        rts
; ---------------------------------------------------------------------------
hdop_keyrow:dc.b 9,1,0,0,0,0,1,2        
; ---------------------------------------------------------------------------
brushpatt_ipar:                         
        moveq   #err.ipar,d0            ; Invalid PARameter (c.f. err.orng)
        rts

; =============== S U B R O U T I N E =======================================
; addr = BRUSH(0..12) - Return one of the inbuilt brushes

brush:                                  
        movea.w sb.gtint,a2    
        jsr     (a2)
        subq.w  #1,d3                   ; Exactly one parameter
        bne.s   brushpatt_ipar
        move.w  (a6,a1.l),d1
        addq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer
        add.w   d1,d1
        blt.s   brushpatt_ipar
        cmpi.w  #24,d1
        bgt.s   brushpatt_ipar
        lea     brush_table(pc),a0
        adda.w  (a0,d1.w),a0
        move.l  a0,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------
brush_table:dc.w brush0-*               
        dc.w brush1-brush_table
        dc.w brush2-brush_table
        dc.w brush3-brush_table
        dc.w brush4-brush_table
        dc.w brush5-brush_table
        dc.w brush6-brush_table
        dc.w brush7-brush_table
        dc.w brush8-brush_table
        dc.w brush9-brush_table
        dc.w brush10-brush_table
        dc.w brush11-brush_table
        dc.w brush12-brush_table

; =============== S U B R O U T I N E =======================================
; addr = MUSTER(0..18) - Return one of the inbuilt patterns

muster:                                 
        movea.w sb.gtint,a2    
        jsr     (a2)
        subq.w  #1,d3
        bne.s   brushpatt_ipar
        move.w  (a6,a1.l),d1
        addq.l  #2,sb_arthp(a6)         ; arithmetic stack pointer
        add.w   d1,d1
        blt.s   brushpatt_ipar
        cmpi.w  #36,d1
        bgt.s   brushpatt_ipar
        lea     pattern_table(pc),a0
        adda.w  (a0,d1.w),a0
        move.l  a0,d5
        bra     ret_d5                  ; Return integer in d5
; ---------------------------------------------------------------------------
pattern_table:dc.w patt0-*              
        dc.w patt1-pattern_table
        dc.w patt2-pattern_table
        dc.w patt3-pattern_table
        dc.w patt4-pattern_table
        dc.w patt5-pattern_table
        dc.w patt6-pattern_table
        dc.w patt7-pattern_table
        dc.w patt8-pattern_table
        dc.w patt9-pattern_table
        dc.w patt10-pattern_table
        dc.w patt11-pattern_table
        dc.w patt12-pattern_table
        dc.w patt13-pattern_table
        dc.w patt14-pattern_table
        dc.w patt15-pattern_table
        dc.w patt16-pattern_table
        dc.w patt17-pattern_table
        dc.w patt18-pattern_table
brush0: dc.w $100,0,1,1,0,0,0,$C,0,$C,0,0,0,0,$8080,0 
brush1: dc.w $100,0,2,2,0,0,0,$C,0,$10,0,0,0,0,0,0,$C0C0,0,$C0C0,0 
brush2: dc.w $100,0,3,3,1,1,0,$C,0,$14,0,0,0,0,0,0,0,0,$E0E0,0,$E0E0,0 
        dc.w $E0E0,0
brush3: dc.w $100,0,6,5,2,2,0,$C,0,$1C,0,0,0,0,0,0,0,0,0,0,0,0,$FCFC,0 
        dc.w $FCFC,0,$FCFC,0,$FCFC,0,$FCFC,0
brush4: dc.w $100,0,$C,$A,5,4,0,$C,0,$30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
        dc.w 0,0,0,0,0,0,0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0
        dc.w $FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0
        dc.w $FFFF,$F0F0
brush5: dc.w $100,0,7,6,3,2,0,$C,0,$20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$3838 
        dc.w 0,$7C7C,0,$FEFE,0,$FEFE,0,$7C7C,0,$3838,0
brush6: dc.w $100,0,$C,$B,5,5,0,$C,0,$34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
        dc.w 0,0,0,0,0,0,0,0,0,$1F1F,$8080,$7F7F,$E0E0,$7F7F,$E0E0,$FFFF
        dc.w $F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$FFFF,$F0F0,$7F7F
        dc.w $E0E0,$7F7F,$E0E0,$1F1F,$8080
brush7: dc.w $100,0,$A,9,4,4,0,$C,0,$2C,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
        dc.w 0,0,0,0,0,$C0C0,$C0C0,$6161,$8080,$3333,0,$1E1E,0,$C0C,0
        dc.w $1E1E,0,$3333,0,$6161,$8080,$C0C0,$C0C0
brush8: dc.w $100,0,$A,8,4,3,0,$C,0,$28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
        dc.w 0,0,0,0,$4040,$101,$8080,$303,0,$606,0,$8C8C,0,$7878,0,$3030
        dc.w 0,$1010,0
brush9: dc.w $100,0,9,8,2,4,0,$C,0,$28,0,0,$101,$8080,$303,0,$606,0,$C0C 
        dc.w 0,$1818,0,$3030,0,$6060,0,$C0C0,0,$101,$8080,$303,0,$606
        dc.w 0,$C0C,0,$1818,0,$3030,0,$6060,0,$C0C0,0
brush10:dc.w $100,0,8,9,2,4,0,$C,0,$2C,0,0,$8080,0,$C0C0,0,$6060,0,$3030 
        dc.w 0,$1818,0,$C0C,0,$606,0,$303,0,$101,0,$8080,0,$C0C0,0,$6060
        dc.w 0,$3030,0,$1818,0,$C0C,0,$606,0,$303,0,$101,0
brush11:dc.w $100,0,$B,1,5,$FFFF,0,$C,0,$C,0,0,$FFFF,$E0E0,$FFFF,$E0E0 
brush12:dc.w $100,0,1,$A,0,4,0,$C,0,$30,0,0,$8080,0,$8080,0,$8080,0,$8080 
        dc.w 0,$8080,0,$8080,0,$8080,0,$8080,0,$8080,0,$8080,0,$8080,0
        dc.w $8080,0,$8080,0,$8080,0,$8080,0,$8080,0,$8080,0,$8080,0,$8080
        dc.w 0,$8080,0
patt0:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,0,0,0,0,$FFFF,$FFFF,$FFFF 
        dc.w $FFFF
patt1:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$FF,$FF,$FF,$FF,$FFFF,$FFFF 
        dc.w $FFFF,$FFFF
patt2:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$FF00,$FF00,$FF00,$FF00,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt3:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt4:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AA,$AA,$55,$55,$FFFF,$FFFF 
        dc.w $FFFF,$FFFF
patt5:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AA00,$AA00,$5500,$5500,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt6:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AA55,$AA55,$55AA,$55AA,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt7:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AAAA,$AAAA,$5555,$5555,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt8:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AAFF,$AAFF,$55FF,$55FF,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt9:  dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$FFAA,$FFAA,$FF55,$FF55,$FFFF 
        dc.w $FFFF,$FFFF,$FFFF
patt10: dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,0,0,0,0,$AAAA,$AAAA,$5555 
        dc.w $5555
patt11: dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AA,$AA,$55,$55,$AAAA,$AAAA 
        dc.w $5555,$5555
patt12: dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AA00,$AA00,$5500,$5500,$AAAA 
        dc.w $AAAA,$5555,$5555
patt13: dc.w $100,0,$10,2,0,0,0,$C,0,$10,0,0,$AAAA,$AAAA,$5555,$5555,$AAAA 
        dc.w $AAAA,$5555,$5555
patt14: dc.w $100,0,$10,8,0,0,0,$C,0,$28,0,0,$AFF,$AFF,$5FF,$5FF,$AFF 
        dc.w $AFF,$5FF,$5FF,$AFFF,$AFFF,$5FFF,$5FFF,$AFFF,$AFFF,$5FFF
        dc.w $5FFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
        dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
patt15: dc.w $100,0,$10,8,0,0,0,$C,0,$28,0,0,$FFFF,$FFFF,$80FF,$80FF,$80FF 
        dc.w $80FF,$80FF,$80FF,$FFFF,$FFFF,$8FF,$8FF,$8FF,$8FF,$8FF,$8FF
        dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
        dc.w $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
patt16: dc.w $100,0,$10,$10,0,0,0,$C,0,$48,0,0,$303,$E0E0,$707,$D0D0,$F0F 
        dc.w $B8B8,$1F1F,$7C7C,$3E3E,$3E3E,$7C7C,$1F1F,$B8B8,$F0F,$D0D0
        dc.w $707,$E0E0,$303,$F0F0,$505,$F8F8,$E0E,$7C7C,$1F1F,$3E3E,$3E3E
        dc.w $1F1F,$7C7C,$E0E,$F8F8,$505,$F0F0,$707,$F0F0,$F0F,$F8F8,$1F1F
        dc.w $FCFC,$3F3F,$FEFE,$7F7F,$7F7F,$FEFE,$3F3F,$FCFC,$1F1F,$F8F8
        dc.w $F0F,$F0F0,$707,$F8F8,$F0F,$FCFC,$1F1F,$FEFE,$3F3F,$7F7F
        dc.w $7F7F,$3F3F,$FEFE,$1F1F,$FCFC,$F0F,$F8F8
patt17: dc.w $100,0,$10,8,0,0,0,$C,0,$28,0,0,$C0C,$C0C,$1A1A,$1A1A,$3333 
        dc.w $3333,$A1A1,$A1A1,$C0C0,$C0C0,$6161,$6161,$3333,$3333,$1616
        dc.w $1616,$1E1E,$1E1E,$3F3F,$3F3F,$FFFF,$FFFF,$F3F3,$F3F3,$E1E1
        dc.w $E1E1,$F3F3,$F3F3,$FFFF,$FFFF,$3F3F,$3F3F
patt18: dc.w $100,0,$10,8,0,0,0,$C,0,$28,0,0,$9200,$2800,$9500,$800,$8500 
        dc.w $4000,$1400,$4200,$5100,$4800,$5000,$800,$1200,$8900,$8200
        dc.w $4100,$9292,$2828,$9595,$808,$8585,$4040,$1414,$4242,$5151
        dc.w $4848,$5050,$808,$1212,$8989,$8282,$4141,0,0


        END
